<?php  // $Id: block_admin_bookmarks.php,v 1.12.2.2 2007/03/14 16:35:10 poltawski Exp $

// seems to work...
// maybe I should add some pretty icons?
// or possibly add the ability to custom-name things?

class block_admin_bookmarks extends block_base {

    function init() {
        $this->title = get_string('adminbookmarks');
        $this->version = 2006090300;
    }

    function applicable_formats() {
        return array('all' => true);
    }

    function preferred_width() {
        return 210;
    }

    function create_item($visiblename,$link,$icon) {
        $this->tempcontent .= '<a href="' . $link . '"><img src="' . $icon . '" border="0" alt="[item]" /> ' . $visiblename . '</a><br />' . "\n";
    }

    function get_content() {

        global $CFG, $USER, $PAGE;

        require_once($CFG->libdir.'/adminlib.php');
        $adminroot = admin_get_root();

        if ($this->content !== NULL) {
            return $this->content;
        }

        $this->content = new stdClass;
        $this->content->text = '';
        if (isset($USER->preference['admin_bookmarks'])) {
            $bookmarks = explode(',',$USER->preference['admin_bookmarks']);
            // hmm... just a liiitle (potentially) processor-intensive
            // (recall that $adminroot->locate is a huge recursive call... and we're calling it repeatedly here

            /// Accessibility: markup as a list.
            $this->content->text .= '<ol class="list">'."\n";

            foreach($bookmarks as $bookmark) {
                $temp = $adminroot->locate($bookmark);
                if (is_a($temp, 'admin_settingpage')) {
                    $this->content->text .= '<li><a href="' . $CFG->wwwroot . '/' . $CFG->admin . '/settings.php?section=' . $bookmark . '">' . $temp->visiblename . "</a></li>\n";
                } elseif (is_a($temp, 'admin_externalpage')) {
                    $this->content->text .= '<li><a href="' . $temp->url . '">' . $temp->visiblename . "</a></li>\n";
                }
            }
            $this->content->text .= "</ol>\n";
        } else {
            $bookmarks = array();
        }

	if(isset($PAGE->section) and $PAGE->section == 'search'){
	  // the search page can't be properly bookmarked at present
	  $this->content->footer = '';
	}elseif (($section = (isset($PAGE->section) ? $PAGE->section : '')) && (in_array($section, $bookmarks))) {
            $this->content->footer = '<a href="' . $CFG->wwwroot . '/blocks/admin_bookmarks/delete.php?section=' . $section . '&amp;sesskey='.sesskey().'">' . get_string('unbookmarkthispage','admin') . '</a>';
        } elseif ($section = (isset($PAGE->section) ? $PAGE->section : '')) {
            $this->content->footer = '<a href="' . $CFG->wwwroot . '/blocks/admin_bookmarks/create.php?section=' . $section . '&amp;sesskey='.sesskey().'">' . get_string('bookmarkthispage','admin') . '</a>';
        } else {
            $this->content->footer = '';
        }

        return $this->content;

    }
}

?>
