-- MySQL dump 10.10
--
-- Host: localhost    Database: moodle
-- ------------------------------------------------------
-- Server version	5.0.18

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES latin1 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `moodle`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `moodle` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `moodle`;

--
-- Table structure for table `adodb_logsql`
--

DROP TABLE IF EXISTS `adodb_logsql`;
CREATE TABLE `adodb_logsql` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `created` datetime NOT NULL,
  `sql0` varchar(250) NOT NULL default '',
  `sql1` text,
  `params` text,
  `tracer` text,
  `timer` decimal(16,6) NOT NULL default '0.000000',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to save some logs from ADOdb';

--
-- Dumping data for table `adodb_logsql`
--


/*!40000 ALTER TABLE `adodb_logsql` DISABLE KEYS */;
LOCK TABLES `adodb_logsql` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `adodb_logsql` ENABLE KEYS */;

--
-- Table structure for table `mdl_assignment`
--

DROP TABLE IF EXISTS `mdl_assignment`;
CREATE TABLE `mdl_assignment` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `format` smallint(4) unsigned NOT NULL default '0',
  `assignmenttype` varchar(50) NOT NULL default '',
  `resubmit` tinyint(2) unsigned NOT NULL default '0',
  `preventlate` tinyint(2) unsigned NOT NULL default '0',
  `emailteachers` tinyint(2) unsigned NOT NULL default '0',
  `var1` bigint(10) default '0',
  `var2` bigint(10) default '0',
  `var3` bigint(10) default '0',
  `var4` bigint(10) default '0',
  `var5` bigint(10) default '0',
  `maxbytes` bigint(10) unsigned NOT NULL default '100000',
  `timedue` bigint(10) unsigned NOT NULL default '0',
  `timeavailable` bigint(10) unsigned NOT NULL default '0',
  `grade` bigint(10) NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_assi_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines assignments';

--
-- Dumping data for table `mdl_assignment`
--


/*!40000 ALTER TABLE `mdl_assignment` DISABLE KEYS */;
LOCK TABLES `mdl_assignment` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_assignment` ENABLE KEYS */;

--
-- Table structure for table `mdl_assignment_submissions`
--

DROP TABLE IF EXISTS `mdl_assignment_submissions`;
CREATE TABLE `mdl_assignment_submissions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `assignment` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `numfiles` bigint(10) unsigned NOT NULL default '0',
  `data1` text NOT NULL,
  `data2` text NOT NULL,
  `grade` bigint(11) NOT NULL default '0',
  `submissioncomment` text NOT NULL,
  `format` smallint(4) unsigned NOT NULL default '0',
  `teacher` bigint(10) unsigned NOT NULL default '0',
  `timemarked` bigint(10) unsigned NOT NULL default '0',
  `mailed` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_assisubm_use_ix` (`userid`),
  KEY `mdl_assisubm_mai_ix` (`mailed`),
  KEY `mdl_assisubm_tim_ix` (`timemarked`),
  KEY `mdl_assisubm_ass_ix` (`assignment`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about submitted assignments';

--
-- Dumping data for table `mdl_assignment_submissions`
--


/*!40000 ALTER TABLE `mdl_assignment_submissions` DISABLE KEYS */;
LOCK TABLES `mdl_assignment_submissions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_assignment_submissions` ENABLE KEYS */;

--
-- Table structure for table `mdl_backup_config`
--

DROP TABLE IF EXISTS `mdl_backup_config`;
CREATE TABLE `mdl_backup_config` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_backconf_nam_uix` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To store backup configuration variables';

--
-- Dumping data for table `mdl_backup_config`
--


/*!40000 ALTER TABLE `mdl_backup_config` DISABLE KEYS */;
LOCK TABLES `mdl_backup_config` WRITE;
INSERT INTO `mdl_backup_config` VALUES (1,'backup_sche_modules','1'),
(2,'backup_sche_withuserdata','1'),
(3,'backup_sche_metacourse','1'),
(4,'backup_sche_users','0'),
(5,'backup_sche_logs','1'),
(6,'backup_sche_userfiles','1'),
(7,'backup_sche_coursefiles','1'),
(8,'backup_sche_messages','1'),
(9,'backup_sche_keep','5'),
(10,'backup_sche_active','1'),
(11,'backup_sche_weekdays','0100000'),
(12,'backup_sche_hour','0'),
(13,'backup_sche_minute','0'),
(14,'backup_sche_destination','');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_backup_config` ENABLE KEYS */;

--
-- Table structure for table `mdl_backup_courses`
--

DROP TABLE IF EXISTS `mdl_backup_courses`;
CREATE TABLE `mdl_backup_courses` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `laststarttime` bigint(10) unsigned NOT NULL default '0',
  `lastendtime` bigint(10) unsigned NOT NULL default '0',
  `laststatus` varchar(1) NOT NULL default '0',
  `nextstarttime` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_backcour_cou_uix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To store every course backup status';

--
-- Dumping data for table `mdl_backup_courses`
--


/*!40000 ALTER TABLE `mdl_backup_courses` DISABLE KEYS */;
LOCK TABLES `mdl_backup_courses` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_backup_courses` ENABLE KEYS */;

--
-- Table structure for table `mdl_backup_files`
--

DROP TABLE IF EXISTS `mdl_backup_files`;
CREATE TABLE `mdl_backup_files` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `backup_code` bigint(10) unsigned NOT NULL default '0',
  `file_type` varchar(10) NOT NULL default '',
  `path` varchar(255) NOT NULL default '',
  `old_id` bigint(10) unsigned NOT NULL default '0',
  `new_id` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_backfile_bacfilpat_uix` (`backup_code`,`file_type`,`path`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To store and recode ids to user and course files';

--
-- Dumping data for table `mdl_backup_files`
--


/*!40000 ALTER TABLE `mdl_backup_files` DISABLE KEYS */;
LOCK TABLES `mdl_backup_files` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_backup_files` ENABLE KEYS */;

--
-- Table structure for table `mdl_backup_ids`
--

DROP TABLE IF EXISTS `mdl_backup_ids`;
CREATE TABLE `mdl_backup_ids` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `backup_code` bigint(12) unsigned NOT NULL default '0',
  `table_name` varchar(30) NOT NULL default '',
  `old_id` bigint(10) unsigned NOT NULL default '0',
  `new_id` bigint(10) unsigned NOT NULL default '0',
  `info` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_backids_bactabold_uix` (`backup_code`,`table_name`,`old_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To store and convert ids in backup/restore';

--
-- Dumping data for table `mdl_backup_ids`
--


/*!40000 ALTER TABLE `mdl_backup_ids` DISABLE KEYS */;
LOCK TABLES `mdl_backup_ids` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_backup_ids` ENABLE KEYS */;

--
-- Table structure for table `mdl_backup_log`
--

DROP TABLE IF EXISTS `mdl_backup_log`;
CREATE TABLE `mdl_backup_log` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `time` bigint(10) unsigned NOT NULL default '0',
  `laststarttime` bigint(10) unsigned NOT NULL default '0',
  `info` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_backlog_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To store every course backup log info';

--
-- Dumping data for table `mdl_backup_log`
--


/*!40000 ALTER TABLE `mdl_backup_log` DISABLE KEYS */;
LOCK TABLES `mdl_backup_log` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_backup_log` ENABLE KEYS */;

--
-- Table structure for table `mdl_block`
--

DROP TABLE IF EXISTS `mdl_block`;
CREATE TABLE `mdl_block` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(40) NOT NULL default '',
  `version` bigint(10) unsigned NOT NULL default '0',
  `cron` bigint(10) unsigned NOT NULL default '0',
  `lastcron` bigint(10) unsigned NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '1',
  `multiple` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to store installed blocks';

--
-- Dumping data for table `mdl_block`
--


/*!40000 ALTER TABLE `mdl_block` DISABLE KEYS */;
LOCK TABLES `mdl_block` WRITE;
INSERT INTO `mdl_block` VALUES (1,'activity_modules',2006011300,0,0,1,0),
(2,'admin',2004081200,0,0,1,0),
(3,'admin_bookmarks',2006090300,0,0,1,0),
(4,'admin_tree',2006090300,0,0,1,0),
(5,'blog_menu',2004112000,0,0,1,0),
(6,'blog_tags',2006032000,0,0,1,1),
(7,'calendar_month',2004081200,0,0,1,0),
(8,'calendar_upcoming',2004052600,0,0,1,0),
(9,'course_list',2004111600,0,0,1,0),
(10,'course_summary',2004052600,0,0,1,0),
(11,'glossary_random',2005040500,0,0,1,1),
(12,'html',2004123000,0,0,1,1),
(13,'loancalc',2005022100,0,0,1,0),
(14,'login',2004081600,0,0,1,0),
(15,'messages',2004122800,0,0,1,0),
(16,'news_items',2005030800,0,0,1,0),
(17,'online_users',2006030100,0,0,1,0),
(18,'participants',2004052600,0,0,1,0),
(19,'quiz_results',2005082300,0,0,1,1),
(20,'recent_activity',2004042900,0,0,1,0),
(21,'rss_client',2006100101,0,0,1,1),
(22,'search',2006062500,0,0,1,0),
(23,'search_forums',2005030900,0,0,1,0),
(24,'section_links',2004052800,0,0,1,0),
(25,'site_main_menu',2005061300,0,0,1,0),
(26,'social_activities',2004041800,0,0,1,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_block` ENABLE KEYS */;

--
-- Table structure for table `mdl_block_instance`
--

DROP TABLE IF EXISTS `mdl_block_instance`;
CREATE TABLE `mdl_block_instance` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `blockid` bigint(10) unsigned NOT NULL default '0',
  `pageid` bigint(10) unsigned NOT NULL default '0',
  `pagetype` varchar(20) NOT NULL default '',
  `position` varchar(10) NOT NULL default '',
  `weight` smallint(3) NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '0',
  `configdata` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_blocinst_pag_ix` (`pageid`),
  KEY `mdl_blocinst_pag2_ix` (`pagetype`),
  KEY `mdl_blocinst_blo_ix` (`blockid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to store block instances in pages';

--
-- Dumping data for table `mdl_block_instance`
--


/*!40000 ALTER TABLE `mdl_block_instance` DISABLE KEYS */;
LOCK TABLES `mdl_block_instance` WRITE;
INSERT INTO `mdl_block_instance` VALUES (1,25,1,'course-view','l',0,1,''),
(2,4,1,'course-view','l',1,1,''),
(3,10,1,'course-view','r',0,1,''),
(4,7,1,'course-view','r',1,1,''),
(5,4,0,'admin','l',0,1,''),
(6,3,0,'admin','l',1,1,''),
(7,18,2,'course-view','l',0,1,''),
(8,1,2,'course-view','l',1,1,''),
(9,23,2,'course-view','l',2,1,''),
(10,2,2,'course-view','l',3,1,''),
(11,9,2,'course-view','l',4,1,''),
(12,16,2,'course-view','r',0,1,''),
(13,8,2,'course-view','r',1,1,''),
(14,20,2,'course-view','r',2,1,'');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_block_instance` ENABLE KEYS */;

--
-- Table structure for table `mdl_block_pinned`
--

DROP TABLE IF EXISTS `mdl_block_pinned`;
CREATE TABLE `mdl_block_pinned` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `blockid` bigint(10) unsigned NOT NULL default '0',
  `pagetype` varchar(20) NOT NULL default '',
  `position` varchar(10) NOT NULL default '',
  `weight` smallint(3) NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '0',
  `configdata` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_blocpinn_pag_ix` (`pagetype`),
  KEY `mdl_blocpinn_blo_ix` (`blockid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to pin blocks';

--
-- Dumping data for table `mdl_block_pinned`
--


/*!40000 ALTER TABLE `mdl_block_pinned` DISABLE KEYS */;
LOCK TABLES `mdl_block_pinned` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_block_pinned` ENABLE KEYS */;

--
-- Table structure for table `mdl_block_rss_client`
--

DROP TABLE IF EXISTS `mdl_block_rss_client`;
CREATE TABLE `mdl_block_rss_client` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `title` text NOT NULL,
  `preferredtitle` varchar(64) NOT NULL default '',
  `description` text NOT NULL,
  `shared` tinyint(2) unsigned NOT NULL default '0',
  `url` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Remote news feed information. Contains the news feed id, the';

--
-- Dumping data for table `mdl_block_rss_client`
--


/*!40000 ALTER TABLE `mdl_block_rss_client` DISABLE KEYS */;
LOCK TABLES `mdl_block_rss_client` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_block_rss_client` ENABLE KEYS */;

--
-- Table structure for table `mdl_blog_tag_instance`
--

DROP TABLE IF EXISTS `mdl_blog_tag_instance`;
CREATE TABLE `mdl_blog_tag_instance` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `entryid` bigint(10) unsigned NOT NULL default '0',
  `tagid` bigint(10) unsigned NOT NULL default '0',
  `groupid` bigint(10) unsigned NOT NULL default '0',
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_blogtaginst_ent_ix` (`entryid`),
  KEY `mdl_blogtaginst_tag_ix` (`tagid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='tag instance for blogs';

--
-- Dumping data for table `mdl_blog_tag_instance`
--


/*!40000 ALTER TABLE `mdl_blog_tag_instance` DISABLE KEYS */;
LOCK TABLES `mdl_blog_tag_instance` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_blog_tag_instance` ENABLE KEYS */;

--
-- Table structure for table `mdl_cache_filters`
--

DROP TABLE IF EXISTS `mdl_cache_filters`;
CREATE TABLE `mdl_cache_filters` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `filter` varchar(32) NOT NULL default '',
  `version` bigint(10) unsigned NOT NULL default '0',
  `md5key` varchar(32) NOT NULL default '',
  `rawtext` text NOT NULL,
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_cachfilt_filmd5_ix` (`filter`,`md5key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='For keeping information about cached data';

--
-- Dumping data for table `mdl_cache_filters`
--


/*!40000 ALTER TABLE `mdl_cache_filters` DISABLE KEYS */;
LOCK TABLES `mdl_cache_filters` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_cache_filters` ENABLE KEYS */;

--
-- Table structure for table `mdl_cache_text`
--

DROP TABLE IF EXISTS `mdl_cache_text`;
CREATE TABLE `mdl_cache_text` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `md5key` varchar(32) NOT NULL default '',
  `formattedtext` longtext NOT NULL,
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_cachtext_md5_ix` (`md5key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='For storing temporary copies of processed texts';

--
-- Dumping data for table `mdl_cache_text`
--


/*!40000 ALTER TABLE `mdl_cache_text` DISABLE KEYS */;
LOCK TABLES `mdl_cache_text` WRITE;
INSERT INTO `mdl_cache_text` VALUES (1,'fccf90e48d18367133a1f1f7c24d81ae','SCHOOLNAME Moodle',1172454188),
(2,'489b99257e999af9ac22d9bbefa9af55','Moodle for beginners.',1172454188),
(3,'dbf4d8902f4bc08bed44fa34590da092','Administrators can usually do anything on the site, in all courses.',1172452851),
(4,'627f298a5fa13e7196b513a84d1b32c7','Course creators can create new courses and teach in them.',1172452851),
(5,'b6f71bb36211bb09d6aece1ccefd58da','Teachers can do anything within a course, including changing the activities and grading students.',1172452851),
(6,'da7f4b52ab4762214d13d65b64e12c39','Non-editing teachers can teach in courses and grade students, but may not alter activities.',1172452851),
(7,'db93b1be0fb24d47be42959facc32289','Students generally have less privileges within a course.',1172452851),
(8,'e7baccd5f49f7685302bdd7c1d62e4fc','Guests have minimal privileges and usually can not enter text anywhere.',1172452851),
(9,'f8c8da02650427652f9441aec1e9398d','Moodle for beginners.',1172454199),
(10,'ce60db57bc8e9cbdac34c2bbc98c95c2','SCHOOLNAME Moodle',1172454199);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_cache_text` ENABLE KEYS */;

--
-- Table structure for table `mdl_capabilities`
--

DROP TABLE IF EXISTS `mdl_capabilities`;
CREATE TABLE `mdl_capabilities` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `captype` varchar(50) NOT NULL default '',
  `contextlevel` bigint(10) unsigned NOT NULL default '0',
  `component` varchar(100) NOT NULL default '',
  `riskbitmask` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_capa_nam_uix` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='this defines all capabilities';

--
-- Dumping data for table `mdl_capabilities`
--


/*!40000 ALTER TABLE `mdl_capabilities` DISABLE KEYS */;
LOCK TABLES `mdl_capabilities` WRITE;
INSERT INTO `mdl_capabilities` VALUES (1,'moodle/site:doanything','admin',10,'moodle',30),
(2,'moodle/legacy:guest','legacy',10,'moodle',0),
(3,'moodle/legacy:student','legacy',10,'moodle',16),
(4,'moodle/legacy:teacher','legacy',10,'moodle',24),
(5,'moodle/legacy:editingteacher','legacy',10,'moodle',28),
(6,'moodle/legacy:coursecreator','legacy',10,'moodle',28),
(7,'moodle/legacy:admin','legacy',10,'moodle',30),
(8,'moodle/site:config','write',10,'moodle',30),
(9,'moodle/site:readallmessages','read',10,'moodle',8),
(10,'moodle/site:approvecourse','write',10,'moodle',4),
(11,'moodle/site:import','write',10,'moodle',28),
(12,'moodle/site:backup','write',10,'moodle',28),
(13,'moodle/site:restore','write',10,'moodle',28),
(14,'moodle/site:manageblocks','write',10,'moodle',20),
(15,'moodle/site:accessallgroups','read',10,'moodle',0),
(16,'moodle/site:viewfullnames','read',10,'moodle',0),
(17,'moodle/site:viewparticipants','read',10,'moodle',0),
(18,'moodle/site:viewreports','read',10,'moodle',8),
(19,'moodle/site:trustcontent','write',10,'moodle',4),
(20,'moodle/site:uploadusers','write',10,'moodle',24),
(21,'moodle/user:create','write',10,'moodle',24),
(22,'moodle/user:delete','write',10,'moodle',8),
(23,'moodle/user:update','write',10,'moodle',24),
(24,'moodle/user:viewdetails','read',10,'moodle',0),
(25,'moodle/user:viewhiddendetails','read',10,'moodle',8),
(26,'moodle/user:viewusergrades','write',50,'moodle',0),
(27,'moodle/user:loginas','write',50,'moodle',30),
(28,'moodle/role:assign','write',10,'moodle',0),
(29,'moodle/role:override','write',10,'moodle',28),
(30,'moodle/role:manage','write',10,'moodle',28),
(31,'moodle/role:unassignself','write',10,'moodle',0),
(32,'moodle/role:viewhiddenassigns','read',10,'moodle',0),
(33,'moodle/role:switchroles','read',10,'moodle',4),
(34,'moodle/category:create','write',40,'moodle',0),
(35,'moodle/category:delete','write',40,'moodle',0),
(36,'moodle/category:update','write',40,'moodle',0),
(37,'moodle/category:visibility','write',40,'moodle',0),
(38,'moodle/course:create','write',50,'moodle',4),
(39,'moodle/course:delete','write',50,'moodle',0),
(40,'moodle/course:update','write',50,'moodle',4),
(41,'moodle/course:view','read',50,'moodle',0),
(42,'moodle/course:bulkmessaging','write',50,'moodle',16),
(43,'moodle/course:viewhiddenuserfields','read',50,'moodle',8),
(44,'moodle/course:viewhiddencourses','read',50,'moodle',0),
(45,'moodle/course:visibility','write',50,'moodle',0),
(46,'moodle/course:managefiles','write',50,'moodle',4),
(47,'moodle/course:manageactivities','write',50,'moodle',4),
(48,'moodle/course:managemetacourse','write',50,'moodle',0),
(49,'moodle/course:activityvisibility','write',50,'moodle',0),
(50,'moodle/course:viewhiddenactivities','write',50,'moodle',0),
(51,'moodle/course:viewparticipants','read',50,'moodle',0),
(52,'moodle/course:viewscales','read',50,'moodle',0),
(53,'moodle/course:managescales','write',50,'moodle',0),
(54,'moodle/course:managegroups','write',50,'moodle',0),
(55,'moodle/course:reset','write',50,'moodle',0),
(56,'moodle/blog:view','read',10,'moodle',0),
(57,'moodle/blog:create','write',10,'moodle',16),
(58,'moodle/blog:manageofficialtags','write',10,'moodle',16),
(59,'moodle/blog:managepersonaltags','write',10,'moodle',16),
(60,'moodle/blog:manageentries','write',10,'moodle',16),
(61,'moodle/calendar:manageownentries','write',10,'moodle',16),
(62,'moodle/calendar:manageentries','write',10,'moodle',16),
(63,'moodle/user:readuserposts','read',30,'moodle',0),
(64,'moodle/user:readuserblogs','read',30,'moodle',0),
(65,'moodle/user:viewuseractivitiesreport','read',30,'moodle',0),
(66,'moodle/user:editprofile','read',30,'moodle',16),
(67,'moodle/question:import','write',50,'moodle',4),
(68,'moodle/question:export','read',50,'moodle',0),
(69,'moodle/question:managecategory','write',50,'moodle',0),
(70,'moodle/question:manage','write',50,'moodle',4),
(71,'moodle/site:doclinks','read',10,'moodle',0),
(72,'moodle/course:sectionvisibility','write',50,'moodle',0),
(73,'moodle/course:useremail','write',50,'moodle',0),
(74,'moodle/course:viewhiddensections','write',50,'moodle',0),
(75,'moodle/course:setcurrentsection','write',50,'moodle',0),
(76,'moodle/course:viewcoursegrades','read',50,'moodle',8),
(77,'moodle/course:managegrades','write',50,'moodle',8),
(78,'mod/assignment:view','read',70,'mod/assignment',0),
(79,'mod/assignment:submit','write',70,'mod/assignment',0),
(80,'mod/assignment:grade','write',70,'mod/assignment',0),
(81,'mod/chat:chat','write',70,'mod/chat',16),
(82,'mod/chat:readlog','read',70,'mod/chat',0),
(83,'mod/chat:deletelog','write',70,'mod/chat',0),
(84,'mod/choice:choose','write',70,'mod/choice',0),
(85,'mod/choice:readresponses','read',70,'mod/choice',0),
(86,'mod/choice:deleteresponses','write',70,'mod/choice',0),
(87,'mod/choice:downloadresponses','read',70,'mod/choice',0),
(88,'mod/data:viewentry','read',70,'mod/data',0),
(89,'mod/data:writeentry','write',70,'mod/data',16),
(90,'mod/data:comment','write',70,'mod/data',16),
(91,'mod/data:viewrating','read',70,'mod/data',0),
(92,'mod/data:rate','write',70,'mod/data',0),
(93,'mod/data:approve','write',70,'mod/data',0),
(94,'mod/data:manageentries','write',70,'mod/data',16),
(95,'mod/data:managecomments','write',70,'mod/data',16),
(96,'mod/data:managetemplates','write',70,'mod/data',20),
(97,'mod/data:viewalluserpresets','read',70,'mod/data',0),
(98,'mod/data:manageuserpresets','write',70,'mod/data',0),
(99,'mod/forum:viewdiscussion','read',70,'mod/forum',0),
(100,'mod/forum:viewhiddentimedposts','read',70,'mod/forum',0),
(101,'mod/forum:startdiscussion','write',70,'mod/forum',16),
(102,'mod/forum:replypost','write',70,'mod/forum',16),
(103,'mod/forum:viewrating','read',70,'mod/forum',0),
(104,'mod/forum:viewanyrating','read',70,'mod/forum',0),
(105,'mod/forum:rate','write',70,'mod/forum',0),
(106,'mod/forum:createattachment','write',70,'mod/forum',16),
(107,'mod/forum:deleteownpost','read',70,'mod/forum',0),
(108,'mod/forum:deleteanypost','read',70,'mod/forum',0),
(109,'mod/forum:splitdiscussions','read',70,'mod/forum',0),
(110,'mod/forum:movediscussions','read',70,'mod/forum',0),
(111,'mod/forum:editanypost','write',70,'mod/forum',16),
(112,'mod/forum:viewqandawithoutposting','read',70,'mod/forum',0),
(113,'mod/forum:viewsubscribers','read',70,'mod/forum',0),
(114,'mod/forum:managesubscriptions','read',70,'mod/forum',0),
(115,'mod/forum:throttlingapplies','write',70,'mod/forum',16),
(116,'mod/glossary:write','write',70,'mod/glossary',16),
(117,'mod/glossary:manageentries','write',70,'mod/glossary',16),
(118,'mod/glossary:managecategories','write',70,'mod/glossary',16),
(119,'mod/glossary:comment','write',70,'mod/glossary',16),
(120,'mod/glossary:managecomments','write',70,'mod/glossary',16),
(121,'mod/glossary:import','write',70,'mod/glossary',16),
(122,'mod/glossary:export','read',70,'mod/glossary',0),
(123,'mod/glossary:approve','write',70,'mod/glossary',16),
(124,'mod/glossary:rate','write',70,'mod/glossary',0),
(125,'mod/glossary:viewrating','read',70,'mod/glossary',0),
(126,'mod/hotpot:attempt','read',70,'mod/hotpot',0),
(127,'mod/hotpot:viewreport','read',70,'mod/hotpot',0),
(128,'mod/hotpot:grade','read',70,'mod/hotpot',0),
(129,'mod/hotpot:deleteattempt','read',70,'mod/hotpot',0),
(130,'mod/lams:participate','write',70,'mod/lams',0),
(131,'mod/lams:manage','write',70,'mod/lams',0),
(132,'mod/lesson:edit','write',70,'mod/lesson',4),
(133,'mod/lesson:manage','write',70,'mod/lesson',0),
(134,'mod/quiz:view','read',70,'mod/quiz',0),
(135,'mod/quiz:attempt','write',70,'mod/quiz',0),
(136,'mod/quiz:manage','write',70,'mod/quiz',0),
(137,'mod/quiz:preview','write',70,'mod/quiz',0),
(138,'mod/quiz:grade','write',70,'mod/quiz',0),
(139,'mod/quiz:viewreports','read',70,'mod/quiz',0),
(140,'mod/quiz:deleteattempts','write',70,'mod/quiz',0),
(141,'mod/scorm:viewreport','read',70,'mod/scorm',0),
(142,'mod/scorm:skipview','write',70,'mod/scorm',0),
(143,'mod/scorm:savetrack','write',70,'mod/scorm',0),
(144,'mod/scorm:viewscores','read',70,'mod/scorm',0),
(145,'mod/survey:participate','read',70,'mod/survey',0),
(146,'mod/survey:readresponses','read',70,'mod/survey',0),
(147,'mod/survey:download','read',70,'mod/survey',0),
(148,'mod/wiki:participate','write',70,'mod/wiki',16),
(149,'mod/wiki:manage','write',70,'mod/wiki',16),
(150,'mod/wiki:overridelock','write',70,'mod/wiki',0),
(151,'mod/workshop:participate','write',70,'mod/workshop',16),
(152,'mod/workshop:manage','write',70,'mod/workshop',16),
(153,'block/rss_client:createprivatefeeds','write',10,'block/rss_client',0),
(154,'block/rss_client:createsharedfeeds','write',10,'block/rss_client',0),
(155,'block/rss_client:manageownfeeds','write',10,'block/rss_client',0),
(156,'block/rss_client:manageanyfeeds','write',10,'block/rss_client',0),
(157,'enrol/authorize:managepayments','write',10,'enrol/authorize',0),
(158,'enrol/authorize:uploadcsv','write',30,'enrol/authorize',4);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_capabilities` ENABLE KEYS */;

--
-- Table structure for table `mdl_chat`
--

DROP TABLE IF EXISTS `mdl_chat`;
CREATE TABLE `mdl_chat` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `intro` text NOT NULL,
  `keepdays` bigint(11) NOT NULL default '0',
  `studentlogs` smallint(4) NOT NULL default '0',
  `chattime` bigint(10) unsigned NOT NULL default '0',
  `schedule` smallint(4) NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_chat_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Each of these is a chat room';

--
-- Dumping data for table `mdl_chat`
--


/*!40000 ALTER TABLE `mdl_chat` DISABLE KEYS */;
LOCK TABLES `mdl_chat` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_chat` ENABLE KEYS */;

--
-- Table structure for table `mdl_chat_messages`
--

DROP TABLE IF EXISTS `mdl_chat_messages`;
CREATE TABLE `mdl_chat_messages` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `chatid` bigint(10) NOT NULL default '0',
  `userid` bigint(10) NOT NULL default '0',
  `groupid` bigint(10) NOT NULL default '0',
  `system` tinyint(1) unsigned NOT NULL default '0',
  `message` text NOT NULL,
  `timestamp` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_chatmess_use_ix` (`userid`),
  KEY `mdl_chatmess_gro_ix` (`groupid`),
  KEY `mdl_chatmess_timcha_ix` (`timestamp`,`chatid`),
  KEY `mdl_chatmess_cha_ix` (`chatid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all the actual chat messages';

--
-- Dumping data for table `mdl_chat_messages`
--


/*!40000 ALTER TABLE `mdl_chat_messages` DISABLE KEYS */;
LOCK TABLES `mdl_chat_messages` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_chat_messages` ENABLE KEYS */;

--
-- Table structure for table `mdl_chat_users`
--

DROP TABLE IF EXISTS `mdl_chat_users`;
CREATE TABLE `mdl_chat_users` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `chatid` bigint(11) NOT NULL default '0',
  `userid` bigint(11) NOT NULL default '0',
  `groupid` bigint(11) NOT NULL default '0',
  `version` varchar(16) NOT NULL default '',
  `ip` varchar(15) NOT NULL default '',
  `firstping` bigint(10) unsigned NOT NULL default '0',
  `lastping` bigint(10) unsigned NOT NULL default '0',
  `lastmessageping` bigint(10) unsigned NOT NULL default '0',
  `sid` varchar(32) NOT NULL default '',
  `course` bigint(10) unsigned NOT NULL default '0',
  `lang` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_chatuser_use_ix` (`userid`),
  KEY `mdl_chatuser_las_ix` (`lastping`),
  KEY `mdl_chatuser_gro_ix` (`groupid`),
  KEY `mdl_chatuser_cha_ix` (`chatid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Keeps track of which users are in which chat rooms';

--
-- Dumping data for table `mdl_chat_users`
--


/*!40000 ALTER TABLE `mdl_chat_users` DISABLE KEYS */;
LOCK TABLES `mdl_chat_users` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_chat_users` ENABLE KEYS */;

--
-- Table structure for table `mdl_choice`
--

DROP TABLE IF EXISTS `mdl_choice`;
CREATE TABLE `mdl_choice` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `text` text NOT NULL,
  `format` tinyint(2) unsigned NOT NULL default '0',
  `publish` tinyint(2) unsigned NOT NULL default '0',
  `showresults` tinyint(2) unsigned NOT NULL default '0',
  `display` smallint(4) unsigned NOT NULL default '0',
  `allowupdate` tinyint(2) unsigned NOT NULL default '0',
  `showunanswered` tinyint(2) unsigned NOT NULL default '0',
  `limitanswers` tinyint(2) unsigned NOT NULL default '0',
  `timeopen` bigint(10) unsigned NOT NULL default '0',
  `timeclose` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_choi_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Available choices are stored here';

--
-- Dumping data for table `mdl_choice`
--


/*!40000 ALTER TABLE `mdl_choice` DISABLE KEYS */;
LOCK TABLES `mdl_choice` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_choice` ENABLE KEYS */;

--
-- Table structure for table `mdl_choice_answers`
--

DROP TABLE IF EXISTS `mdl_choice_answers`;
CREATE TABLE `mdl_choice_answers` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `choiceid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `optionid` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_choiansw_use_ix` (`userid`),
  KEY `mdl_choiansw_cho_ix` (`choiceid`),
  KEY `mdl_choiansw_opt_ix` (`optionid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='choices performed by users';

--
-- Dumping data for table `mdl_choice_answers`
--


/*!40000 ALTER TABLE `mdl_choice_answers` DISABLE KEYS */;
LOCK TABLES `mdl_choice_answers` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_choice_answers` ENABLE KEYS */;

--
-- Table structure for table `mdl_choice_options`
--

DROP TABLE IF EXISTS `mdl_choice_options`;
CREATE TABLE `mdl_choice_options` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `choiceid` bigint(10) unsigned NOT NULL default '0',
  `text` text,
  `maxanswers` bigint(10) unsigned default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_choiopti_cho_ix` (`choiceid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='available options to choice';

--
-- Dumping data for table `mdl_choice_options`
--


/*!40000 ALTER TABLE `mdl_choice_options` DISABLE KEYS */;
LOCK TABLES `mdl_choice_options` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_choice_options` ENABLE KEYS */;

--
-- Table structure for table `mdl_config`
--

DROP TABLE IF EXISTS `mdl_config`;
CREATE TABLE `mdl_config` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_conf_nam_uix` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Moodle configuration variables';

--
-- Dumping data for table `mdl_config`
--


/*!40000 ALTER TABLE `mdl_config` DISABLE KEYS */;
LOCK TABLES `mdl_config` WRITE;
INSERT INTO `mdl_config` VALUES (1,'statsrolesupgraded','1172450792'),
(2,'notloggedinroleid','6'),
(3,'defaultuserroleid','6'),
(4,'defaultcourseroleid','5'),
(5,'autologinguests','1'),
(6,'hiddenuserfields','description,city,country,lastaccess'),
(7,'enablecourserequests','1'),
(8,'defaultrequestcategory','1'),
(9,'timezone','99'),
(10,'forcetimezone','99'),
(11,'country','0'),
(12,'iplookup','hostip'),
(13,'lang','admin_lang_lowercase'),
(14,'langmenu','1'),
(15,'langlist',''),
(16,'langcache','1'),
(17,'locale',''),
(18,'protectusernames','1'),
(19,'forcelogin','0'),
(20,'forceloginforprofiles','1'),
(21,'opentogoogle','0'),
(22,'maxbytes','2'),
(23,'messaging','1'),
(24,'allowobjectembed','0'),
(25,'enabletrusttext','0'),
(26,'maxeditingtime','3600'),
(27,'fullnamedisplay','firstname lastname'),
(28,'extendedusernamechars','1'),
(29,'sitepolicy',''),
(30,'bloglevel','4'),
(31,'loginhttps','1'),
(32,'secureforms','0'),
(33,'restrictmodulesfor','none'),
(34,'restrictbydefault','0'),
(35,'defaultallowedmodules','1,2,3,4,5,6,8,11,12,13,14,15,16,17'),
(36,'displayloginfailures',''),
(37,'notifyloginfailures','mainadmin'),
(38,'notifyloginthreshold','10'),
(39,'runclamonupload','1'),
(40,'pathtoclam','/usr/bin/clamdscan'),
(41,'quarantinedir','DATADIR/quarantine'),
(42,'clamfailureonupload','donothing'),
(43,'themelist',''),
(44,'allowuserthemes','1'),
(45,'allowcoursethemes','1'),
(46,'allowuserblockhiding','1'),
(47,'showblocksonmodpages','0'),
(48,'tabselectedtofront','0'),
(49,'frontpage','1,0,,'),
(50,'frontpageloggedin','1,0,,'),
(51,'coursesperpage','20'),
(52,'calendar_adminseesall','0'),
(53,'calendar_startwday','1'),
(54,'calendar_weekend','65'),
(55,'calendar_lookahead','21'),
(56,'calendar_maxevents','10'),
(57,'cachetext','60'),
(58,'filteruploadedfiles','0'),
(59,'filtermatchoneperpage','0'),
(60,'filtermatchonepertext','0'),
(61,'filterall','0'),
(62,'htmleditor','1'),
(63,'editorbackgroundcolor','#ffffff'),
(64,'editorfontfamily','Trebuchet MS,Verdana,Arial,Helvetica,sans-serif'),
(65,'editorfontsize','11px'),
(66,'editorfontlist','Trebuchet:Trebuchet MS,Verdana,Arial,Helvetica,sans-serif;Arial:arial,helvetica,sans-serif;Courier New:courier new,courier,monospace;Georgia:georgia,times new roman,times,serif;Tahoma:tahoma,arial,helvetica,sans-serif;Times New Roman:times new roman,times,serif;Verdana:verdana,arial,helvetica,sans-serif;Impact:impact;Wingdings:wingdings'),
(67,'editorkillword','1'),
(68,'editorhidebuttons',''),
(69,'docroot','http://docs.moodle.org'),
(70,'doctonewwindow','0'),
(71,'mymoodleredirect','0'),
(72,'gradebookroles','5'),
(73,'gdversion','2'),
(74,'zip','/usr/bin/zip'),
(75,'unzip','/usr/bin/unzip'),
(76,'pathtodu','/usr/bin/du'),
(77,'aspellpath',''),
(78,'smtphosts','mailserver'),
(79,'smtpuser',''),
(80,'smtppass',''),
(81,'noreplyaddress','noreply@DOMAIN'),
(82,'allowemailaddresses',''),
(83,'denyemailaddresses',''),
(84,'digestmailtime','17'),
(85,'sitemailcharset','ISO-8859-1'),
(86,'allowusermailcharset','1'),
(87,'dbsessions','0'),
(88,'sessiontimeout','7200'),
(89,'sessioncookie',''),
(90,'sessioncookiepath','/'),
(91,'enablerssfeeds','1'),
(92,'debug',''),
(93,'perfdebug','7'),
(94,'enablestats','1'),
(95,'statsfirstrun','2419200'),
(96,'statsmaxruntime','3600'),
(97,'statsruntimestarthour','2'),
(98,'statsruntimestartminute','0'),
(99,'statsuserthreshold','0'),
(100,'framename','_top'),
(101,'slasharguments','1'),
(102,'proxyhost','proxy'),
(103,'proxyport','8080'),
(104,'longtimenosee','120'),
(105,'deleteunconfirmed','168'),
(106,'loglifetime','0'),
(107,'enablerecordcache','1'),
(108,'enableajax','1'),
(109,'enableglobalsearch','0'),
(110,'alternateloginurl',''),
(111,'auth','ldap'),
(112,'auth_pop3mailbox','INBOX'),
(113,'changepassword',''),
(114,'enrol','manual'),
(115,'enrol_plugins_enabled','manual,ldap'),
(116,'guestloginbutton','1'),
(117,'style','default'),
(118,'template','default'),
(119,'theme','formal_white'),
(120,'version','2006101010'),
(121,'release','1.7.1'),
(122,'assignment_maxbytes','1024000'),
(123,'assignment_itemstocount','1'),
(124,'assignment_online_version','2005042900'),
(125,'chat_refresh_room','5'),
(126,'chat_refresh_userlist','10'),
(127,'chat_old_ping','35'),
(128,'chat_method','header_js'),
(129,'chat_normal_updatemode','jsupdate'),
(130,'chat_serverhost','CHAT_SERVERHOST'),
(131,'chat_serverip','SCHOOL_MAILSERVER'),
(132,'chat_serverport','9111'),
(133,'chat_servermax','100'),
(134,'forum_displaymode','3'),
(135,'forum_shortpost','300'),
(136,'forum_longpost','600'),
(137,'forum_manydiscussions','100'),
(138,'forum_maxbytes','512000'),
(139,'forum_trackreadposts','1'),
(140,'forum_oldpostdays','14'),
(141,'forum_usermarksread',''),
(142,'forum_cleanreadtime','2'),
(143,'forum_replytouser','1'),
(144,'glossary_studentspost','1'),
(145,'glossary_dupentries','0'),
(146,'glossary_allowcomments','0'),
(147,'glossary_linkbydefault','1'),
(148,'glossary_defaultapproval','1'),
(149,'glossary_entbypage','10'),
(150,'hotpot_showtimes','0'),
(151,'hotpot_excelencodings',''),
(152,'hotpot_initialdisable','1'),
(153,'journal_showrecentactivity','1'),
(154,'journal_initialdisable','1'),
(155,'lams_initialdisable','1'),
(156,'quiz_review','16777215'),
(157,'quiz_attemptonlast','0'),
(158,'quiz_attempts','0'),
(159,'quiz_grademethod',''),
(160,'quiz_decimalpoints','2'),
(161,'quiz_maximumgrade','10'),
(162,'quiz_password',''),
(163,'quiz_popup','0'),
(164,'quiz_questionsperpage','0'),
(165,'quiz_shuffleanswers','1'),
(166,'quiz_shufflequestions','0'),
(167,'quiz_subnet',''),
(168,'quiz_timelimit','0'),
(169,'quiz_optionflags','1'),
(170,'quiz_penaltyscheme','1'),
(171,'quiz_delay1','0'),
(172,'quiz_delay2','0'),
(173,'quiz_fix_review','0'),
(174,'quiz_fix_attemptonlast','0'),
(175,'quiz_fix_attempts','0'),
(176,'quiz_fix_grademethod','0'),
(177,'quiz_fix_decimalpoints','0'),
(178,'quiz_fix_password','0'),
(179,'quiz_fix_popup','0'),
(180,'quiz_fix_questionsperpage','0'),
(181,'quiz_fix_shuffleanswers','0'),
(182,'quiz_fix_shufflequestions','0'),
(183,'quiz_fix_subnet','0'),
(184,'quiz_fix_timelimit','0'),
(185,'quiz_fix_adaptive','0'),
(186,'quiz_fix_penaltyscheme','0'),
(187,'quiz_fix_delay1','0'),
(188,'quiz_fix_delay2','0'),
(189,'resource_framesize','130'),
(190,'resource_websearch','http://google.com/'),
(191,'resource_defaulturl','http://'),
(192,'resource_filterexternalpages','0'),
(193,'resource_secretphrase','Oaof2AMSDgqLlrvrDxKC'),
(194,'resource_popup','checked'),
(195,'resource_windowsettings','0'),
(196,'resource_parametersettings','0'),
(197,'resource_allowlocalfiles','1'),
(198,'resource_hide_repository','1'),
(199,'resource_autofilerename','1'),
(200,'resource_blockdeletingfile','1'),
(201,'resource_popupresizable','checked'),
(202,'resource_popupscrollbars','checked'),
(203,'resource_popupdirectories','checked'),
(204,'resource_popuplocation','checked'),
(205,'resource_popupmenubar','checked'),
(206,'resource_popuptoolbar','checked'),
(207,'resource_popupstatus','checked'),
(208,'resource_popupheight','450'),
(209,'resource_popupwidth','620'),
(210,'qtype_calculated_version','2006032200'),
(211,'qtype_essay_version','2006032200'),
(212,'qtype_match_version','2006032200'),
(213,'qtype_multianswer_version','2006032200'),
(214,'qtype_multichoice_version','2006081901'),
(215,'qtype_numerical_version','2006032201'),
(216,'qtype_randomsamatch_version','2006042800'),
(217,'qtype_rqp_version','2006032200'),
(218,'qtype_shortanswer_version','2006032200'),
(219,'qtype_truefalse_version','2006032200'),
(220,'backup_version','2006082304'),
(221,'backup_release','1.7'),
(222,'blocks_version','2005090201'),
(223,'enrol_authorize_version','2006101702'),
(224,'enrol_paypal_version','2006092200'),
(225,'adminblocks_initialised','1'),
(226,'siteidentifier','4dZT4Od4kqwuXiHZLSQWtTHSDEdcfmkX'),
(227,'rolesactive','1'),
(228,'sesskey','SESSIONKEY'),
(229,'ldap_host_url','ldaps://ldap'),
(230,'ldap_version','3'),
(231,'ldap_preventpassindb','1'),
(232,'ldap_bind_dn',''),
(233,'ldap_bind_pw',''),
(234,'ldap_user_type','rfc2307'),
(235,'ldap_contexts','LDAP_CONTEXT'),
(236,'ldap_search_sub','1'),
(237,'ldap_opt_deref','0'),
(238,'ldap_user_attribute','uid'),
(239,'ldap_memberattribute','member'),
(240,'ldap_objectclass','objectclass=SchoolAccount'),
(241,'auth_ldap_forcechangepassword','0'),
(242,'auth_ldap_stdchangepassword','0'),
(243,'ldap_expiration','0'),
(244,'ldap_expiration_warning','10'),
(245,'ldap_expireattr',''),
(246,'ldap_gracelogins','0'),
(247,'ldap_graceattr',''),
(248,'ldap_create_context',''),
(249,'ldap_creators','cn=teachers,ou=group,LDAP_SUFFIX;cn=sysadmins,ou=group,LDAP_SUFFIX'),
(250,'auth_instructions',''),
(251,'auth_ldap_changepasswordurl','https://admin/change_passwd.pl'),
(252,'auth_ldap_changepasswordhelp',''),
(253,'auth_user_create','0');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_config` ENABLE KEYS */;

--
-- Table structure for table `mdl_config_plugins`
--

DROP TABLE IF EXISTS `mdl_config_plugins`;
CREATE TABLE `mdl_config_plugins` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `plugin` varchar(100) NOT NULL default 'core',
  `name` varchar(100) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_confplug_plunam_uix` (`plugin`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Moodle modules and plugins configuration variables';

--
-- Dumping data for table `mdl_config_plugins`
--


/*!40000 ALTER TABLE `mdl_config_plugins` DISABLE KEYS */;
LOCK TABLES `mdl_config_plugins` WRITE;
INSERT INTO `mdl_config_plugins` VALUES (1,'auth/ldap','field_map_firstname','givenName'),
(2,'auth/ldap','field_updatelocal_firstname','onlogin'),
(3,'auth/ldap','field_updateremote_firstname','0'),
(4,'auth/ldap','field_lock_firstname','locked'),
(5,'auth/ldap','field_map_lastname','sn'),
(6,'auth/ldap','field_updatelocal_lastname','onlogin'),
(7,'auth/ldap','field_updateremote_lastname','0'),
(8,'auth/ldap','field_lock_lastname','locked'),
(9,'auth/ldap','field_map_email','mail'),
(10,'auth/ldap','field_updatelocal_email','onlogin'),
(11,'auth/ldap','field_updateremote_email','0'),
(12,'auth/ldap','field_lock_email','locked'),
(13,'auth/ldap','field_map_phone1','telephoneNumber'),
(14,'auth/ldap','field_updatelocal_phone1','onlogin'),
(15,'auth/ldap','field_updateremote_phone1','0'),
(16,'auth/ldap','field_lock_phone1','locked'),
(17,'auth/ldap','field_map_phone2','homePhone'),
(18,'auth/ldap','field_updatelocal_phone2','onlogin'),
(19,'auth/ldap','field_updateremote_phone2','0'),
(20,'auth/ldap','field_lock_phone2','locked'),
(21,'auth/ldap','field_map_department','ou'),
(22,'auth/ldap','field_updatelocal_department','onlogin'),
(23,'auth/ldap','field_updateremote_department','0'),
(24,'auth/ldap','field_lock_department','locked'),
(25,'auth/ldap','field_map_address','street'),
(26,'auth/ldap','field_updatelocal_address','onlogin'),
(27,'auth/ldap','field_updateremote_address','0'),
(28,'auth/ldap','field_lock_address','locked'),
(29,'auth/ldap','field_map_city','l'),
(30,'auth/ldap','field_updatelocal_city','onlogin'),
(31,'auth/ldap','field_updateremote_city','0'),
(32,'auth/ldap','field_lock_city','locked'),
(33,'auth/ldap','field_map_country','c'),
(34,'auth/ldap','field_updatelocal_country','onlogin'),
(35,'auth/ldap','field_updateremote_country','0'),
(36,'auth/ldap','field_lock_country','locked'),
(37,'auth/ldap','field_map_description','description'),
(38,'auth/ldap','field_updatelocal_description','onlogin'),
(39,'auth/ldap','field_updateremote_description','0'),
(40,'auth/ldap','field_lock_description','locked'),
(41,'auth/ldap','field_map_idnumber','uidNumber'),
(42,'auth/ldap','field_updatelocal_idnumber','onlogin'),
(43,'auth/ldap','field_updateremote_idnumber','0'),
(44,'auth/ldap','field_lock_idnumber','locked'),
(45,'auth/ldap','field_map_lang','preferredLanguage'),
(46,'auth/ldap','field_updatelocal_lang','onlogin'),
(47,'auth/ldap','field_updateremote_lang','0'),
(48,'auth/ldap','field_lock_lang','locked');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_config_plugins` ENABLE KEYS */;

--
-- Table structure for table `mdl_context`
--

DROP TABLE IF EXISTS `mdl_context`;
CREATE TABLE `mdl_context` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `contextlevel` bigint(10) unsigned NOT NULL default '0',
  `instanceid` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_cont_conins_uix` (`contextlevel`,`instanceid`),
  KEY `mdl_cont_ins_ix` (`instanceid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='one of these must be set';

--
-- Dumping data for table `mdl_context`
--


/*!40000 ALTER TABLE `mdl_context` DISABLE KEYS */;
LOCK TABLES `mdl_context` WRITE;
INSERT INTO `mdl_context` VALUES (1,10,1),
(2,70,1),
(3,40,1),
(4,50,2),
(5,40,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_context` ENABLE KEYS */;

--
-- Table structure for table `mdl_course`
--

DROP TABLE IF EXISTS `mdl_course`;
CREATE TABLE `mdl_course` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `category` bigint(10) unsigned NOT NULL default '0',
  `sortorder` bigint(10) unsigned NOT NULL default '0',
  `password` varchar(50) NOT NULL default '',
  `fullname` varchar(254) NOT NULL default '',
  `shortname` varchar(100) NOT NULL default '',
  `idnumber` varchar(100) NOT NULL default '',
  `summary` text NOT NULL,
  `format` varchar(10) NOT NULL default 'topics',
  `showgrades` tinyint(2) unsigned NOT NULL default '1',
  `modinfo` longtext,
  `newsitems` mediumint(5) unsigned NOT NULL default '1',
  `teacher` varchar(100) NOT NULL default 'Teacher',
  `teachers` varchar(100) NOT NULL default 'Teachers',
  `student` varchar(100) NOT NULL default 'Student',
  `students` varchar(100) NOT NULL default 'Students',
  `guest` tinyint(2) unsigned NOT NULL default '0',
  `startdate` bigint(10) unsigned NOT NULL default '0',
  `enrolperiod` bigint(10) unsigned NOT NULL default '0',
  `numsections` mediumint(5) unsigned NOT NULL default '1',
  `marker` bigint(10) unsigned NOT NULL default '0',
  `maxbytes` bigint(10) unsigned NOT NULL default '0',
  `showreports` smallint(4) unsigned NOT NULL default '0',
  `visible` tinyint(1) unsigned NOT NULL default '1',
  `hiddensections` tinyint(2) unsigned NOT NULL default '0',
  `groupmode` smallint(4) unsigned NOT NULL default '0',
  `groupmodeforce` smallint(4) unsigned NOT NULL default '0',
  `lang` varchar(10) NOT NULL default '',
  `theme` varchar(50) NOT NULL default '',
  `cost` varchar(10) NOT NULL default '',
  `currency` varchar(3) NOT NULL default 'EUR',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `metacourse` tinyint(1) unsigned NOT NULL default '0',
  `requested` tinyint(1) unsigned NOT NULL default '0',
  `restrictmodules` tinyint(1) unsigned NOT NULL default '0',
  `expirynotify` tinyint(1) unsigned NOT NULL default '0',
  `expirythreshold` bigint(10) unsigned NOT NULL default '0',
  `notifystudents` tinyint(1) unsigned NOT NULL default '0',
  `enrollable` tinyint(1) unsigned NOT NULL default '1',
  `enrolstartdate` bigint(10) unsigned NOT NULL default '0',
  `enrolenddate` bigint(10) unsigned NOT NULL default '0',
  `enrol` varchar(20) NOT NULL default '',
  `defaultrole` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_cour_cat_ix` (`category`),
  KEY `mdl_cour_idn_ix` (`idnumber`),
  KEY `mdl_cour_sho_ix` (`shortname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Central course table';

--
-- Dumping data for table `mdl_course`
--


/*!40000 ALTER TABLE `mdl_course` DISABLE KEYS */;
LOCK TABLES `mdl_course` WRITE;
INSERT INTO `mdl_course` VALUES (1,0,1000,'','SCHOOLNAME Moodle','Moodle','','SCHOOLNAME Moodle','site',1,'a:1:{i:1;O:8:\"stdClass\":6:{s:2:\"cm\";i:1;s:3:\"mod\";s:5:\"forum\";s:7:\"section\";s:1:\"0\";s:4:\"name\";s:23:\"Nachrichten+der+Website\";s:7:\"visible\";s:1:\"1\";s:5:\"extra\";s:0:\"\";}}',3,'Teacher','Teachers','Student','Students',0,0,0,1,0,0,0,1,0,0,0,'','','','EUR',0,1172451704,0,0,0,0,0,0,1,0,0,'',0),
(2,1,2000,'','Moodle','Kurs101','','Moodle for beginners.','weeks',1,'a:1:{i:2;O:8:\"stdClass\":6:{s:2:\"cm\";i:2;s:3:\"mod\";s:5:\"forum\";s:7:\"section\";s:1:\"0\";s:4:\"name\";s:16:\"Nachrichtenforum\";s:7:\"visible\";s:1:\"1\";s:5:\"extra\";s:0:\"\";}}',5,'Trainer/in','Trainer/innen','Teilnehmer/in','Teilnehmer/innen',0,1172530800,0,10,0,2097152,0,1,0,0,0,'','','','EUR',1172451827,1172451827,0,0,0,0,864000,0,1,0,0,'',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course` ENABLE KEYS */;

--
-- Table structure for table `mdl_course_allowed_modules`
--

DROP TABLE IF EXISTS `mdl_course_allowed_modules`;
CREATE TABLE `mdl_course_allowed_modules` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `module` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_courallomodu_cou_ix` (`course`),
  KEY `mdl_courallomodu_mod_ix` (`module`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='allowed modules foreach course';

--
-- Dumping data for table `mdl_course_allowed_modules`
--


/*!40000 ALTER TABLE `mdl_course_allowed_modules` DISABLE KEYS */;
LOCK TABLES `mdl_course_allowed_modules` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course_allowed_modules` ENABLE KEYS */;

--
-- Table structure for table `mdl_course_categories`
--

DROP TABLE IF EXISTS `mdl_course_categories`;
CREATE TABLE `mdl_course_categories` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` text,
  `parent` bigint(10) unsigned NOT NULL default '0',
  `sortorder` bigint(10) unsigned NOT NULL default '0',
  `coursecount` bigint(10) unsigned NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '1',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `depth` bigint(10) unsigned NOT NULL default '0',
  `path` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_courcate_par_ix` (`parent`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Course categories';

--
-- Dumping data for table `mdl_course_categories`
--


/*!40000 ALTER TABLE `mdl_course_categories` DISABLE KEYS */;
LOCK TABLES `mdl_course_categories` WRITE;
INSERT INTO `mdl_course_categories` VALUES (1,'Miscellaneous',NULL,0,0,1,1,0,1,'/1');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course_categories` ENABLE KEYS */;

--
-- Table structure for table `mdl_course_display`
--

DROP TABLE IF EXISTS `mdl_course_display`;
CREATE TABLE `mdl_course_display` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `display` bigint(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_courdisp_couuse_ix` (`course`,`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores info about how to display the course';

--
-- Dumping data for table `mdl_course_display`
--


/*!40000 ALTER TABLE `mdl_course_display` DISABLE KEYS */;
LOCK TABLES `mdl_course_display` WRITE;
INSERT INTO `mdl_course_display` VALUES (1,2,2,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course_display` ENABLE KEYS */;

--
-- Table structure for table `mdl_course_meta`
--

DROP TABLE IF EXISTS `mdl_course_meta`;
CREATE TABLE `mdl_course_meta` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `parent_course` bigint(10) unsigned NOT NULL default '0',
  `child_course` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_courmeta_par_ix` (`parent_course`),
  KEY `mdl_courmeta_chi_ix` (`child_course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to store meta-courses relations';

--
-- Dumping data for table `mdl_course_meta`
--


/*!40000 ALTER TABLE `mdl_course_meta` DISABLE KEYS */;
LOCK TABLES `mdl_course_meta` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course_meta` ENABLE KEYS */;

--
-- Table structure for table `mdl_course_modules`
--

DROP TABLE IF EXISTS `mdl_course_modules`;
CREATE TABLE `mdl_course_modules` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `module` bigint(10) unsigned NOT NULL default '0',
  `instance` bigint(10) unsigned NOT NULL default '0',
  `section` bigint(10) unsigned NOT NULL default '0',
  `added` bigint(10) unsigned NOT NULL default '0',
  `score` smallint(4) NOT NULL default '0',
  `indent` mediumint(5) unsigned NOT NULL default '0',
  `visible` tinyint(1) NOT NULL default '1',
  `visibleold` tinyint(1) NOT NULL default '1',
  `groupmode` smallint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_courmodu_vis_ix` (`visible`),
  KEY `mdl_courmodu_cou_ix` (`course`),
  KEY `mdl_courmodu_mod_ix` (`module`),
  KEY `mdl_courmodu_ins_ix` (`instance`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='course_modules table retrofitted from MySQL';

--
-- Dumping data for table `mdl_course_modules`
--


/*!40000 ALTER TABLE `mdl_course_modules` DISABLE KEYS */;
LOCK TABLES `mdl_course_modules` WRITE;
INSERT INTO `mdl_course_modules` VALUES (1,1,5,1,2,1172451707,0,0,1,1,0),
(2,2,5,2,3,1172451867,0,0,1,1,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course_modules` ENABLE KEYS */;

--
-- Table structure for table `mdl_course_request`
--

DROP TABLE IF EXISTS `mdl_course_request`;
CREATE TABLE `mdl_course_request` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `fullname` varchar(254) NOT NULL default '',
  `shortname` varchar(15) NOT NULL default '',
  `summary` text NOT NULL,
  `reason` text NOT NULL,
  `requester` bigint(10) NOT NULL default '0',
  `password` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_courrequ_sho_ix` (`shortname`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='course requests';

--
-- Dumping data for table `mdl_course_request`
--


/*!40000 ALTER TABLE `mdl_course_request` DISABLE KEYS */;
LOCK TABLES `mdl_course_request` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course_request` ENABLE KEYS */;

--
-- Table structure for table `mdl_course_sections`
--

DROP TABLE IF EXISTS `mdl_course_sections`;
CREATE TABLE `mdl_course_sections` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `section` bigint(10) unsigned NOT NULL default '0',
  `summary` text,
  `sequence` text,
  `visible` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `mdl_coursect_cousec_ix` (`course`,`section`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to define the sections for each course';

--
-- Dumping data for table `mdl_course_sections`
--


/*!40000 ALTER TABLE `mdl_course_sections` DISABLE KEYS */;
LOCK TABLES `mdl_course_sections` WRITE;
INSERT INTO `mdl_course_sections` VALUES (1,1,1,'','',1),
(2,1,0,'','1',1),
(3,2,0,NULL,'2',1),
(4,2,1,'',NULL,1),
(5,2,2,'',NULL,1),
(6,2,3,'',NULL,1),
(7,2,4,'',NULL,1),
(8,2,5,'',NULL,1),
(9,2,6,'',NULL,1),
(10,2,7,'',NULL,1),
(11,2,8,'',NULL,1),
(12,2,9,'',NULL,1),
(13,2,10,'',NULL,1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_course_sections` ENABLE KEYS */;

--
-- Table structure for table `mdl_data`
--

DROP TABLE IF EXISTS `mdl_data`;
CREATE TABLE `mdl_data` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `intro` text NOT NULL,
  `comments` smallint(4) unsigned NOT NULL default '0',
  `timeavailablefrom` bigint(10) unsigned NOT NULL default '0',
  `timeavailableto` bigint(10) unsigned NOT NULL default '0',
  `timeviewfrom` bigint(10) unsigned NOT NULL default '0',
  `timeviewto` bigint(10) unsigned NOT NULL default '0',
  `requiredentries` int(8) unsigned NOT NULL default '0',
  `requiredentriestoview` int(8) unsigned NOT NULL default '0',
  `maxentries` int(8) unsigned NOT NULL default '0',
  `rssarticles` smallint(4) unsigned NOT NULL default '0',
  `singletemplate` text,
  `listtemplate` text,
  `listtemplateheader` text,
  `listtemplatefooter` text,
  `addtemplate` text,
  `rsstemplate` text,
  `rsstitletemplate` text,
  `csstemplate` text,
  `jstemplate` text,
  `approval` smallint(4) unsigned NOT NULL default '0',
  `scale` bigint(10) NOT NULL default '0',
  `assessed` bigint(10) unsigned NOT NULL default '0',
  `defaultsort` bigint(10) unsigned NOT NULL default '0',
  `defaultsortdir` smallint(4) unsigned NOT NULL default '0',
  `editany` smallint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Removed ratings column';

--
-- Dumping data for table `mdl_data`
--


/*!40000 ALTER TABLE `mdl_data` DISABLE KEYS */;
LOCK TABLES `mdl_data` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_data` ENABLE KEYS */;

--
-- Table structure for table `mdl_data_comments`
--

DROP TABLE IF EXISTS `mdl_data_comments`;
CREATE TABLE `mdl_data_comments` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `recordid` bigint(10) unsigned NOT NULL default '0',
  `content` text NOT NULL,
  `created` bigint(10) unsigned NOT NULL default '0',
  `modified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_datacomm_rec_ix` (`recordid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to comment data records';

--
-- Dumping data for table `mdl_data_comments`
--


/*!40000 ALTER TABLE `mdl_data_comments` DISABLE KEYS */;
LOCK TABLES `mdl_data_comments` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_data_comments` ENABLE KEYS */;

--
-- Table structure for table `mdl_data_content`
--

DROP TABLE IF EXISTS `mdl_data_content`;
CREATE TABLE `mdl_data_content` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `fieldid` bigint(10) unsigned NOT NULL default '0',
  `recordid` bigint(10) unsigned NOT NULL default '0',
  `content` longtext,
  `content1` longtext,
  `content2` longtext,
  `content3` longtext,
  `content4` longtext,
  PRIMARY KEY  (`id`),
  KEY `mdl_datacont_rec_ix` (`recordid`),
  KEY `mdl_datacont_fie_ix` (`fieldid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='the content introduced in each record/fields';

--
-- Dumping data for table `mdl_data_content`
--


/*!40000 ALTER TABLE `mdl_data_content` DISABLE KEYS */;
LOCK TABLES `mdl_data_content` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_data_content` ENABLE KEYS */;

--
-- Table structure for table `mdl_data_fields`
--

DROP TABLE IF EXISTS `mdl_data_fields`;
CREATE TABLE `mdl_data_fields` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `dataid` bigint(10) unsigned NOT NULL default '0',
  `type` varchar(255) NOT NULL default '',
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `param1` text,
  `param2` text,
  `param3` text,
  `param4` text,
  `param5` text,
  `param6` text,
  `param7` text,
  `param8` text,
  `param9` text,
  `param10` text,
  PRIMARY KEY  (`id`),
  KEY `mdl_datafiel_dat_ix` (`dataid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='every field available';

--
-- Dumping data for table `mdl_data_fields`
--


/*!40000 ALTER TABLE `mdl_data_fields` DISABLE KEYS */;
LOCK TABLES `mdl_data_fields` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_data_fields` ENABLE KEYS */;

--
-- Table structure for table `mdl_data_ratings`
--

DROP TABLE IF EXISTS `mdl_data_ratings`;
CREATE TABLE `mdl_data_ratings` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `recordid` bigint(10) unsigned NOT NULL default '0',
  `rating` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_datarati_rec_ix` (`recordid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to rate data records';

--
-- Dumping data for table `mdl_data_ratings`
--


/*!40000 ALTER TABLE `mdl_data_ratings` DISABLE KEYS */;
LOCK TABLES `mdl_data_ratings` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_data_ratings` ENABLE KEYS */;

--
-- Table structure for table `mdl_data_records`
--

DROP TABLE IF EXISTS `mdl_data_records`;
CREATE TABLE `mdl_data_records` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `groupid` bigint(10) unsigned NOT NULL default '0',
  `dataid` bigint(10) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `approved` smallint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_datareco_dat_ix` (`dataid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='every record introduced';

--
-- Dumping data for table `mdl_data_records`
--


/*!40000 ALTER TABLE `mdl_data_records` DISABLE KEYS */;
LOCK TABLES `mdl_data_records` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_data_records` ENABLE KEYS */;

--
-- Table structure for table `mdl_enrol_authorize`
--

DROP TABLE IF EXISTS `mdl_enrol_authorize`;
CREATE TABLE `mdl_enrol_authorize` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `paymentmethod` enum('cc','echeck') NOT NULL default 'cc',
  `refundinfo` smallint(4) unsigned NOT NULL default '0',
  `ccname` varchar(255) NOT NULL default '',
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `transid` bigint(10) unsigned NOT NULL default '0',
  `status` bigint(10) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `settletime` bigint(10) unsigned NOT NULL default '0',
  `amount` varchar(10) NOT NULL default '',
  `currency` varchar(3) NOT NULL default 'EUR',
  PRIMARY KEY  (`id`),
  KEY `mdl_enroauth_cou_ix` (`courseid`),
  KEY `mdl_enroauth_use_ix` (`userid`),
  KEY `mdl_enroauth_sta_ix` (`status`),
  KEY `mdl_enroauth_tra_ix` (`transid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Holds all known information about authorize.net transactions';

--
-- Dumping data for table `mdl_enrol_authorize`
--


/*!40000 ALTER TABLE `mdl_enrol_authorize` DISABLE KEYS */;
LOCK TABLES `mdl_enrol_authorize` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_enrol_authorize` ENABLE KEYS */;

--
-- Table structure for table `mdl_enrol_authorize_refunds`
--

DROP TABLE IF EXISTS `mdl_enrol_authorize_refunds`;
CREATE TABLE `mdl_enrol_authorize_refunds` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `orderid` bigint(10) unsigned NOT NULL default '0',
  `status` tinyint(1) unsigned NOT NULL default '0',
  `amount` varchar(10) NOT NULL default '',
  `transid` bigint(10) unsigned default '0',
  `settletime` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_enroauthrefu_tra_ix` (`transid`),
  KEY `mdl_enroauthrefu_ord_ix` (`orderid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Authorize.net refunds';

--
-- Dumping data for table `mdl_enrol_authorize_refunds`
--


/*!40000 ALTER TABLE `mdl_enrol_authorize_refunds` DISABLE KEYS */;
LOCK TABLES `mdl_enrol_authorize_refunds` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_enrol_authorize_refunds` ENABLE KEYS */;

--
-- Table structure for table `mdl_enrol_paypal`
--

DROP TABLE IF EXISTS `mdl_enrol_paypal`;
CREATE TABLE `mdl_enrol_paypal` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `business` varchar(255) NOT NULL default '',
  `receiver_email` varchar(255) NOT NULL default '',
  `receiver_id` varchar(255) NOT NULL default '',
  `item_name` varchar(255) NOT NULL default '',
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `memo` varchar(255) NOT NULL default '',
  `tax` varchar(255) NOT NULL default '',
  `option_name1` varchar(255) NOT NULL default '',
  `option_selection1_x` varchar(255) NOT NULL default '',
  `option_name2` varchar(255) NOT NULL default '',
  `option_selection2_x` varchar(255) NOT NULL default '',
  `payment_status` varchar(255) NOT NULL default '',
  `pending_reason` varchar(255) NOT NULL default '',
  `reason_code` varchar(30) NOT NULL default '',
  `txn_id` varchar(255) NOT NULL default '',
  `parent_txn_id` varchar(255) NOT NULL default '',
  `payment_type` varchar(30) NOT NULL default '',
  `timeupdated` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Holds all known information about Paypal transactions';

--
-- Dumping data for table `mdl_enrol_paypal`
--


/*!40000 ALTER TABLE `mdl_enrol_paypal` DISABLE KEYS */;
LOCK TABLES `mdl_enrol_paypal` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_enrol_paypal` ENABLE KEYS */;

--
-- Table structure for table `mdl_event`
--

DROP TABLE IF EXISTS `mdl_event`;
CREATE TABLE `mdl_event` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `format` smallint(4) unsigned NOT NULL default '0',
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `groupid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `repeatid` bigint(10) unsigned NOT NULL default '0',
  `modulename` varchar(20) NOT NULL default '',
  `instance` bigint(10) unsigned NOT NULL default '0',
  `eventtype` varchar(20) NOT NULL default '',
  `timestart` bigint(10) unsigned NOT NULL default '0',
  `timeduration` bigint(10) unsigned NOT NULL default '0',
  `visible` smallint(4) NOT NULL default '1',
  `uuid` varchar(36) NOT NULL default '',
  `sequence` bigint(10) unsigned NOT NULL default '1',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_even_cou_ix` (`courseid`),
  KEY `mdl_even_use_ix` (`userid`),
  KEY `mdl_even_tim_ix` (`timestart`),
  KEY `mdl_even_tim2_ix` (`timeduration`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='For everything with a time associated to it';

--
-- Dumping data for table `mdl_event`
--


/*!40000 ALTER TABLE `mdl_event` DISABLE KEYS */;
LOCK TABLES `mdl_event` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_event` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum`
--

DROP TABLE IF EXISTS `mdl_forum`;
CREATE TABLE `mdl_forum` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `type` enum('single','news','general','social','eachuser','teacher','qanda') NOT NULL default 'general',
  `name` varchar(255) NOT NULL default '',
  `intro` text NOT NULL,
  `assessed` bigint(10) unsigned NOT NULL default '0',
  `assesstimestart` bigint(10) unsigned NOT NULL default '0',
  `assesstimefinish` bigint(10) unsigned NOT NULL default '0',
  `scale` bigint(10) NOT NULL default '0',
  `maxbytes` bigint(10) unsigned NOT NULL default '0',
  `forcesubscribe` tinyint(1) unsigned NOT NULL default '0',
  `trackingtype` tinyint(2) unsigned NOT NULL default '1',
  `rsstype` tinyint(2) unsigned NOT NULL default '0',
  `rssarticles` tinyint(2) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `warnafter` bigint(10) unsigned NOT NULL default '0',
  `blockafter` bigint(10) unsigned NOT NULL default '0',
  `blockperiod` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_foru_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Forums contain and structure discussion';

--
-- Dumping data for table `mdl_forum`
--


/*!40000 ALTER TABLE `mdl_forum` DISABLE KEYS */;
LOCK TABLES `mdl_forum` WRITE;
INSERT INTO `mdl_forum` VALUES (1,1,'news','Nachrichten der Website','Allgemeine Nachrichten und Ankndigungen',0,0,0,0,0,0,1,0,0,1172451707,0,0,0),
(2,2,'news','Nachrichtenforum','Allgemeine Nachrichten und Ankndigungen',0,0,0,0,0,1,1,0,0,1172451867,0,0,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum_discussions`
--

DROP TABLE IF EXISTS `mdl_forum_discussions`;
CREATE TABLE `mdl_forum_discussions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `forum` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `firstpost` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `groupid` bigint(10) NOT NULL default '-1',
  `assessed` tinyint(1) NOT NULL default '1',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `usermodified` bigint(10) unsigned NOT NULL default '0',
  `timestart` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_forudisc_use_ix` (`userid`),
  KEY `mdl_forudisc_for_ix` (`forum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Forums are composed of discussions';

--
-- Dumping data for table `mdl_forum_discussions`
--


/*!40000 ALTER TABLE `mdl_forum_discussions` DISABLE KEYS */;
LOCK TABLES `mdl_forum_discussions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum_discussions` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum_posts`
--

DROP TABLE IF EXISTS `mdl_forum_posts`;
CREATE TABLE `mdl_forum_posts` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `discussion` bigint(10) unsigned NOT NULL default '0',
  `parent` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `created` bigint(10) unsigned NOT NULL default '0',
  `modified` bigint(10) unsigned NOT NULL default '0',
  `mailed` tinyint(2) unsigned NOT NULL default '0',
  `subject` varchar(255) NOT NULL default '',
  `message` text NOT NULL,
  `format` tinyint(2) NOT NULL default '0',
  `attachment` varchar(100) NOT NULL default '',
  `totalscore` smallint(4) NOT NULL default '0',
  `mailnow` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_forupost_use_ix` (`userid`),
  KEY `mdl_forupost_cre_ix` (`created`),
  KEY `mdl_forupost_mai_ix` (`mailed`),
  KEY `mdl_forupost_dis_ix` (`discussion`),
  KEY `mdl_forupost_par_ix` (`parent`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='All posts are stored in this table';

--
-- Dumping data for table `mdl_forum_posts`
--


/*!40000 ALTER TABLE `mdl_forum_posts` DISABLE KEYS */;
LOCK TABLES `mdl_forum_posts` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum_posts` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum_queue`
--

DROP TABLE IF EXISTS `mdl_forum_queue`;
CREATE TABLE `mdl_forum_queue` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `discussionid` bigint(10) unsigned NOT NULL default '0',
  `postid` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_foruqueu_use_ix` (`userid`),
  KEY `mdl_foruqueu_dis_ix` (`discussionid`),
  KEY `mdl_foruqueu_pos_ix` (`postid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='For keeping track of posts that will be mailed in digest for';

--
-- Dumping data for table `mdl_forum_queue`
--


/*!40000 ALTER TABLE `mdl_forum_queue` DISABLE KEYS */;
LOCK TABLES `mdl_forum_queue` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum_queue` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum_ratings`
--

DROP TABLE IF EXISTS `mdl_forum_ratings`;
CREATE TABLE `mdl_forum_ratings` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `post` bigint(10) unsigned NOT NULL default '0',
  `time` bigint(10) unsigned NOT NULL default '0',
  `rating` smallint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_forurati_use_ix` (`userid`),
  KEY `mdl_forurati_pos_ix` (`post`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='forum_ratings table retrofitted from MySQL';

--
-- Dumping data for table `mdl_forum_ratings`
--


/*!40000 ALTER TABLE `mdl_forum_ratings` DISABLE KEYS */;
LOCK TABLES `mdl_forum_ratings` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum_ratings` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum_read`
--

DROP TABLE IF EXISTS `mdl_forum_read`;
CREATE TABLE `mdl_forum_read` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `forumid` bigint(10) unsigned NOT NULL default '0',
  `discussionid` bigint(10) unsigned NOT NULL default '0',
  `postid` bigint(10) unsigned NOT NULL default '0',
  `firstread` bigint(10) unsigned NOT NULL default '0',
  `lastread` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_foruread_usefor_ix` (`userid`,`forumid`),
  KEY `mdl_foruread_usedis_ix` (`userid`,`discussionid`),
  KEY `mdl_foruread_usepos_ix` (`userid`,`postid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Tracks each users read posts';

--
-- Dumping data for table `mdl_forum_read`
--


/*!40000 ALTER TABLE `mdl_forum_read` DISABLE KEYS */;
LOCK TABLES `mdl_forum_read` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum_read` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum_subscriptions`
--

DROP TABLE IF EXISTS `mdl_forum_subscriptions`;
CREATE TABLE `mdl_forum_subscriptions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `forum` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_forusubs_use_ix` (`userid`),
  KEY `mdl_forusubs_for_ix` (`forum`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Keeps track of who is subscribed to what forum';

--
-- Dumping data for table `mdl_forum_subscriptions`
--


/*!40000 ALTER TABLE `mdl_forum_subscriptions` DISABLE KEYS */;
LOCK TABLES `mdl_forum_subscriptions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum_subscriptions` ENABLE KEYS */;

--
-- Table structure for table `mdl_forum_track_prefs`
--

DROP TABLE IF EXISTS `mdl_forum_track_prefs`;
CREATE TABLE `mdl_forum_track_prefs` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `forumid` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_forutracpref_usefor_ix` (`userid`,`forumid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Tracks each users untracked forums';

--
-- Dumping data for table `mdl_forum_track_prefs`
--


/*!40000 ALTER TABLE `mdl_forum_track_prefs` DISABLE KEYS */;
LOCK TABLES `mdl_forum_track_prefs` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_forum_track_prefs` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary`
--

DROP TABLE IF EXISTS `mdl_glossary`;
CREATE TABLE `mdl_glossary` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `intro` text NOT NULL,
  `studentcanpost` tinyint(2) unsigned NOT NULL default '0',
  `allowduplicatedentries` tinyint(2) unsigned NOT NULL default '0',
  `displayformat` varchar(50) NOT NULL default 'dictionary',
  `mainglossary` tinyint(2) unsigned NOT NULL default '0',
  `showspecial` tinyint(2) unsigned NOT NULL default '1',
  `showalphabet` tinyint(2) unsigned NOT NULL default '1',
  `showall` tinyint(2) unsigned NOT NULL default '1',
  `allowcomments` tinyint(2) unsigned NOT NULL default '0',
  `allowprintview` tinyint(2) unsigned NOT NULL default '1',
  `usedynalink` tinyint(2) unsigned NOT NULL default '1',
  `defaultapproval` tinyint(2) unsigned NOT NULL default '1',
  `globalglossary` tinyint(2) unsigned NOT NULL default '0',
  `entbypage` smallint(3) unsigned NOT NULL default '10',
  `editalways` tinyint(2) unsigned NOT NULL default '0',
  `rsstype` tinyint(2) unsigned NOT NULL default '0',
  `rssarticles` tinyint(2) unsigned NOT NULL default '0',
  `assessed` bigint(10) unsigned NOT NULL default '0',
  `assesstimestart` bigint(10) unsigned NOT NULL default '0',
  `assesstimefinish` bigint(10) unsigned NOT NULL default '0',
  `scale` bigint(10) NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_glos_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='all glossaries';

--
-- Dumping data for table `mdl_glossary`
--


/*!40000 ALTER TABLE `mdl_glossary` DISABLE KEYS */;
LOCK TABLES `mdl_glossary` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary_alias`
--

DROP TABLE IF EXISTS `mdl_glossary_alias`;
CREATE TABLE `mdl_glossary_alias` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `entryid` bigint(10) unsigned NOT NULL default '0',
  `alias` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_glosalia_ent_ix` (`entryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='entries alias';

--
-- Dumping data for table `mdl_glossary_alias`
--


/*!40000 ALTER TABLE `mdl_glossary_alias` DISABLE KEYS */;
LOCK TABLES `mdl_glossary_alias` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary_alias` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary_categories`
--

DROP TABLE IF EXISTS `mdl_glossary_categories`;
CREATE TABLE `mdl_glossary_categories` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `glossaryid` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `usedynalink` tinyint(2) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `mdl_gloscate_glo_ix` (`glossaryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='all categories for glossary entries';

--
-- Dumping data for table `mdl_glossary_categories`
--


/*!40000 ALTER TABLE `mdl_glossary_categories` DISABLE KEYS */;
LOCK TABLES `mdl_glossary_categories` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary_categories` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary_comments`
--

DROP TABLE IF EXISTS `mdl_glossary_comments`;
CREATE TABLE `mdl_glossary_comments` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `entryid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `entrycomment` text NOT NULL,
  `format` tinyint(2) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_gloscomm_use_ix` (`userid`),
  KEY `mdl_gloscomm_ent_ix` (`entryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='comments on glossary entries';

--
-- Dumping data for table `mdl_glossary_comments`
--


/*!40000 ALTER TABLE `mdl_glossary_comments` DISABLE KEYS */;
LOCK TABLES `mdl_glossary_comments` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary_comments` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary_entries`
--

DROP TABLE IF EXISTS `mdl_glossary_entries`;
CREATE TABLE `mdl_glossary_entries` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `glossaryid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `concept` varchar(255) NOT NULL default '',
  `definition` text NOT NULL,
  `format` tinyint(2) unsigned NOT NULL default '0',
  `attachment` varchar(100) NOT NULL default '',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `teacherentry` tinyint(2) unsigned NOT NULL default '0',
  `sourceglossaryid` bigint(10) unsigned NOT NULL default '0',
  `usedynalink` tinyint(2) unsigned NOT NULL default '1',
  `casesensitive` tinyint(2) unsigned NOT NULL default '0',
  `fullmatch` tinyint(2) unsigned NOT NULL default '1',
  `approved` tinyint(2) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `mdl_glosentr_use_ix` (`userid`),
  KEY `mdl_glosentr_con_ix` (`concept`),
  KEY `mdl_glosentr_glo_ix` (`glossaryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='all glossary entries';

--
-- Dumping data for table `mdl_glossary_entries`
--


/*!40000 ALTER TABLE `mdl_glossary_entries` DISABLE KEYS */;
LOCK TABLES `mdl_glossary_entries` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary_entries` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary_entries_categories`
--

DROP TABLE IF EXISTS `mdl_glossary_entries_categories`;
CREATE TABLE `mdl_glossary_entries_categories` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `categoryid` bigint(10) unsigned NOT NULL default '0',
  `entryid` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_glosentrcate_cat_ix` (`categoryid`),
  KEY `mdl_glosentrcate_ent_ix` (`entryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='categories of each glossary entry';

--
-- Dumping data for table `mdl_glossary_entries_categories`
--


/*!40000 ALTER TABLE `mdl_glossary_entries_categories` DISABLE KEYS */;
LOCK TABLES `mdl_glossary_entries_categories` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary_entries_categories` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary_formats`
--

DROP TABLE IF EXISTS `mdl_glossary_formats`;
CREATE TABLE `mdl_glossary_formats` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `popupformatname` varchar(50) NOT NULL default '',
  `visible` tinyint(2) unsigned NOT NULL default '1',
  `showgroup` tinyint(2) unsigned NOT NULL default '1',
  `defaultmode` varchar(50) NOT NULL default '',
  `defaulthook` varchar(50) NOT NULL default '',
  `sortkey` varchar(50) NOT NULL default '',
  `sortorder` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Setting of the display formats';

--
-- Dumping data for table `mdl_glossary_formats`
--


/*!40000 ALTER TABLE `mdl_glossary_formats` DISABLE KEYS */;
LOCK TABLES `mdl_glossary_formats` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary_formats` ENABLE KEYS */;

--
-- Table structure for table `mdl_glossary_ratings`
--

DROP TABLE IF EXISTS `mdl_glossary_ratings`;
CREATE TABLE `mdl_glossary_ratings` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `entryid` bigint(10) unsigned NOT NULL default '0',
  `time` bigint(10) unsigned NOT NULL default '0',
  `rating` smallint(4) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_glosrati_use_ix` (`userid`),
  KEY `mdl_glosrati_ent_ix` (`entryid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Contains user ratings for entries';

--
-- Dumping data for table `mdl_glossary_ratings`
--


/*!40000 ALTER TABLE `mdl_glossary_ratings` DISABLE KEYS */;
LOCK TABLES `mdl_glossary_ratings` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_glossary_ratings` ENABLE KEYS */;

--
-- Table structure for table `mdl_grade_category`
--

DROP TABLE IF EXISTS `mdl_grade_category`;
CREATE TABLE `mdl_grade_category` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `drop_x_lowest` bigint(10) unsigned NOT NULL default '0',
  `bonus_points` bigint(10) unsigned NOT NULL default '0',
  `hidden` bigint(10) unsigned NOT NULL default '0',
  `weight` decimal(5,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `mdl_gradcate_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to define categories to group activity grades';

--
-- Dumping data for table `mdl_grade_category`
--


/*!40000 ALTER TABLE `mdl_grade_category` DISABLE KEYS */;
LOCK TABLES `mdl_grade_category` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_grade_category` ENABLE KEYS */;

--
-- Table structure for table `mdl_grade_exceptions`
--

DROP TABLE IF EXISTS `mdl_grade_exceptions`;
CREATE TABLE `mdl_grade_exceptions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `grade_itemid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_gradexce_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='individual grades to be skipped for certain students';

--
-- Dumping data for table `mdl_grade_exceptions`
--


/*!40000 ALTER TABLE `mdl_grade_exceptions` DISABLE KEYS */;
LOCK TABLES `mdl_grade_exceptions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_grade_exceptions` ENABLE KEYS */;

--
-- Table structure for table `mdl_grade_item`
--

DROP TABLE IF EXISTS `mdl_grade_item`;
CREATE TABLE `mdl_grade_item` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `category` bigint(10) unsigned NOT NULL default '0',
  `modid` bigint(10) unsigned NOT NULL default '0',
  `cminstance` bigint(10) unsigned NOT NULL default '0',
  `scale_grade` double(11,10) NOT NULL default '1.0000000000',
  `extra_credit` bigint(10) unsigned NOT NULL default '0',
  `sort_order` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_graditem_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='items to be graded';

--
-- Dumping data for table `mdl_grade_item`
--


/*!40000 ALTER TABLE `mdl_grade_item` DISABLE KEYS */;
LOCK TABLES `mdl_grade_item` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_grade_item` ENABLE KEYS */;

--
-- Table structure for table `mdl_grade_letter`
--

DROP TABLE IF EXISTS `mdl_grade_letter`;
CREATE TABLE `mdl_grade_letter` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `letter` varchar(8) NOT NULL default 'NA',
  `grade_high` decimal(5,2) NOT NULL default '100.00',
  `grade_low` decimal(5,2) NOT NULL default '0.00',
  PRIMARY KEY  (`id`),
  KEY `mdl_gradlett_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to convert numerical grades to letter grades';

--
-- Dumping data for table `mdl_grade_letter`
--


/*!40000 ALTER TABLE `mdl_grade_letter` DISABLE KEYS */;
LOCK TABLES `mdl_grade_letter` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_grade_letter` ENABLE KEYS */;

--
-- Table structure for table `mdl_grade_preferences`
--

DROP TABLE IF EXISTS `mdl_grade_preferences`;
CREATE TABLE `mdl_grade_preferences` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `preference` bigint(10) NOT NULL default '0',
  `value` bigint(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_gradpref_coupre_uix` (`courseid`,`preference`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Preferences of the gradebook for each course';

--
-- Dumping data for table `mdl_grade_preferences`
--


/*!40000 ALTER TABLE `mdl_grade_preferences` DISABLE KEYS */;
LOCK TABLES `mdl_grade_preferences` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_grade_preferences` ENABLE KEYS */;

--
-- Table structure for table `mdl_groups`
--

DROP TABLE IF EXISTS `mdl_groups`;
CREATE TABLE `mdl_groups` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(254) NOT NULL default '',
  `description` text NOT NULL,
  `password` varchar(50) NOT NULL default '',
  `lang` varchar(10) NOT NULL default 'en',
  `theme` varchar(50) NOT NULL default '',
  `picture` bigint(10) unsigned NOT NULL default '0',
  `hidepicture` tinyint(2) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_grou_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Each record is a group in a course';

--
-- Dumping data for table `mdl_groups`
--


/*!40000 ALTER TABLE `mdl_groups` DISABLE KEYS */;
LOCK TABLES `mdl_groups` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_groups` ENABLE KEYS */;

--
-- Table structure for table `mdl_groups_members`
--

DROP TABLE IF EXISTS `mdl_groups_members`;
CREATE TABLE `mdl_groups_members` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `groupid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `timeadded` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_groumemb_gro_ix` (`groupid`),
  KEY `mdl_groumemb_use_ix` (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Lists memberships of users to groups';

--
-- Dumping data for table `mdl_groups_members`
--


/*!40000 ALTER TABLE `mdl_groups_members` DISABLE KEYS */;
LOCK TABLES `mdl_groups_members` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_groups_members` ENABLE KEYS */;

--
-- Table structure for table `mdl_hotpot`
--

DROP TABLE IF EXISTS `mdl_hotpot`;
CREATE TABLE `mdl_hotpot` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `summary` text NOT NULL,
  `timeopen` bigint(10) unsigned NOT NULL default '0',
  `timeclose` bigint(10) unsigned NOT NULL default '0',
  `location` smallint(4) unsigned NOT NULL default '0',
  `reference` varchar(255) NOT NULL default '',
  `outputformat` smallint(4) unsigned NOT NULL default '1',
  `navigation` smallint(4) unsigned NOT NULL default '1',
  `studentfeedback` smallint(4) unsigned NOT NULL default '0',
  `studentfeedbackurl` varchar(255) NOT NULL default '',
  `forceplugins` smallint(4) unsigned NOT NULL default '0',
  `shownextquiz` smallint(4) unsigned NOT NULL default '0',
  `review` smallint(4) NOT NULL default '0',
  `grade` bigint(10) NOT NULL default '0',
  `grademethod` smallint(4) NOT NULL default '1',
  `attempts` mediumint(6) NOT NULL default '0',
  `password` varchar(255) NOT NULL default '',
  `subnet` varchar(255) NOT NULL default '',
  `clickreporting` smallint(4) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='details about Hot Potatoes quizzes';

--
-- Dumping data for table `mdl_hotpot`
--


/*!40000 ALTER TABLE `mdl_hotpot` DISABLE KEYS */;
LOCK TABLES `mdl_hotpot` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_hotpot` ENABLE KEYS */;

--
-- Table structure for table `mdl_hotpot_attempts`
--

DROP TABLE IF EXISTS `mdl_hotpot_attempts`;
CREATE TABLE `mdl_hotpot_attempts` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `hotpot` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `starttime` bigint(10) unsigned NOT NULL default '0',
  `endtime` bigint(10) unsigned NOT NULL default '0',
  `score` mediumint(6) unsigned NOT NULL default '0',
  `penalties` mediumint(6) unsigned NOT NULL default '0',
  `attempt` mediumint(6) unsigned NOT NULL default '0',
  `timestart` bigint(10) unsigned NOT NULL default '0',
  `timefinish` bigint(10) unsigned NOT NULL default '0',
  `status` smallint(4) unsigned NOT NULL default '1',
  `clickreportid` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_hotpatte_use_ix` (`userid`),
  KEY `mdl_hotpatte_hot_ix` (`hotpot`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='details about Hot Potatoes quiz attempts';

--
-- Dumping data for table `mdl_hotpot_attempts`
--


/*!40000 ALTER TABLE `mdl_hotpot_attempts` DISABLE KEYS */;
LOCK TABLES `mdl_hotpot_attempts` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_hotpot_attempts` ENABLE KEYS */;

--
-- Table structure for table `mdl_hotpot_details`
--

DROP TABLE IF EXISTS `mdl_hotpot_details`;
CREATE TABLE `mdl_hotpot_details` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `attempt` bigint(10) unsigned NOT NULL default '0',
  `details` text,
  PRIMARY KEY  (`id`),
  KEY `mdl_hotpdeta_att_ix` (`attempt`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='raw details (as XML) of Hot Potatoes quiz attempts';

--
-- Dumping data for table `mdl_hotpot_details`
--


/*!40000 ALTER TABLE `mdl_hotpot_details` DISABLE KEYS */;
LOCK TABLES `mdl_hotpot_details` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_hotpot_details` ENABLE KEYS */;

--
-- Table structure for table `mdl_hotpot_questions`
--

DROP TABLE IF EXISTS `mdl_hotpot_questions`;
CREATE TABLE `mdl_hotpot_questions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` text NOT NULL,
  `type` smallint(4) unsigned NOT NULL default '0',
  `text` bigint(10) unsigned NOT NULL default '0',
  `hotpot` bigint(10) unsigned NOT NULL default '0',
  `md5key` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_hotpques_md5_ix` (`md5key`),
  KEY `mdl_hotpques_hot_ix` (`hotpot`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='details about questions in Hot Potatoes quiz attempts';

--
-- Dumping data for table `mdl_hotpot_questions`
--


/*!40000 ALTER TABLE `mdl_hotpot_questions` DISABLE KEYS */;
LOCK TABLES `mdl_hotpot_questions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_hotpot_questions` ENABLE KEYS */;

--
-- Table structure for table `mdl_hotpot_responses`
--

DROP TABLE IF EXISTS `mdl_hotpot_responses`;
CREATE TABLE `mdl_hotpot_responses` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `attempt` bigint(10) unsigned NOT NULL default '0',
  `question` bigint(10) unsigned NOT NULL default '0',
  `score` mediumint(6) NOT NULL default '0',
  `weighting` mediumint(6) NOT NULL default '0',
  `correct` varchar(255) NOT NULL default '',
  `wrong` varchar(255) NOT NULL default '',
  `ignored` varchar(255) NOT NULL default '',
  `hints` mediumint(6) unsigned NOT NULL default '0',
  `clues` mediumint(6) unsigned NOT NULL default '0',
  `checks` mediumint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_hotpresp_att_ix` (`attempt`),
  KEY `mdl_hotpresp_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='details about responses in Hot Potatoes quiz attempts';

--
-- Dumping data for table `mdl_hotpot_responses`
--


/*!40000 ALTER TABLE `mdl_hotpot_responses` DISABLE KEYS */;
LOCK TABLES `mdl_hotpot_responses` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_hotpot_responses` ENABLE KEYS */;

--
-- Table structure for table `mdl_hotpot_strings`
--

DROP TABLE IF EXISTS `mdl_hotpot_strings`;
CREATE TABLE `mdl_hotpot_strings` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `string` text NOT NULL,
  `md5key` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_hotpstri_md5_ix` (`md5key`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='strings used in Hot Potatoes questions and responses';

--
-- Dumping data for table `mdl_hotpot_strings`
--


/*!40000 ALTER TABLE `mdl_hotpot_strings` DISABLE KEYS */;
LOCK TABLES `mdl_hotpot_strings` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_hotpot_strings` ENABLE KEYS */;

--
-- Table structure for table `mdl_journal`
--

DROP TABLE IF EXISTS `mdl_journal`;
CREATE TABLE `mdl_journal` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `intro` text NOT NULL,
  `introformat` tinyint(2) NOT NULL default '0',
  `days` mediumint(5) unsigned NOT NULL default '7',
  `assessed` bigint(10) NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_jour_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='data for each journal';

--
-- Dumping data for table `mdl_journal`
--


/*!40000 ALTER TABLE `mdl_journal` DISABLE KEYS */;
LOCK TABLES `mdl_journal` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_journal` ENABLE KEYS */;

--
-- Table structure for table `mdl_journal_entries`
--

DROP TABLE IF EXISTS `mdl_journal_entries`;
CREATE TABLE `mdl_journal_entries` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `journal` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `modified` bigint(10) unsigned NOT NULL default '0',
  `text` text NOT NULL,
  `format` tinyint(2) NOT NULL default '0',
  `rating` bigint(10) default '0',
  `entrycomment` text,
  `teacher` bigint(10) unsigned NOT NULL default '0',
  `timemarked` bigint(10) unsigned NOT NULL default '0',
  `mailed` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_jourentr_use_ix` (`userid`),
  KEY `mdl_jourentr_jou_ix` (`journal`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='All the journal entries of all people';

--
-- Dumping data for table `mdl_journal_entries`
--


/*!40000 ALTER TABLE `mdl_journal_entries` DISABLE KEYS */;
LOCK TABLES `mdl_journal_entries` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_journal_entries` ENABLE KEYS */;

--
-- Table structure for table `mdl_label`
--

DROP TABLE IF EXISTS `mdl_label`;
CREATE TABLE `mdl_label` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_labe_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines labels';

--
-- Dumping data for table `mdl_label`
--


/*!40000 ALTER TABLE `mdl_label` DISABLE KEYS */;
LOCK TABLES `mdl_label` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_label` ENABLE KEYS */;

--
-- Table structure for table `mdl_lams`
--

DROP TABLE IF EXISTS `mdl_lams`;
CREATE TABLE `mdl_lams` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `introduction` text NOT NULL,
  `learning_session_id` bigint(20) default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_lams_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='LAMS activity';

--
-- Dumping data for table `mdl_lams`
--


/*!40000 ALTER TABLE `mdl_lams` DISABLE KEYS */;
LOCK TABLES `mdl_lams` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lams` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson`
--

DROP TABLE IF EXISTS `mdl_lesson`;
CREATE TABLE `mdl_lesson` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `practice` smallint(3) unsigned NOT NULL default '0',
  `modattempts` smallint(3) unsigned NOT NULL default '0',
  `usepassword` smallint(3) unsigned NOT NULL default '0',
  `password` varchar(32) NOT NULL default '',
  `dependency` bigint(10) unsigned NOT NULL default '0',
  `conditions` text NOT NULL,
  `grade` smallint(3) NOT NULL default '0',
  `custom` smallint(3) unsigned NOT NULL default '0',
  `ongoing` smallint(3) unsigned NOT NULL default '0',
  `usemaxgrade` smallint(3) NOT NULL default '0',
  `maxanswers` smallint(3) unsigned NOT NULL default '4',
  `maxattempts` smallint(3) unsigned NOT NULL default '5',
  `review` smallint(3) unsigned NOT NULL default '0',
  `nextpagedefault` smallint(3) unsigned NOT NULL default '0',
  `feedback` smallint(3) unsigned NOT NULL default '1',
  `minquestions` smallint(3) unsigned NOT NULL default '0',
  `maxpages` smallint(3) unsigned NOT NULL default '0',
  `timed` smallint(3) unsigned NOT NULL default '0',
  `maxtime` bigint(10) unsigned NOT NULL default '0',
  `retake` smallint(3) unsigned NOT NULL default '1',
  `activitylink` bigint(10) unsigned NOT NULL default '0',
  `mediafile` varchar(255) NOT NULL default '',
  `mediaheight` bigint(10) unsigned NOT NULL default '100',
  `mediawidth` bigint(10) unsigned NOT NULL default '650',
  `mediaclose` smallint(3) unsigned NOT NULL default '0',
  `slideshow` smallint(3) unsigned NOT NULL default '0',
  `width` bigint(10) unsigned NOT NULL default '640',
  `height` bigint(10) unsigned NOT NULL default '480',
  `bgcolor` varchar(7) NOT NULL default '#FFFFFF',
  `displayleft` smallint(3) unsigned NOT NULL default '0',
  `displayleftif` smallint(3) unsigned NOT NULL default '0',
  `progressbar` smallint(3) unsigned NOT NULL default '0',
  `highscores` smallint(3) unsigned NOT NULL default '0',
  `maxhighscores` bigint(10) unsigned NOT NULL default '0',
  `available` bigint(10) unsigned NOT NULL default '0',
  `deadline` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_less_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines lesson';

--
-- Dumping data for table `mdl_lesson`
--


/*!40000 ALTER TABLE `mdl_lesson` DISABLE KEYS */;
LOCK TABLES `mdl_lesson` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_answers`
--

DROP TABLE IF EXISTS `mdl_lesson_answers`;
CREATE TABLE `mdl_lesson_answers` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `lessonid` bigint(10) unsigned NOT NULL default '0',
  `pageid` bigint(10) unsigned NOT NULL default '0',
  `jumpto` bigint(11) NOT NULL default '0',
  `grade` smallint(3) unsigned NOT NULL default '0',
  `score` bigint(10) NOT NULL default '0',
  `flags` smallint(3) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `answer` text NOT NULL,
  `response` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_lessansw_les_ix` (`lessonid`),
  KEY `mdl_lessansw_pag_ix` (`pageid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines lesson_answers';

--
-- Dumping data for table `mdl_lesson_answers`
--


/*!40000 ALTER TABLE `mdl_lesson_answers` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_answers` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_answers` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_attempts`
--

DROP TABLE IF EXISTS `mdl_lesson_attempts`;
CREATE TABLE `mdl_lesson_attempts` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `lessonid` bigint(10) unsigned NOT NULL default '0',
  `pageid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `answerid` bigint(10) unsigned NOT NULL default '0',
  `retry` smallint(3) unsigned NOT NULL default '0',
  `correct` bigint(10) unsigned NOT NULL default '0',
  `useranswer` text NOT NULL,
  `timeseen` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_lessatte_use_ix` (`userid`),
  KEY `mdl_lessatte_les_ix` (`lessonid`),
  KEY `mdl_lessatte_pag_ix` (`pageid`),
  KEY `mdl_lessatte_ans_ix` (`answerid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines lesson_attempts';

--
-- Dumping data for table `mdl_lesson_attempts`
--


/*!40000 ALTER TABLE `mdl_lesson_attempts` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_attempts` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_attempts` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_branch`
--

DROP TABLE IF EXISTS `mdl_lesson_branch`;
CREATE TABLE `mdl_lesson_branch` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `lessonid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `pageid` bigint(10) unsigned NOT NULL default '0',
  `retry` bigint(10) unsigned NOT NULL default '0',
  `flag` smallint(3) unsigned NOT NULL default '0',
  `timeseen` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_lessbran_use_ix` (`userid`),
  KEY `mdl_lessbran_les_ix` (`lessonid`),
  KEY `mdl_lessbran_pag_ix` (`pageid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='branches for each lesson/user';

--
-- Dumping data for table `mdl_lesson_branch`
--


/*!40000 ALTER TABLE `mdl_lesson_branch` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_branch` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_branch` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_default`
--

DROP TABLE IF EXISTS `mdl_lesson_default`;
CREATE TABLE `mdl_lesson_default` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `practice` smallint(3) unsigned NOT NULL default '0',
  `modattempts` smallint(3) unsigned NOT NULL default '0',
  `usepassword` smallint(3) unsigned NOT NULL default '0',
  `password` varchar(32) NOT NULL default '',
  `conditions` text NOT NULL,
  `grade` smallint(3) NOT NULL default '0',
  `custom` smallint(3) unsigned NOT NULL default '0',
  `ongoing` smallint(3) unsigned NOT NULL default '0',
  `usemaxgrade` smallint(3) unsigned NOT NULL default '0',
  `maxanswers` smallint(3) unsigned NOT NULL default '4',
  `maxattempts` smallint(3) unsigned NOT NULL default '5',
  `review` smallint(3) unsigned NOT NULL default '0',
  `nextpagedefault` smallint(3) unsigned NOT NULL default '0',
  `feedback` smallint(3) unsigned NOT NULL default '1',
  `minquestions` smallint(3) unsigned NOT NULL default '0',
  `maxpages` smallint(3) unsigned NOT NULL default '0',
  `timed` smallint(3) unsigned NOT NULL default '0',
  `maxtime` bigint(10) unsigned NOT NULL default '0',
  `retake` smallint(3) unsigned NOT NULL default '1',
  `mediaheight` bigint(10) unsigned NOT NULL default '100',
  `mediawidth` bigint(10) unsigned NOT NULL default '650',
  `mediaclose` smallint(3) unsigned NOT NULL default '0',
  `slideshow` smallint(3) unsigned NOT NULL default '0',
  `width` bigint(10) unsigned NOT NULL default '640',
  `height` bigint(10) unsigned NOT NULL default '480',
  `bgcolor` varchar(7) default '#FFFFFF',
  `displayleft` smallint(3) unsigned NOT NULL default '0',
  `displayleftif` smallint(3) unsigned NOT NULL default '0',
  `progressbar` smallint(3) unsigned NOT NULL default '0',
  `highscores` smallint(3) unsigned NOT NULL default '0',
  `maxhighscores` bigint(10) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines lesson_default';

--
-- Dumping data for table `mdl_lesson_default`
--


/*!40000 ALTER TABLE `mdl_lesson_default` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_default` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_default` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_grades`
--

DROP TABLE IF EXISTS `mdl_lesson_grades`;
CREATE TABLE `mdl_lesson_grades` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `lessonid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `grade` double unsigned NOT NULL default '0',
  `late` smallint(3) unsigned NOT NULL default '0',
  `completed` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_lessgrad_use_ix` (`userid`),
  KEY `mdl_lessgrad_les_ix` (`lessonid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines lesson_grades';

--
-- Dumping data for table `mdl_lesson_grades`
--


/*!40000 ALTER TABLE `mdl_lesson_grades` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_grades` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_grades` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_high_scores`
--

DROP TABLE IF EXISTS `mdl_lesson_high_scores`;
CREATE TABLE `mdl_lesson_high_scores` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `lessonid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `gradeid` bigint(10) unsigned NOT NULL default '0',
  `nickname` varchar(5) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_lesshighscor_use_ix` (`userid`),
  KEY `mdl_lesshighscor_les_ix` (`lessonid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='high scores for each lesson';

--
-- Dumping data for table `mdl_lesson_high_scores`
--


/*!40000 ALTER TABLE `mdl_lesson_high_scores` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_high_scores` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_high_scores` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_pages`
--

DROP TABLE IF EXISTS `mdl_lesson_pages`;
CREATE TABLE `mdl_lesson_pages` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `lessonid` bigint(10) unsigned NOT NULL default '0',
  `prevpageid` bigint(10) unsigned NOT NULL default '0',
  `nextpageid` bigint(10) unsigned NOT NULL default '0',
  `qtype` smallint(3) unsigned NOT NULL default '0',
  `qoption` smallint(3) unsigned NOT NULL default '0',
  `layout` smallint(3) unsigned NOT NULL default '1',
  `display` smallint(3) unsigned NOT NULL default '1',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `contents` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_lesspage_les_ix` (`lessonid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines lesson_pages';

--
-- Dumping data for table `mdl_lesson_pages`
--


/*!40000 ALTER TABLE `mdl_lesson_pages` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_pages` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_pages` ENABLE KEYS */;

--
-- Table structure for table `mdl_lesson_timer`
--

DROP TABLE IF EXISTS `mdl_lesson_timer`;
CREATE TABLE `mdl_lesson_timer` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `lessonid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `starttime` bigint(10) unsigned NOT NULL default '0',
  `lessontime` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_lesstime_use_ix` (`userid`),
  KEY `mdl_lesstime_les_ix` (`lessonid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='lesson timer for each lesson';

--
-- Dumping data for table `mdl_lesson_timer`
--


/*!40000 ALTER TABLE `mdl_lesson_timer` DISABLE KEYS */;
LOCK TABLES `mdl_lesson_timer` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_lesson_timer` ENABLE KEYS */;

--
-- Table structure for table `mdl_log`
--

DROP TABLE IF EXISTS `mdl_log`;
CREATE TABLE `mdl_log` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `time` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `ip` varchar(15) NOT NULL default '',
  `course` bigint(10) unsigned NOT NULL default '0',
  `module` varchar(20) NOT NULL default '',
  `cmid` bigint(10) unsigned NOT NULL default '0',
  `action` varchar(40) NOT NULL default '',
  `url` varchar(100) NOT NULL default '',
  `info` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_log_timcoumodact_ix` (`time`,`course`,`module`,`action`),
  KEY `mdl_log_coumodact_ix` (`course`,`module`,`action`),
  KEY `mdl_log_couuse_ix` (`course`,`userid`),
  KEY `mdl_log_use_ix` (`userid`),
  KEY `mdl_log_inf_ix` (`info`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Every action is logged as far as possible';

--
-- Dumping data for table `mdl_log`
--


/*!40000 ALTER TABLE `mdl_log` DISABLE KEYS */;
LOCK TABLES `mdl_log` WRITE;
INSERT INTO `mdl_log` VALUES (1,1172451550,2,'192.168.0.3',1,'user',0,'update','view.php?id=2&course=1',' '),
(2,1172451706,2,'192.168.0.3',1,'course',0,'view','view.php?id=1','1'),
(3,1172451827,2,'192.168.0.3',1,'course',0,'new','view.php?id=2','Moodle (ID 2)'),
(4,1172451867,2,'192.168.0.3',2,'course',0,'view','view.php?id=2','2'),
(5,1172451891,2,'192.168.0.3',1,'course',0,'view','view.php?id=1','1'),
(6,1172453632,2,'192.168.0.3',1,'course',0,'view','view.php?id=1','1'),
(7,1172454186,2,'192.168.0.3',1,'course',0,'view','view.php?id=1','1'),
(8,1172454197,2,'192.168.0.3',1,'user',0,'logout','view.php?id=2&course=1','2');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_log` ENABLE KEYS */;

--
-- Table structure for table `mdl_log_display`
--

DROP TABLE IF EXISTS `mdl_log_display`;
CREATE TABLE `mdl_log_display` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `module` varchar(20) NOT NULL default '',
  `action` varchar(40) NOT NULL default '',
  `mtable` varchar(30) NOT NULL default '',
  `field` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_logdisp_modact_uix` (`module`,`action`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='For a particular module/action, specifies a moodle table/fie';

--
-- Dumping data for table `mdl_log_display`
--


/*!40000 ALTER TABLE `mdl_log_display` DISABLE KEYS */;
LOCK TABLES `mdl_log_display` WRITE;
INSERT INTO `mdl_log_display` VALUES (1,'user','view','user','CONCAT(firstname,\' \',lastname)'),
(2,'course','user report','user','CONCAT(firstname,\' \',lastname)'),
(3,'course','view','course','fullname'),
(4,'course','update','course','fullname'),
(5,'course','enrol','course','fullname'),
(6,'course','report log','course','fullname'),
(7,'course','report live','course','fullname'),
(8,'course','report outline','course','fullname'),
(9,'course','report participation','course','fullname'),
(10,'course','report stats','course','fullname'),
(11,'message','write','user','CONCAT(firstname,\' \',lastname)'),
(12,'message','read','user','CONCAT(firstname,\' \',lastname)'),
(13,'message','add contact','user','CONCAT(firstname,\' \',lastname)'),
(14,'message','remove contact','user','CONCAT(firstname,\' \',lastname)'),
(15,'message','block contact','user','CONCAT(firstname,\' \',lastname)'),
(16,'message','unblock contact','user','CONCAT(firstname,\' \',lastname)'),
(17,'assignment','view','assignment','name'),
(18,'assignment','add','assignment','name'),
(19,'assignment','update','assignment','name'),
(20,'assignment','view submission','assignment','name'),
(21,'assignment','upload','assignment','name'),
(22,'chat','view','chat','name'),
(23,'chat','add','chat','name'),
(24,'chat','update','chat','name'),
(25,'chat','report','chat','name'),
(26,'chat','talk','chat','name'),
(27,'choice','view','choice','name'),
(28,'choice','update','choice','name'),
(29,'choice','add','choice','name'),
(30,'choice','report','choice','name'),
(31,'choice','choose','choice','name'),
(32,'choice','choose again','choice','name'),
(33,'data','view','data','name'),
(34,'data','add','data','name'),
(35,'data','update','data','name'),
(36,'data','record delete','data','name'),
(37,'data','fields add','data_fields','name'),
(38,'data','fields update','data_fields','name'),
(39,'data','templates saved','data','name'),
(40,'data','templates def','data','name'),
(41,'forum','add','forum','name'),
(42,'forum','update','forum','name'),
(43,'forum','add discussion','forum_discussions','name'),
(44,'forum','add post','forum_posts','subject'),
(45,'forum','update post','forum_posts','subject'),
(46,'forum','user report','user','CONCAT(firstname,\' \',lastname)'),
(47,'forum','move discussion','forum_discussions','name'),
(48,'forum','view subscribers','forum','name'),
(49,'forum','view discussion','forum_discussions','name'),
(50,'forum','view forum','forum','name'),
(51,'forum','subscribe','forum','name'),
(52,'forum','unsubscribe','forum','name'),
(53,'glossary','add','glossary','name'),
(54,'glossary','update','glossary','name'),
(55,'glossary','view','glossary','name'),
(56,'glossary','view all','glossary','name'),
(57,'glossary','add entry','glossary','name'),
(58,'glossary','update entry','glossary','name'),
(59,'glossary','add category','glossary','name'),
(60,'glossary','update category','glossary','name'),
(61,'glossary','delete category','glossary','name'),
(62,'glossary','add comment','glossary','name'),
(63,'glossary','update comment','glossary','name'),
(64,'glossary','delete comment','glossary','name'),
(65,'glossary','approve entry','glossary','name'),
(66,'glossary','view entry','glossary_entries','concept'),
(67,'journal','view','journal','name'),
(68,'journal','add entry','journal','name'),
(69,'journal','update entry','journal','name'),
(70,'journal','view responses','journal','name'),
(71,'label','add','quiz','name'),
(72,'label','update','quiz','name'),
(73,'lesson','start','lesson','name'),
(74,'lesson','end','lesson','name'),
(75,'lesson','view','lesson_pages','title'),
(76,'quiz','add','quiz','name'),
(77,'quiz','update','quiz','name'),
(78,'quiz','view','quiz','name'),
(79,'quiz','report','quiz','name'),
(80,'quiz','attempt','quiz','name'),
(81,'quiz','submit','quiz','name'),
(82,'quiz','review','quiz','name'),
(83,'quiz','editquestions','quiz','name'),
(84,'quiz','preview','quiz','name'),
(85,'quiz','start attempt','quiz','name'),
(86,'quiz','close attempt','quiz','name'),
(87,'quiz','continue attempt','quiz','name'),
(88,'resource','view','resource','name'),
(89,'resource','update','resource','name'),
(90,'resource','add','resource','name'),
(91,'scorm','view','scorm','name'),
(92,'scorm','review','scorm','name'),
(93,'scorm','update','scorm','name'),
(94,'scorm','add','scorm','name'),
(95,'survey','add','survey','name'),
(96,'survey','update','survey','name'),
(97,'survey','download','survey','name'),
(98,'survey','view form','survey','name'),
(99,'survey','view graph','survey','name'),
(100,'survey','view report','survey','name'),
(101,'survey','submit','survey','name'),
(102,'workshop','assessments','workshop','name'),
(103,'workshop','close','workshop','name'),
(104,'workshop','display','workshop','name'),
(105,'workshop','resubmit','workshop','name'),
(106,'workshop','set up','workshop','name'),
(107,'workshop','submissions','workshop','name'),
(108,'workshop','view','workshop','name'),
(109,'workshop','update','workshop','name');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_log_display` ENABLE KEYS */;

--
-- Table structure for table `mdl_message`
--

DROP TABLE IF EXISTS `mdl_message`;
CREATE TABLE `mdl_message` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `useridfrom` bigint(10) NOT NULL default '0',
  `useridto` bigint(10) NOT NULL default '0',
  `message` text NOT NULL,
  `format` smallint(4) unsigned NOT NULL default '0',
  `timecreated` bigint(10) NOT NULL default '0',
  `messagetype` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_mess_use_ix` (`useridfrom`),
  KEY `mdl_mess_use2_ix` (`useridto`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all unread messages';

--
-- Dumping data for table `mdl_message`
--


/*!40000 ALTER TABLE `mdl_message` DISABLE KEYS */;
LOCK TABLES `mdl_message` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_message` ENABLE KEYS */;

--
-- Table structure for table `mdl_message_contacts`
--

DROP TABLE IF EXISTS `mdl_message_contacts`;
CREATE TABLE `mdl_message_contacts` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `contactid` bigint(10) unsigned NOT NULL default '0',
  `blocked` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_messcont_usecon_uix` (`userid`,`contactid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Maintains lists of relationships between users';

--
-- Dumping data for table `mdl_message_contacts`
--


/*!40000 ALTER TABLE `mdl_message_contacts` DISABLE KEYS */;
LOCK TABLES `mdl_message_contacts` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_message_contacts` ENABLE KEYS */;

--
-- Table structure for table `mdl_message_read`
--

DROP TABLE IF EXISTS `mdl_message_read`;
CREATE TABLE `mdl_message_read` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `useridfrom` bigint(10) NOT NULL default '0',
  `useridto` bigint(10) NOT NULL default '0',
  `message` text NOT NULL,
  `format` smallint(4) unsigned NOT NULL default '0',
  `timecreated` bigint(10) NOT NULL default '0',
  `timeread` bigint(10) NOT NULL default '0',
  `messagetype` varchar(50) NOT NULL default '',
  `mailed` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_messread_use_ix` (`useridfrom`),
  KEY `mdl_messread_use2_ix` (`useridto`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores all messages that have been read';

--
-- Dumping data for table `mdl_message_read`
--


/*!40000 ALTER TABLE `mdl_message_read` DISABLE KEYS */;
LOCK TABLES `mdl_message_read` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_message_read` ENABLE KEYS */;

--
-- Table structure for table `mdl_modules`
--

DROP TABLE IF EXISTS `mdl_modules`;
CREATE TABLE `mdl_modules` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(20) NOT NULL default '',
  `version` bigint(10) NOT NULL default '0',
  `cron` bigint(10) unsigned NOT NULL default '0',
  `lastcron` bigint(10) unsigned NOT NULL default '0',
  `search` varchar(255) NOT NULL default '',
  `visible` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `mdl_modu_nam_ix` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='modules available in the site';

--
-- Dumping data for table `mdl_modules`
--


/*!40000 ALTER TABLE `mdl_modules` DISABLE KEYS */;
LOCK TABLES `mdl_modules` WRITE;
INSERT INTO `mdl_modules` VALUES (1,'assignment',2006092800,60,0,'',1),
(2,'chat',2006091800,300,0,'',1),
(3,'choice',2006091201,0,0,'',1),
(4,'data',2006100201,60,0,'',1),
(5,'forum',2006092002,60,0,'',1),
(6,'glossary',2006091801,0,0,'',1),
(7,'hotpot',2006091201,0,0,'',0),
(8,'journal',2006092100,60,0,'',0),
(9,'label',2006091201,0,0,'',1),
(10,'lams',2006091201,0,0,'',0),
(11,'lesson',2006091801,0,0,'',1),
(12,'quiz',2006091901,0,0,'',1),
(13,'resource',2006091700,0,0,'',1),
(14,'scorm',2006102702,0,0,'',1),
(15,'survey',2006091201,0,0,'',1),
(16,'wiki',2006092602,3600,0,'',1),
(17,'workshop',2006091800,60,0,'',1);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_modules` ENABLE KEYS */;

--
-- Table structure for table `mdl_post`
--

DROP TABLE IF EXISTS `mdl_post`;
CREATE TABLE `mdl_post` (
  `id` bigint(10) NOT NULL auto_increment,
  `module` varchar(20) NOT NULL default '',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `groupid` bigint(10) unsigned NOT NULL default '0',
  `moduleid` bigint(10) unsigned NOT NULL default '0',
  `coursemoduleid` bigint(10) unsigned NOT NULL default '0',
  `subject` varchar(128) NOT NULL default '',
  `summary` longtext,
  `content` longtext,
  `uniquehash` varchar(128) NOT NULL default '',
  `rating` bigint(10) unsigned NOT NULL default '0',
  `format` bigint(10) unsigned NOT NULL default '0',
  `publishstate` enum('draft','site','public') NOT NULL default 'draft',
  `lastmodified` bigint(10) unsigned NOT NULL default '0',
  `created` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_post_iduse_uix` (`id`,`userid`),
  KEY `mdl_post_las_ix` (`lastmodified`),
  KEY `mdl_post_mod_ix` (`module`),
  KEY `mdl_post_sub_ix` (`subject`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Generic post table to hold data blog entries etc in differen';

--
-- Dumping data for table `mdl_post`
--


/*!40000 ALTER TABLE `mdl_post` DISABLE KEYS */;
LOCK TABLES `mdl_post` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_post` ENABLE KEYS */;

--
-- Table structure for table `mdl_question`
--

DROP TABLE IF EXISTS `mdl_question`;
CREATE TABLE `mdl_question` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `category` bigint(10) NOT NULL default '0',
  `parent` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `questiontext` text NOT NULL,
  `questiontextformat` tinyint(2) NOT NULL default '0',
  `image` varchar(255) NOT NULL default '',
  `generalfeedback` text NOT NULL,
  `defaultgrade` bigint(10) unsigned NOT NULL default '1',
  `penalty` double NOT NULL default '0.1',
  `qtype` varchar(20) NOT NULL default '',
  `length` bigint(10) unsigned NOT NULL default '1',
  `stamp` varchar(255) NOT NULL default '',
  `version` varchar(255) NOT NULL default '',
  `hidden` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_ques_cat_ix` (`category`),
  KEY `mdl_ques_par_ix` (`parent`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='The questions themselves';

--
-- Dumping data for table `mdl_question`
--


/*!40000 ALTER TABLE `mdl_question` DISABLE KEYS */;
LOCK TABLES `mdl_question` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_answers`
--

DROP TABLE IF EXISTS `mdl_question_answers`;
CREATE TABLE `mdl_question_answers` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `answer` text NOT NULL,
  `fraction` double NOT NULL default '0',
  `feedback` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_quesansw_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Answers, with a fractional grade (0-1) and feedback';

--
-- Dumping data for table `mdl_question_answers`
--


/*!40000 ALTER TABLE `mdl_question_answers` DISABLE KEYS */;
LOCK TABLES `mdl_question_answers` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_answers` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_attempts`
--

DROP TABLE IF EXISTS `mdl_question_attempts`;
CREATE TABLE `mdl_question_attempts` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `modulename` varchar(20) NOT NULL default 'quiz',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Student attempts. This table gets extended by the modules';

--
-- Dumping data for table `mdl_question_attempts`
--


/*!40000 ALTER TABLE `mdl_question_attempts` DISABLE KEYS */;
LOCK TABLES `mdl_question_attempts` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_attempts` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_calculated`
--

DROP TABLE IF EXISTS `mdl_question_calculated`;
CREATE TABLE `mdl_question_calculated` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `answer` bigint(10) unsigned NOT NULL default '0',
  `tolerance` varchar(20) NOT NULL default '0.0',
  `tolerancetype` bigint(10) NOT NULL default '1',
  `correctanswerlength` bigint(10) NOT NULL default '2',
  `correctanswerformat` bigint(10) NOT NULL default '2',
  PRIMARY KEY  (`id`),
  KEY `mdl_quescalc_ans_ix` (`answer`),
  KEY `mdl_quescalc_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Options for questions of type calculated';

--
-- Dumping data for table `mdl_question_calculated`
--


/*!40000 ALTER TABLE `mdl_question_calculated` DISABLE KEYS */;
LOCK TABLES `mdl_question_calculated` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_calculated` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_categories`
--

DROP TABLE IF EXISTS `mdl_question_categories`;
CREATE TABLE `mdl_question_categories` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `info` text NOT NULL,
  `publish` smallint(4) NOT NULL default '0',
  `stamp` varchar(255) NOT NULL default '',
  `parent` bigint(10) unsigned NOT NULL default '0',
  `sortorder` bigint(10) unsigned NOT NULL default '999',
  PRIMARY KEY  (`id`),
  KEY `mdl_quescate_cou_ix` (`course`),
  KEY `mdl_quescate_par_ix` (`parent`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Categories are for grouping questions';

--
-- Dumping data for table `mdl_question_categories`
--


/*!40000 ALTER TABLE `mdl_question_categories` DISABLE KEYS */;
LOCK TABLES `mdl_question_categories` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_categories` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_dataset_definitions`
--

DROP TABLE IF EXISTS `mdl_question_dataset_definitions`;
CREATE TABLE `mdl_question_dataset_definitions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `category` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `type` bigint(10) NOT NULL default '0',
  `options` varchar(255) NOT NULL default '',
  `itemcount` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesdatadefi_cat_ix` (`category`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Organises and stores properties for dataset items';

--
-- Dumping data for table `mdl_question_dataset_definitions`
--


/*!40000 ALTER TABLE `mdl_question_dataset_definitions` DISABLE KEYS */;
LOCK TABLES `mdl_question_dataset_definitions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_dataset_definitions` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_dataset_items`
--

DROP TABLE IF EXISTS `mdl_question_dataset_items`;
CREATE TABLE `mdl_question_dataset_items` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `definition` bigint(10) unsigned NOT NULL default '0',
  `itemnumber` bigint(10) unsigned NOT NULL default '0',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesdataitem_def_ix` (`definition`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Individual dataset items';

--
-- Dumping data for table `mdl_question_dataset_items`
--


/*!40000 ALTER TABLE `mdl_question_dataset_items` DISABLE KEYS */;
LOCK TABLES `mdl_question_dataset_items` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_dataset_items` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_datasets`
--

DROP TABLE IF EXISTS `mdl_question_datasets`;
CREATE TABLE `mdl_question_datasets` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `datasetdefinition` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesdata_quedat_ix` (`question`,`datasetdefinition`),
  KEY `mdl_quesdata_que_ix` (`question`),
  KEY `mdl_quesdata_dat_ix` (`datasetdefinition`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Many-many relation between questions and dataset definitions';

--
-- Dumping data for table `mdl_question_datasets`
--


/*!40000 ALTER TABLE `mdl_question_datasets` DISABLE KEYS */;
LOCK TABLES `mdl_question_datasets` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_datasets` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_match`
--

DROP TABLE IF EXISTS `mdl_question_match`;
CREATE TABLE `mdl_question_match` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `subquestions` varchar(255) NOT NULL default '',
  `shuffleanswers` smallint(4) NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesmatc_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines fixed matching questions';

--
-- Dumping data for table `mdl_question_match`
--


/*!40000 ALTER TABLE `mdl_question_match` DISABLE KEYS */;
LOCK TABLES `mdl_question_match` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_match` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_match_sub`
--

DROP TABLE IF EXISTS `mdl_question_match_sub`;
CREATE TABLE `mdl_question_match_sub` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `code` bigint(10) unsigned NOT NULL default '0',
  `question` bigint(10) unsigned NOT NULL default '0',
  `questiontext` text NOT NULL,
  `answertext` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesmatcsub_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines the subquestions that make up a matching question';

--
-- Dumping data for table `mdl_question_match_sub`
--


/*!40000 ALTER TABLE `mdl_question_match_sub` DISABLE KEYS */;
LOCK TABLES `mdl_question_match_sub` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_match_sub` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_multianswer`
--

DROP TABLE IF EXISTS `mdl_question_multianswer`;
CREATE TABLE `mdl_question_multianswer` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `sequence` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_quesmult_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Options for multianswer questions';

--
-- Dumping data for table `mdl_question_multianswer`
--


/*!40000 ALTER TABLE `mdl_question_multianswer` DISABLE KEYS */;
LOCK TABLES `mdl_question_multianswer` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_multianswer` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_multichoice`
--

DROP TABLE IF EXISTS `mdl_question_multichoice`;
CREATE TABLE `mdl_question_multichoice` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `layout` smallint(4) NOT NULL default '0',
  `answers` varchar(255) NOT NULL default '',
  `single` smallint(4) NOT NULL default '0',
  `shuffleanswers` smallint(4) NOT NULL default '1',
  `correctfeedback` text NOT NULL,
  `partiallycorrectfeedback` text NOT NULL,
  `incorrectfeedback` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_quesmult_que2_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Options for multiple choice questions';

--
-- Dumping data for table `mdl_question_multichoice`
--


/*!40000 ALTER TABLE `mdl_question_multichoice` DISABLE KEYS */;
LOCK TABLES `mdl_question_multichoice` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_multichoice` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_numerical`
--

DROP TABLE IF EXISTS `mdl_question_numerical`;
CREATE TABLE `mdl_question_numerical` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `answer` bigint(10) unsigned NOT NULL default '0',
  `tolerance` varchar(255) NOT NULL default '0.0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesnume_ans_ix` (`answer`),
  KEY `mdl_quesnume_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Options for numerical questions';

--
-- Dumping data for table `mdl_question_numerical`
--


/*!40000 ALTER TABLE `mdl_question_numerical` DISABLE KEYS */;
LOCK TABLES `mdl_question_numerical` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_numerical` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_numerical_units`
--

DROP TABLE IF EXISTS `mdl_question_numerical_units`;
CREATE TABLE `mdl_question_numerical_units` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `multiplier` decimal(40,20) NOT NULL default '1.00000000000000000000',
  `unit` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesnumeunit_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Optional unit options for numerical questions';

--
-- Dumping data for table `mdl_question_numerical_units`
--


/*!40000 ALTER TABLE `mdl_question_numerical_units` DISABLE KEYS */;
LOCK TABLES `mdl_question_numerical_units` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_numerical_units` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_randomsamatch`
--

DROP TABLE IF EXISTS `mdl_question_randomsamatch`;
CREATE TABLE `mdl_question_randomsamatch` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `choose` bigint(10) unsigned NOT NULL default '4',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesrand_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about a random short-answer matching question';

--
-- Dumping data for table `mdl_question_randomsamatch`
--


/*!40000 ALTER TABLE `mdl_question_randomsamatch` DISABLE KEYS */;
LOCK TABLES `mdl_question_randomsamatch` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_randomsamatch` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_rqp`
--

DROP TABLE IF EXISTS `mdl_question_rqp`;
CREATE TABLE `mdl_question_rqp` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `type` bigint(10) unsigned NOT NULL default '0',
  `source` longblob NOT NULL,
  `format` varchar(255) NOT NULL default '',
  `flags` smallint(3) unsigned NOT NULL default '0',
  `maxscore` bigint(10) unsigned NOT NULL default '1',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesrqp_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Options for RQP questions';

--
-- Dumping data for table `mdl_question_rqp`
--


/*!40000 ALTER TABLE `mdl_question_rqp` DISABLE KEYS */;
LOCK TABLES `mdl_question_rqp` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_rqp` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_rqp_servers`
--

DROP TABLE IF EXISTS `mdl_question_rqp_servers`;
CREATE TABLE `mdl_question_rqp_servers` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `typeid` bigint(10) unsigned NOT NULL default '0',
  `url` varchar(255) NOT NULL default '',
  `can_render` tinyint(2) unsigned NOT NULL default '0',
  `can_author` tinyint(2) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesrqpserv_typ_ix` (`typeid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Information about RQP servers';

--
-- Dumping data for table `mdl_question_rqp_servers`
--


/*!40000 ALTER TABLE `mdl_question_rqp_servers` DISABLE KEYS */;
LOCK TABLES `mdl_question_rqp_servers` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_rqp_servers` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_rqp_states`
--

DROP TABLE IF EXISTS `mdl_question_rqp_states`;
CREATE TABLE `mdl_question_rqp_states` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `stateid` bigint(10) unsigned NOT NULL default '0',
  `responses` text NOT NULL,
  `persistent_data` text NOT NULL,
  `template_vars` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='RQP question type specific state information';

--
-- Dumping data for table `mdl_question_rqp_states`
--


/*!40000 ALTER TABLE `mdl_question_rqp_states` DISABLE KEYS */;
LOCK TABLES `mdl_question_rqp_states` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_rqp_states` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_rqp_types`
--

DROP TABLE IF EXISTS `mdl_question_rqp_types`;
CREATE TABLE `mdl_question_rqp_types` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_quesrqptype_nam_uix` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='RQP question types';

--
-- Dumping data for table `mdl_question_rqp_types`
--


/*!40000 ALTER TABLE `mdl_question_rqp_types` DISABLE KEYS */;
LOCK TABLES `mdl_question_rqp_types` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_rqp_types` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_sessions`
--

DROP TABLE IF EXISTS `mdl_question_sessions`;
CREATE TABLE `mdl_question_sessions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `attemptid` bigint(10) unsigned NOT NULL default '0',
  `questionid` bigint(10) unsigned NOT NULL default '0',
  `newest` bigint(10) unsigned NOT NULL default '0',
  `newgraded` bigint(10) unsigned NOT NULL default '0',
  `sumpenalty` double NOT NULL default '0',
  `manualcomment` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_quessess_attque_uix` (`attemptid`,`questionid`),
  KEY `mdl_quessess_att_ix` (`attemptid`),
  KEY `mdl_quessess_que_ix` (`questionid`),
  KEY `mdl_quessess_new_ix` (`newest`),
  KEY `mdl_quessess_new2_ix` (`newgraded`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Gives ids of the newest open and newest graded states';

--
-- Dumping data for table `mdl_question_sessions`
--


/*!40000 ALTER TABLE `mdl_question_sessions` DISABLE KEYS */;
LOCK TABLES `mdl_question_sessions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_sessions` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_shortanswer`
--

DROP TABLE IF EXISTS `mdl_question_shortanswer`;
CREATE TABLE `mdl_question_shortanswer` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `answers` varchar(255) NOT NULL default '',
  `usecase` tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesshor_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Options for short answer questions';

--
-- Dumping data for table `mdl_question_shortanswer`
--


/*!40000 ALTER TABLE `mdl_question_shortanswer` DISABLE KEYS */;
LOCK TABLES `mdl_question_shortanswer` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_shortanswer` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_states`
--

DROP TABLE IF EXISTS `mdl_question_states`;
CREATE TABLE `mdl_question_states` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `attempt` bigint(10) unsigned NOT NULL default '0',
  `question` bigint(10) unsigned NOT NULL default '0',
  `originalquestion` bigint(10) unsigned NOT NULL default '0',
  `seq_number` mediumint(6) unsigned NOT NULL default '0',
  `answer` text NOT NULL,
  `timestamp` bigint(10) unsigned NOT NULL default '0',
  `event` smallint(4) unsigned NOT NULL default '0',
  `grade` double NOT NULL default '0',
  `raw_grade` double NOT NULL default '0',
  `penalty` double NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quesstat_att_ix` (`attempt`),
  KEY `mdl_quesstat_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores user responses to an attempt, and percentage grades';

--
-- Dumping data for table `mdl_question_states`
--


/*!40000 ALTER TABLE `mdl_question_states` DISABLE KEYS */;
LOCK TABLES `mdl_question_states` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_states` ENABLE KEYS */;

--
-- Table structure for table `mdl_question_truefalse`
--

DROP TABLE IF EXISTS `mdl_question_truefalse`;
CREATE TABLE `mdl_question_truefalse` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `question` bigint(10) unsigned NOT NULL default '0',
  `trueanswer` bigint(10) unsigned NOT NULL default '0',
  `falseanswer` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_questrue_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Options for True-False questions';

--
-- Dumping data for table `mdl_question_truefalse`
--


/*!40000 ALTER TABLE `mdl_question_truefalse` DISABLE KEYS */;
LOCK TABLES `mdl_question_truefalse` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_question_truefalse` ENABLE KEYS */;

--
-- Table structure for table `mdl_quiz`
--

DROP TABLE IF EXISTS `mdl_quiz`;
CREATE TABLE `mdl_quiz` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `intro` text NOT NULL,
  `timeopen` bigint(10) unsigned NOT NULL default '0',
  `timeclose` bigint(10) unsigned NOT NULL default '0',
  `optionflags` bigint(10) unsigned NOT NULL default '0',
  `penaltyscheme` smallint(4) unsigned NOT NULL default '0',
  `attempts` mediumint(6) NOT NULL default '0',
  `attemptonlast` smallint(4) NOT NULL default '0',
  `grademethod` smallint(4) NOT NULL default '1',
  `decimalpoints` smallint(4) NOT NULL default '2',
  `review` bigint(10) unsigned NOT NULL default '0',
  `questionsperpage` bigint(10) NOT NULL default '0',
  `shufflequestions` smallint(4) NOT NULL default '0',
  `shuffleanswers` smallint(4) NOT NULL default '0',
  `questions` text NOT NULL,
  `sumgrades` bigint(10) NOT NULL default '0',
  `grade` bigint(10) NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `timelimit` tinyint(2) unsigned NOT NULL default '0',
  `password` varchar(255) NOT NULL default '',
  `subnet` varchar(255) NOT NULL default '',
  `popup` smallint(4) NOT NULL default '0',
  `delay1` bigint(10) NOT NULL default '0',
  `delay2` bigint(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quiz_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Main information about each quiz';

--
-- Dumping data for table `mdl_quiz`
--


/*!40000 ALTER TABLE `mdl_quiz` DISABLE KEYS */;
LOCK TABLES `mdl_quiz` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_quiz` ENABLE KEYS */;

--
-- Table structure for table `mdl_quiz_attempts`
--

DROP TABLE IF EXISTS `mdl_quiz_attempts`;
CREATE TABLE `mdl_quiz_attempts` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `uniqueid` bigint(10) unsigned NOT NULL default '0',
  `quiz` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `attempt` mediumint(6) NOT NULL default '0',
  `sumgrades` double NOT NULL default '0',
  `timestart` bigint(10) unsigned NOT NULL default '0',
  `timefinish` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `layout` text NOT NULL,
  `preview` smallint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_quizatte_uni_uix` (`uniqueid`),
  KEY `mdl_quizatte_use_ix` (`userid`),
  KEY `mdl_quizatte_qui_ix` (`quiz`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores various attempts on a quiz';

--
-- Dumping data for table `mdl_quiz_attempts`
--


/*!40000 ALTER TABLE `mdl_quiz_attempts` DISABLE KEYS */;
LOCK TABLES `mdl_quiz_attempts` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_quiz_attempts` ENABLE KEYS */;

--
-- Table structure for table `mdl_quiz_feedback`
--

DROP TABLE IF EXISTS `mdl_quiz_feedback`;
CREATE TABLE `mdl_quiz_feedback` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `quizid` bigint(10) unsigned NOT NULL default '0',
  `feedbacktext` text NOT NULL,
  `mingrade` double NOT NULL default '0',
  `maxgrade` double NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quizfeed_qui_ix` (`quizid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Feedback given to students based on their overall score on t';

--
-- Dumping data for table `mdl_quiz_feedback`
--


/*!40000 ALTER TABLE `mdl_quiz_feedback` DISABLE KEYS */;
LOCK TABLES `mdl_quiz_feedback` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_quiz_feedback` ENABLE KEYS */;

--
-- Table structure for table `mdl_quiz_grades`
--

DROP TABLE IF EXISTS `mdl_quiz_grades`;
CREATE TABLE `mdl_quiz_grades` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `quiz` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `grade` double NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quizgrad_use_ix` (`userid`),
  KEY `mdl_quizgrad_qui_ix` (`quiz`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Final quiz grade (may be best of several attempts)';

--
-- Dumping data for table `mdl_quiz_grades`
--


/*!40000 ALTER TABLE `mdl_quiz_grades` DISABLE KEYS */;
LOCK TABLES `mdl_quiz_grades` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_quiz_grades` ENABLE KEYS */;

--
-- Table structure for table `mdl_quiz_question_instances`
--

DROP TABLE IF EXISTS `mdl_quiz_question_instances`;
CREATE TABLE `mdl_quiz_question_instances` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `quiz` bigint(10) unsigned NOT NULL default '0',
  `question` bigint(10) unsigned NOT NULL default '0',
  `grade` mediumint(6) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quizquesinst_qui_ix` (`quiz`),
  KEY `mdl_quizquesinst_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='The grade for a question in a quiz';

--
-- Dumping data for table `mdl_quiz_question_instances`
--


/*!40000 ALTER TABLE `mdl_quiz_question_instances` DISABLE KEYS */;
LOCK TABLES `mdl_quiz_question_instances` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_quiz_question_instances` ENABLE KEYS */;

--
-- Table structure for table `mdl_quiz_question_versions`
--

DROP TABLE IF EXISTS `mdl_quiz_question_versions`;
CREATE TABLE `mdl_quiz_question_versions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `quiz` bigint(10) unsigned NOT NULL default '0',
  `oldquestion` bigint(10) unsigned NOT NULL default '0',
  `newquestion` bigint(10) unsigned NOT NULL default '0',
  `originalquestion` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `timestamp` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_quizquesvers_qui_ix` (`quiz`),
  KEY `mdl_quizquesvers_old_ix` (`oldquestion`),
  KEY `mdl_quizquesvers_new_ix` (`newquestion`),
  KEY `mdl_quizquesvers_ori_ix` (`originalquestion`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='quiz_question_versions table retrofitted from MySQL';

--
-- Dumping data for table `mdl_quiz_question_versions`
--


/*!40000 ALTER TABLE `mdl_quiz_question_versions` DISABLE KEYS */;
LOCK TABLES `mdl_quiz_question_versions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_quiz_question_versions` ENABLE KEYS */;

--
-- Table structure for table `mdl_resource`
--

DROP TABLE IF EXISTS `mdl_resource`;
CREATE TABLE `mdl_resource` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `type` varchar(30) NOT NULL default '',
  `reference` varchar(255) NOT NULL default '',
  `summary` text NOT NULL,
  `alltext` text NOT NULL,
  `popup` text NOT NULL,
  `options` varchar(255) NOT NULL default '',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_reso_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='each record is one resource and its config data';

--
-- Dumping data for table `mdl_resource`
--


/*!40000 ALTER TABLE `mdl_resource` DISABLE KEYS */;
LOCK TABLES `mdl_resource` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_resource` ENABLE KEYS */;

--
-- Table structure for table `mdl_role`
--

DROP TABLE IF EXISTS `mdl_role`;
CREATE TABLE `mdl_role` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `shortname` varchar(100) NOT NULL default '',
  `description` text NOT NULL,
  `sortorder` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_role_sor_uix` (`sortorder`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='moodle roles';

--
-- Dumping data for table `mdl_role`
--


/*!40000 ALTER TABLE `mdl_role` DISABLE KEYS */;
LOCK TABLES `mdl_role` WRITE;
INSERT INTO `mdl_role` VALUES (1,'Administrator','admin','Administrators can usually do anything on the site, in all courses.',0),
(2,'Course creator','coursecreator','Course creators can create new courses and teach in them.',1),
(3,'Teacher','editingteacher','Teachers can do anything within a course, including changing the activities and grading students.',2),
(4,'Non-editing teacher','teacher','Non-editing teachers can teach in courses and grade students, but may not alter activities.',3),
(5,'Student','student','Students generally have less privileges within a course.',4),
(6,'Guest','guest','Guests have minimal privileges and usually can not enter text anywhere.',5);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_role` ENABLE KEYS */;

--
-- Table structure for table `mdl_role_allow_assign`
--

DROP TABLE IF EXISTS `mdl_role_allow_assign`;
CREATE TABLE `mdl_role_allow_assign` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `allowassign` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_rolealloassi_rolall_uix` (`roleid`,`allowassign`),
  KEY `mdl_rolealloassi_rol_ix` (`roleid`),
  KEY `mdl_rolealloassi_all_ix` (`allowassign`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='this defines what role can assign what role';

--
-- Dumping data for table `mdl_role_allow_assign`
--


/*!40000 ALTER TABLE `mdl_role_allow_assign` DISABLE KEYS */;
LOCK TABLES `mdl_role_allow_assign` WRITE;
INSERT INTO `mdl_role_allow_assign` VALUES (1,1,1),
(2,1,2),
(3,1,4),
(4,1,3),
(5,1,5),
(6,1,6),
(7,2,4),
(8,2,3),
(9,2,5),
(10,2,6),
(11,3,4),
(12,3,5),
(13,3,6);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_role_allow_assign` ENABLE KEYS */;

--
-- Table structure for table `mdl_role_allow_override`
--

DROP TABLE IF EXISTS `mdl_role_allow_override`;
CREATE TABLE `mdl_role_allow_override` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `allowoverride` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_rolealloover_rolall_uix` (`roleid`,`allowoverride`),
  KEY `mdl_rolealloover_rol_ix` (`roleid`),
  KEY `mdl_rolealloover_all_ix` (`allowoverride`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='this defines what role can override what role';

--
-- Dumping data for table `mdl_role_allow_override`
--


/*!40000 ALTER TABLE `mdl_role_allow_override` DISABLE KEYS */;
LOCK TABLES `mdl_role_allow_override` WRITE;
INSERT INTO `mdl_role_allow_override` VALUES (1,1,1),
(2,1,2),
(3,1,4),
(4,1,3),
(5,1,5),
(6,1,6);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_role_allow_override` ENABLE KEYS */;

--
-- Table structure for table `mdl_role_assignments`
--

DROP TABLE IF EXISTS `mdl_role_assignments`;
CREATE TABLE `mdl_role_assignments` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `contextid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `hidden` tinyint(1) unsigned NOT NULL default '0',
  `timestart` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `modifierid` bigint(10) unsigned NOT NULL default '0',
  `enrol` varchar(20) NOT NULL default '',
  `sortorder` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_roleassi_conroluse_uix` (`contextid`,`roleid`,`userid`),
  KEY `mdl_roleassi_sor_ix` (`sortorder`),
  KEY `mdl_roleassi_rol_ix` (`roleid`),
  KEY `mdl_roleassi_con_ix` (`contextid`),
  KEY `mdl_roleassi_use_ix` (`userid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='assigning roles to different context';

--
-- Dumping data for table `mdl_role_assignments`
--


/*!40000 ALTER TABLE `mdl_role_assignments` DISABLE KEYS */;
LOCK TABLES `mdl_role_assignments` WRITE;
INSERT INTO `mdl_role_assignments` VALUES (1,1,1,2,0,0,0,1172451239,0,'manual',0),
(2,1,4,2,0,0,0,1172451846,2,'manual',0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_role_assignments` ENABLE KEYS */;

--
-- Table structure for table `mdl_role_capabilities`
--

DROP TABLE IF EXISTS `mdl_role_capabilities`;
CREATE TABLE `mdl_role_capabilities` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `contextid` bigint(10) unsigned NOT NULL default '0',
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `capability` varchar(255) NOT NULL default '',
  `permission` bigint(10) NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `modifierid` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_rolecapa_rolconcap_uix` (`roleid`,`contextid`,`capability`),
  KEY `mdl_rolecapa_rol_ix` (`roleid`),
  KEY `mdl_rolecapa_con_ix` (`contextid`),
  KEY `mdl_rolecapa_mod_ix` (`modifierid`),
  KEY `mdl_rolecapa_cap_ix` (`capability`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='permission has to be signed, overriding a capability for a p';

--
-- Dumping data for table `mdl_role_capabilities`
--


/*!40000 ALTER TABLE `mdl_role_capabilities` DISABLE KEYS */;
LOCK TABLES `mdl_role_capabilities` WRITE;
INSERT INTO `mdl_role_capabilities` VALUES (1,1,1,'moodle/legacy:admin',1,1172450789,0),
(2,1,2,'moodle/legacy:coursecreator',1,1172450789,0),
(3,1,3,'moodle/legacy:editingteacher',1,1172450789,0),
(4,1,4,'moodle/legacy:teacher',1,1172450789,0),
(5,1,5,'moodle/legacy:student',1,1172450789,0),
(6,1,6,'moodle/legacy:guest',1,1172450789,0),
(7,1,1,'moodle/site:doanything',1,1172450789,0),
(8,1,1,'moodle/site:config',1,1172450789,0),
(9,1,1,'moodle/site:readallmessages',1,1172450789,0),
(10,1,1,'moodle/site:approvecourse',1,1172450789,0),
(11,1,3,'moodle/site:import',1,1172450789,0),
(12,1,2,'moodle/site:import',1,1172450789,0),
(13,1,1,'moodle/site:import',1,1172450789,0),
(14,1,3,'moodle/site:backup',1,1172450789,0),
(15,1,2,'moodle/site:backup',1,1172450789,0),
(16,1,1,'moodle/site:backup',1,1172450789,0),
(17,1,3,'moodle/site:restore',1,1172450789,0),
(18,1,2,'moodle/site:restore',1,1172450789,0),
(19,1,1,'moodle/site:restore',1,1172450789,0),
(20,1,3,'moodle/site:manageblocks',1,1172450789,0),
(21,1,2,'moodle/site:manageblocks',1,1172450789,0),
(22,1,1,'moodle/site:manageblocks',1,1172450789,0),
(23,1,4,'moodle/site:accessallgroups',1,1172450789,0),
(24,1,3,'moodle/site:accessallgroups',1,1172450789,0),
(25,1,2,'moodle/site:accessallgroups',1,1172450789,0),
(26,1,1,'moodle/site:accessallgroups',1,1172450789,0),
(27,1,4,'moodle/site:viewfullnames',1,1172450789,0),
(28,1,3,'moodle/site:viewfullnames',1,1172450790,0),
(29,1,2,'moodle/site:viewfullnames',1,1172450790,0),
(30,1,1,'moodle/site:viewfullnames',1,1172450790,0),
(31,1,3,'moodle/site:viewparticipants',1,1172450790,0),
(32,1,2,'moodle/site:viewparticipants',1,1172450790,0),
(33,1,1,'moodle/site:viewparticipants',1,1172450790,0),
(34,1,4,'moodle/site:viewreports',1,1172450790,0),
(35,1,3,'moodle/site:viewreports',1,1172450790,0),
(36,1,2,'moodle/site:viewreports',1,1172450790,0),
(37,1,1,'moodle/site:viewreports',1,1172450790,0),
(38,1,3,'moodle/site:trustcontent',1,1172450790,0),
(39,1,2,'moodle/site:trustcontent',1,1172450790,0),
(40,1,1,'moodle/site:trustcontent',1,1172450790,0),
(41,1,1,'moodle/site:uploadusers',1,1172450790,0),
(42,1,1,'moodle/user:create',1,1172450790,0),
(43,1,1,'moodle/user:delete',1,1172450790,0),
(44,1,1,'moodle/user:update',1,1172450790,0),
(45,1,6,'moodle/user:viewdetails',1,1172450790,0),
(46,1,5,'moodle/user:viewdetails',1,1172450790,0),
(47,1,4,'moodle/user:viewdetails',1,1172450790,0),
(48,1,3,'moodle/user:viewdetails',1,1172450790,0),
(49,1,2,'moodle/user:viewdetails',1,1172450790,0),
(50,1,1,'moodle/user:viewdetails',1,1172450790,0),
(51,1,4,'moodle/user:viewhiddendetails',1,1172450790,0),
(52,1,3,'moodle/user:viewhiddendetails',1,1172450790,0),
(53,1,2,'moodle/user:viewhiddendetails',1,1172450790,0),
(54,1,1,'moodle/user:viewhiddendetails',1,1172450790,0),
(55,1,5,'moodle/user:viewusergrades',1,1172450790,0),
(56,1,4,'moodle/user:viewusergrades',1,1172450790,0),
(57,1,3,'moodle/user:viewusergrades',1,1172450790,0),
(58,1,2,'moodle/user:viewusergrades',1,1172450790,0),
(59,1,1,'moodle/user:viewusergrades',1,1172450790,0),
(60,1,1,'moodle/user:loginas',1,1172450790,0),
(61,1,3,'moodle/role:assign',1,1172450790,0),
(62,1,2,'moodle/role:assign',1,1172450790,0),
(63,1,1,'moodle/role:assign',1,1172450790,0),
(64,1,1,'moodle/role:override',1,1172450790,0),
(65,1,1,'moodle/role:manage',1,1172450790,0),
(66,1,4,'moodle/role:unassignself',1,1172450790,0),
(67,1,3,'moodle/role:unassignself',1,1172450790,0),
(68,1,2,'moodle/role:unassignself',1,1172450790,0),
(69,1,1,'moodle/role:unassignself',1,1172450790,0),
(70,1,4,'moodle/role:viewhiddenassigns',1,1172450790,0),
(71,1,3,'moodle/role:viewhiddenassigns',1,1172450790,0),
(72,1,2,'moodle/role:viewhiddenassigns',1,1172450790,0),
(73,1,1,'moodle/role:viewhiddenassigns',1,1172450790,0),
(74,1,3,'moodle/role:switchroles',1,1172450790,0),
(75,1,1,'moodle/role:switchroles',1,1172450790,0),
(76,1,1,'moodle/category:create',1,1172450790,0),
(77,1,1,'moodle/category:delete',1,1172450790,0),
(78,1,1,'moodle/category:update',1,1172450790,0),
(79,1,1,'moodle/category:visibility',1,1172450790,0),
(80,1,2,'moodle/course:create',1,1172450790,0),
(81,1,1,'moodle/course:create',1,1172450790,0),
(82,1,1,'moodle/course:delete',1,1172450790,0),
(83,1,3,'moodle/course:update',1,1172450790,0),
(84,1,2,'moodle/course:update',1,1172450790,0),
(85,1,1,'moodle/course:update',1,1172450790,0),
(86,1,6,'moodle/course:view',1,1172450790,0),
(87,1,5,'moodle/course:view',1,1172450790,0),
(88,1,4,'moodle/course:view',1,1172450790,0),
(89,1,3,'moodle/course:view',1,1172450790,0),
(90,1,2,'moodle/course:view',1,1172450790,0),
(91,1,1,'moodle/course:view',1,1172450790,0),
(92,1,4,'moodle/course:bulkmessaging',1,1172450790,0),
(93,1,3,'moodle/course:bulkmessaging',1,1172450790,0),
(94,1,2,'moodle/course:bulkmessaging',1,1172450790,0),
(95,1,1,'moodle/course:bulkmessaging',1,1172450790,0),
(96,1,4,'moodle/course:viewhiddenuserfields',1,1172450790,0),
(97,1,3,'moodle/course:viewhiddenuserfields',1,1172450790,0),
(98,1,2,'moodle/course:viewhiddenuserfields',1,1172450790,0),
(99,1,1,'moodle/course:viewhiddenuserfields',1,1172450790,0),
(100,1,2,'moodle/course:viewhiddencourses',1,1172450790,0),
(101,1,1,'moodle/course:viewhiddencourses',1,1172450790,0),
(102,1,2,'moodle/course:visibility',1,1172450790,0),
(103,1,1,'moodle/course:visibility',1,1172450791,0),
(104,1,3,'moodle/course:managefiles',1,1172450791,0),
(105,1,2,'moodle/course:managefiles',1,1172450791,0),
(106,1,1,'moodle/course:managefiles',1,1172450791,0),
(107,1,3,'moodle/course:manageactivities',1,1172450791,0),
(108,1,2,'moodle/course:manageactivities',1,1172450791,0),
(109,1,1,'moodle/course:manageactivities',1,1172450791,0),
(110,1,3,'moodle/course:managemetacourse',1,1172450791,0),
(111,1,2,'moodle/course:managemetacourse',1,1172450791,0),
(112,1,1,'moodle/course:managemetacourse',1,1172450791,0),
(113,1,3,'moodle/course:activityvisibility',1,1172450791,0),
(114,1,2,'moodle/course:activityvisibility',1,1172450791,0),
(115,1,1,'moodle/course:activityvisibility',1,1172450791,0),
(116,1,4,'moodle/course:viewhiddenactivities',1,1172450791,0),
(117,1,3,'moodle/course:viewhiddenactivities',1,1172450791,0),
(118,1,2,'moodle/course:viewhiddenactivities',1,1172450791,0),
(119,1,1,'moodle/course:viewhiddenactivities',1,1172450791,0),
(120,1,5,'moodle/course:viewparticipants',1,1172450791,0),
(121,1,4,'moodle/course:viewparticipants',1,1172450791,0),
(122,1,3,'moodle/course:viewparticipants',1,1172450791,0),
(123,1,2,'moodle/course:viewparticipants',1,1172450791,0),
(124,1,1,'moodle/course:viewparticipants',1,1172450791,0),
(125,1,5,'moodle/course:viewscales',1,1172450791,0),
(126,1,4,'moodle/course:viewscales',1,1172450791,0),
(127,1,3,'moodle/course:viewscales',1,1172450791,0),
(128,1,2,'moodle/course:viewscales',1,1172450791,0),
(129,1,1,'moodle/course:viewscales',1,1172450791,0),
(130,1,3,'moodle/course:managescales',1,1172450791,0),
(131,1,2,'moodle/course:managescales',1,1172450791,0),
(132,1,1,'moodle/course:managescales',1,1172450791,0),
(133,1,3,'moodle/course:managegroups',1,1172450791,0),
(134,1,2,'moodle/course:managegroups',1,1172450791,0),
(135,1,1,'moodle/course:managegroups',1,1172450791,0),
(136,1,3,'moodle/course:reset',1,1172450791,0),
(137,1,2,'moodle/course:reset',1,1172450791,0),
(138,1,1,'moodle/course:reset',1,1172450791,0),
(139,1,6,'moodle/blog:view',1,1172450791,0),
(140,1,5,'moodle/blog:view',1,1172450791,0),
(141,1,4,'moodle/blog:view',1,1172450791,0),
(142,1,3,'moodle/blog:view',1,1172450791,0),
(143,1,2,'moodle/blog:view',1,1172450791,0),
(144,1,1,'moodle/blog:view',1,1172450791,0),
(145,1,6,'moodle/blog:create',1,1172450791,0),
(146,1,5,'moodle/blog:create',1,1172450791,0),
(147,1,4,'moodle/blog:create',1,1172450791,0),
(148,1,3,'moodle/blog:create',1,1172450791,0),
(149,1,2,'moodle/blog:create',1,1172450791,0),
(150,1,1,'moodle/blog:create',1,1172450791,0),
(151,1,1,'moodle/blog:manageofficialtags',1,1172450791,0),
(152,1,5,'moodle/blog:managepersonaltags',1,1172450791,0),
(153,1,4,'moodle/blog:managepersonaltags',1,1172450791,0),
(154,1,3,'moodle/blog:managepersonaltags',1,1172450791,0),
(155,1,2,'moodle/blog:managepersonaltags',1,1172450791,0),
(156,1,1,'moodle/blog:managepersonaltags',1,1172450791,0),
(157,1,4,'moodle/blog:manageentries',1,1172450791,0),
(158,1,3,'moodle/blog:manageentries',1,1172450791,0),
(159,1,2,'moodle/blog:manageentries',1,1172450791,0),
(160,1,1,'moodle/blog:manageentries',1,1172450791,0),
(161,1,6,'moodle/calendar:manageownentries',1,1172450791,0),
(162,1,5,'moodle/calendar:manageownentries',1,1172450791,0),
(163,1,4,'moodle/calendar:manageownentries',1,1172450791,0),
(164,1,3,'moodle/calendar:manageownentries',1,1172450791,0),
(165,1,2,'moodle/calendar:manageownentries',1,1172450791,0),
(166,1,1,'moodle/calendar:manageownentries',1,1172450791,0),
(167,1,4,'moodle/calendar:manageentries',1,1172450791,0),
(168,1,3,'moodle/calendar:manageentries',1,1172450791,0),
(169,1,2,'moodle/calendar:manageentries',1,1172450791,0),
(170,1,1,'moodle/calendar:manageentries',1,1172450791,0),
(171,1,5,'moodle/user:readuserposts',1,1172450791,0),
(172,1,4,'moodle/user:readuserposts',1,1172450791,0),
(173,1,3,'moodle/user:readuserposts',1,1172450791,0),
(174,1,2,'moodle/user:readuserposts',1,1172450791,0),
(175,1,1,'moodle/user:readuserposts',1,1172450791,0),
(176,1,5,'moodle/user:readuserblogs',1,1172450791,0),
(177,1,4,'moodle/user:readuserblogs',1,1172450791,0),
(178,1,3,'moodle/user:readuserblogs',1,1172450791,0),
(179,1,2,'moodle/user:readuserblogs',1,1172450791,0),
(180,1,1,'moodle/user:readuserblogs',1,1172450791,0),
(181,1,4,'moodle/user:viewuseractivitiesreport',1,1172450791,0),
(182,1,3,'moodle/user:viewuseractivitiesreport',1,1172450791,0),
(183,1,2,'moodle/user:viewuseractivitiesreport',1,1172450791,0),
(184,1,1,'moodle/user:viewuseractivitiesreport',1,1172450791,0),
(185,1,1,'moodle/user:editprofile',1,1172450791,0),
(186,1,3,'moodle/question:import',1,1172450791,0),
(187,1,2,'moodle/question:import',1,1172450791,0),
(188,1,1,'moodle/question:import',1,1172450791,0),
(189,1,3,'moodle/question:export',1,1172450791,0),
(190,1,2,'moodle/question:export',1,1172450792,0),
(191,1,1,'moodle/question:export',1,1172450792,0),
(192,1,3,'moodle/question:managecategory',1,1172450792,0),
(193,1,2,'moodle/question:managecategory',1,1172450792,0),
(194,1,1,'moodle/question:managecategory',1,1172450792,0),
(195,1,3,'moodle/question:manage',1,1172450792,0),
(196,1,2,'moodle/question:manage',1,1172450792,0),
(197,1,1,'moodle/question:manage',1,1172450792,0),
(198,1,4,'moodle/site:doclinks',1,1172450792,0),
(199,1,3,'moodle/site:doclinks',1,1172450792,0),
(200,1,2,'moodle/site:doclinks',1,1172450792,0),
(201,1,1,'moodle/site:doclinks',1,1172450792,0),
(202,1,3,'moodle/course:sectionvisibility',1,1172450792,0),
(203,1,2,'moodle/course:sectionvisibility',1,1172450792,0),
(204,1,1,'moodle/course:sectionvisibility',1,1172450792,0),
(205,1,3,'moodle/course:useremail',1,1172450792,0),
(206,1,1,'moodle/course:useremail',1,1172450792,0),
(207,1,3,'moodle/course:viewhiddensections',1,1172450792,0),
(208,1,2,'moodle/course:viewhiddensections',1,1172450792,0),
(209,1,1,'moodle/course:viewhiddensections',1,1172450792,0),
(210,1,3,'moodle/course:setcurrentsection',1,1172450792,0),
(211,1,2,'moodle/course:setcurrentsection',1,1172450792,0),
(212,1,1,'moodle/course:setcurrentsection',1,1172450792,0),
(213,1,4,'moodle/course:viewcoursegrades',1,1172450792,0),
(214,1,3,'moodle/course:viewcoursegrades',1,1172450792,0),
(215,1,2,'moodle/course:viewcoursegrades',1,1172450792,0),
(216,1,1,'moodle/course:viewcoursegrades',1,1172450792,0),
(217,1,3,'moodle/course:managegrades',1,1172450792,0),
(218,1,2,'moodle/course:managegrades',1,1172450792,0),
(219,1,1,'moodle/course:managegrades',1,1172450792,0),
(220,1,6,'mod/assignment:view',1,1172450813,0),
(221,1,5,'mod/assignment:view',1,1172450813,0),
(222,1,4,'mod/assignment:view',1,1172450813,0),
(223,1,3,'mod/assignment:view',1,1172450813,0),
(224,1,2,'mod/assignment:view',1,1172450813,0),
(225,1,1,'mod/assignment:view',1,1172450813,0),
(226,1,5,'mod/assignment:submit',1,1172450813,0),
(227,1,4,'mod/assignment:grade',1,1172450813,0),
(228,1,3,'mod/assignment:grade',1,1172450813,0),
(229,1,2,'mod/assignment:grade',1,1172450813,0),
(230,1,1,'mod/assignment:grade',1,1172450814,0),
(231,1,5,'mod/chat:chat',1,1172450814,0),
(232,1,4,'mod/chat:chat',1,1172450814,0),
(233,1,3,'mod/chat:chat',1,1172450814,0),
(234,1,2,'mod/chat:chat',1,1172450814,0),
(235,1,1,'mod/chat:chat',1,1172450814,0),
(236,1,5,'mod/chat:readlog',1,1172450814,0),
(237,1,4,'mod/chat:readlog',1,1172450814,0),
(238,1,3,'mod/chat:readlog',1,1172450814,0),
(239,1,2,'mod/chat:readlog',1,1172450814,0),
(240,1,1,'mod/chat:readlog',1,1172450814,0),
(241,1,4,'mod/chat:deletelog',1,1172450814,0),
(242,1,3,'mod/chat:deletelog',1,1172450814,0),
(243,1,2,'mod/chat:deletelog',1,1172450814,0),
(244,1,1,'mod/chat:deletelog',1,1172450814,0),
(245,1,5,'mod/choice:choose',1,1172450815,0),
(246,1,4,'mod/choice:choose',1,1172450815,0),
(247,1,3,'mod/choice:choose',1,1172450815,0),
(248,1,2,'mod/choice:choose',1,1172450815,0),
(249,1,1,'mod/choice:choose',1,1172450815,0),
(250,1,4,'mod/choice:readresponses',1,1172450815,0),
(251,1,3,'mod/choice:readresponses',1,1172450815,0),
(252,1,2,'mod/choice:readresponses',1,1172450815,0),
(253,1,1,'mod/choice:readresponses',1,1172450815,0),
(254,1,4,'mod/choice:deleteresponses',1,1172450815,0),
(255,1,3,'mod/choice:deleteresponses',1,1172450815,0),
(256,1,2,'mod/choice:deleteresponses',1,1172450815,0),
(257,1,1,'mod/choice:deleteresponses',1,1172450815,0),
(258,1,4,'mod/choice:downloadresponses',1,1172450815,0),
(259,1,3,'mod/choice:downloadresponses',1,1172450815,0),
(260,1,2,'mod/choice:downloadresponses',1,1172450815,0),
(261,1,1,'mod/choice:downloadresponses',1,1172450815,0),
(262,1,6,'mod/data:viewentry',1,1172450816,0),
(263,1,5,'mod/data:viewentry',1,1172450816,0),
(264,1,4,'mod/data:viewentry',1,1172450816,0),
(265,1,3,'mod/data:viewentry',1,1172450816,0),
(266,1,2,'mod/data:viewentry',1,1172450816,0),
(267,1,1,'mod/data:viewentry',1,1172450816,0),
(268,1,5,'mod/data:writeentry',1,1172450816,0),
(269,1,4,'mod/data:writeentry',1,1172450816,0),
(270,1,3,'mod/data:writeentry',1,1172450816,0),
(271,1,2,'mod/data:writeentry',1,1172450816,0),
(272,1,1,'mod/data:writeentry',1,1172450816,0),
(273,1,5,'mod/data:comment',1,1172450816,0),
(274,1,4,'mod/data:comment',1,1172450816,0),
(275,1,3,'mod/data:comment',1,1172450816,0),
(276,1,2,'mod/data:comment',1,1172450816,0),
(277,1,1,'mod/data:comment',1,1172450816,0),
(278,1,4,'mod/data:viewrating',1,1172450816,0),
(279,1,3,'mod/data:viewrating',1,1172450816,0),
(280,1,2,'mod/data:viewrating',1,1172450816,0),
(281,1,1,'mod/data:viewrating',1,1172450816,0),
(282,1,4,'mod/data:rate',1,1172450816,0),
(283,1,3,'mod/data:rate',1,1172450816,0),
(284,1,2,'mod/data:rate',1,1172450816,0),
(285,1,1,'mod/data:rate',1,1172450816,0),
(286,1,4,'mod/data:approve',1,1172450816,0),
(287,1,3,'mod/data:approve',1,1172450816,0),
(288,1,2,'mod/data:approve',1,1172450816,0),
(289,1,1,'mod/data:approve',1,1172450816,0),
(290,1,4,'mod/data:manageentries',1,1172450816,0),
(291,1,3,'mod/data:manageentries',1,1172450816,0),
(292,1,2,'mod/data:manageentries',1,1172450816,0),
(293,1,1,'mod/data:manageentries',1,1172450816,0),
(294,1,4,'mod/data:managecomments',1,1172450816,0),
(295,1,3,'mod/data:managecomments',1,1172450816,0),
(296,1,2,'mod/data:managecomments',1,1172450816,0),
(297,1,1,'mod/data:managecomments',1,1172450816,0),
(298,1,4,'mod/data:managetemplates',1,1172450816,0),
(299,1,3,'mod/data:managetemplates',1,1172450816,0),
(300,1,2,'mod/data:managetemplates',1,1172450816,0),
(301,1,1,'mod/data:managetemplates',1,1172450816,0),
(302,1,4,'mod/data:viewalluserpresets',1,1172450816,0),
(303,1,3,'mod/data:viewalluserpresets',1,1172450816,0),
(304,1,2,'mod/data:viewalluserpresets',1,1172450817,0),
(305,1,1,'mod/data:viewalluserpresets',1,1172450817,0),
(306,1,1,'mod/data:manageuserpresets',1,1172450817,0),
(307,1,6,'mod/forum:viewdiscussion',1,1172450818,0),
(308,1,5,'mod/forum:viewdiscussion',1,1172450818,0),
(309,1,4,'mod/forum:viewdiscussion',1,1172450818,0),
(310,1,3,'mod/forum:viewdiscussion',1,1172450818,0),
(311,1,2,'mod/forum:viewdiscussion',1,1172450818,0),
(312,1,1,'mod/forum:viewdiscussion',1,1172450818,0),
(313,1,4,'mod/forum:viewhiddentimedposts',1,1172450818,0),
(314,1,3,'mod/forum:viewhiddentimedposts',1,1172450818,0),
(315,1,2,'mod/forum:viewhiddentimedposts',1,1172450818,0),
(316,1,1,'mod/forum:viewhiddentimedposts',1,1172450818,0),
(317,1,5,'mod/forum:startdiscussion',1,1172450818,0),
(318,1,4,'mod/forum:startdiscussion',1,1172450818,0),
(319,1,3,'mod/forum:startdiscussion',1,1172450818,0),
(320,1,2,'mod/forum:startdiscussion',1,1172450818,0),
(321,1,1,'mod/forum:startdiscussion',1,1172450818,0),
(322,1,5,'mod/forum:replypost',1,1172450818,0),
(323,1,4,'mod/forum:replypost',1,1172450818,0),
(324,1,3,'mod/forum:replypost',1,1172450818,0),
(325,1,2,'mod/forum:replypost',1,1172450818,0),
(326,1,1,'mod/forum:replypost',1,1172450818,0),
(327,1,5,'mod/forum:viewrating',1,1172450818,0),
(328,1,4,'mod/forum:viewrating',1,1172450818,0),
(329,1,3,'mod/forum:viewrating',1,1172450818,0),
(330,1,2,'mod/forum:viewrating',1,1172450819,0),
(331,1,1,'mod/forum:viewrating',1,1172450819,0),
(332,1,4,'mod/forum:viewanyrating',1,1172450819,0),
(333,1,3,'mod/forum:viewanyrating',1,1172450819,0),
(334,1,2,'mod/forum:viewanyrating',1,1172450819,0),
(335,1,1,'mod/forum:viewanyrating',1,1172450819,0),
(336,1,4,'mod/forum:rate',1,1172450819,0),
(337,1,3,'mod/forum:rate',1,1172450819,0),
(338,1,2,'mod/forum:rate',1,1172450819,0),
(339,1,1,'mod/forum:rate',1,1172450819,0),
(340,1,5,'mod/forum:createattachment',1,1172450819,0),
(341,1,4,'mod/forum:createattachment',1,1172450819,0),
(342,1,3,'mod/forum:createattachment',1,1172450819,0),
(343,1,2,'mod/forum:createattachment',1,1172450819,0),
(344,1,1,'mod/forum:createattachment',1,1172450819,0),
(345,1,5,'mod/forum:deleteownpost',1,1172450819,0),
(346,1,4,'mod/forum:deleteownpost',1,1172450819,0),
(347,1,3,'mod/forum:deleteownpost',1,1172450819,0),
(348,1,2,'mod/forum:deleteownpost',1,1172450819,0),
(349,1,1,'mod/forum:deleteownpost',1,1172450819,0),
(350,1,4,'mod/forum:deleteanypost',1,1172450819,0),
(351,1,3,'mod/forum:deleteanypost',1,1172450819,0),
(352,1,2,'mod/forum:deleteanypost',1,1172450819,0),
(353,1,1,'mod/forum:deleteanypost',1,1172450819,0),
(354,1,4,'mod/forum:splitdiscussions',1,1172450819,0),
(355,1,3,'mod/forum:splitdiscussions',1,1172450819,0),
(356,1,2,'mod/forum:splitdiscussions',1,1172450819,0),
(357,1,1,'mod/forum:splitdiscussions',1,1172450819,0),
(358,1,4,'mod/forum:movediscussions',1,1172450819,0),
(359,1,3,'mod/forum:movediscussions',1,1172450819,0),
(360,1,2,'mod/forum:movediscussions',1,1172450819,0),
(361,1,1,'mod/forum:movediscussions',1,1172450819,0),
(362,1,4,'mod/forum:editanypost',1,1172450819,0),
(363,1,3,'mod/forum:editanypost',1,1172450819,0),
(364,1,2,'mod/forum:editanypost',1,1172450819,0),
(365,1,1,'mod/forum:editanypost',1,1172450819,0),
(366,1,4,'mod/forum:viewqandawithoutposting',1,1172450819,0),
(367,1,3,'mod/forum:viewqandawithoutposting',1,1172450819,0),
(368,1,2,'mod/forum:viewqandawithoutposting',1,1172450819,0),
(369,1,1,'mod/forum:viewqandawithoutposting',1,1172450819,0),
(370,1,4,'mod/forum:viewsubscribers',1,1172450819,0),
(371,1,3,'mod/forum:viewsubscribers',1,1172450819,0),
(372,1,2,'mod/forum:viewsubscribers',1,1172450819,0),
(373,1,1,'mod/forum:viewsubscribers',1,1172450819,0),
(374,1,4,'mod/forum:managesubscriptions',1,1172450819,0),
(375,1,3,'mod/forum:managesubscriptions',1,1172450819,0),
(376,1,2,'mod/forum:managesubscriptions',1,1172450819,0),
(377,1,1,'mod/forum:managesubscriptions',1,1172450819,0),
(378,1,5,'mod/glossary:write',1,1172450821,0),
(379,1,4,'mod/glossary:write',1,1172450821,0),
(380,1,3,'mod/glossary:write',1,1172450821,0),
(381,1,2,'mod/glossary:write',1,1172450821,0),
(382,1,1,'mod/glossary:write',1,1172450821,0),
(383,1,4,'mod/glossary:manageentries',1,1172450821,0),
(384,1,3,'mod/glossary:manageentries',1,1172450821,0),
(385,1,2,'mod/glossary:manageentries',1,1172450821,0),
(386,1,1,'mod/glossary:manageentries',1,1172450821,0),
(387,1,4,'mod/glossary:managecategories',1,1172450821,0),
(388,1,3,'mod/glossary:managecategories',1,1172450821,0),
(389,1,2,'mod/glossary:managecategories',1,1172450821,0),
(390,1,1,'mod/glossary:managecategories',1,1172450821,0),
(391,1,5,'mod/glossary:comment',1,1172450821,0),
(392,1,4,'mod/glossary:comment',1,1172450821,0),
(393,1,3,'mod/glossary:comment',1,1172450821,0),
(394,1,2,'mod/glossary:comment',1,1172450821,0),
(395,1,1,'mod/glossary:comment',1,1172450821,0),
(396,1,4,'mod/glossary:managecomments',1,1172450821,0),
(397,1,3,'mod/glossary:managecomments',1,1172450821,0),
(398,1,2,'mod/glossary:managecomments',1,1172450821,0),
(399,1,1,'mod/glossary:managecomments',1,1172450821,0),
(400,1,4,'mod/glossary:import',1,1172450821,0),
(401,1,3,'mod/glossary:import',1,1172450821,0),
(402,1,2,'mod/glossary:import',1,1172450821,0),
(403,1,1,'mod/glossary:import',1,1172450821,0),
(404,1,4,'mod/glossary:export',1,1172450821,0),
(405,1,3,'mod/glossary:export',1,1172450821,0),
(406,1,2,'mod/glossary:export',1,1172450821,0),
(407,1,1,'mod/glossary:export',1,1172450821,0),
(408,1,4,'mod/glossary:approve',1,1172450821,0),
(409,1,3,'mod/glossary:approve',1,1172450821,0),
(410,1,2,'mod/glossary:approve',1,1172450821,0),
(411,1,1,'mod/glossary:approve',1,1172450821,0),
(412,1,4,'mod/glossary:rate',1,1172450821,0),
(413,1,3,'mod/glossary:rate',1,1172450821,0),
(414,1,2,'mod/glossary:rate',1,1172450821,0),
(415,1,1,'mod/glossary:rate',1,1172450821,0),
(416,1,4,'mod/glossary:viewrating',1,1172450822,0),
(417,1,3,'mod/glossary:viewrating',1,1172450822,0),
(418,1,2,'mod/glossary:viewrating',1,1172450822,0),
(419,1,1,'mod/glossary:viewrating',1,1172450822,0),
(420,1,5,'mod/hotpot:attempt',1,1172450823,0),
(421,1,4,'mod/hotpot:attempt',1,1172450823,0),
(422,1,3,'mod/hotpot:attempt',1,1172450823,0),
(423,1,2,'mod/hotpot:attempt',1,1172450823,0),
(424,1,1,'mod/hotpot:attempt',1,1172450823,0),
(425,1,4,'mod/hotpot:viewreport',1,1172450823,0),
(426,1,3,'mod/hotpot:viewreport',1,1172450823,0),
(427,1,2,'mod/hotpot:viewreport',1,1172450823,0),
(428,1,1,'mod/hotpot:viewreport',1,1172450823,0),
(429,1,4,'mod/hotpot:grade',1,1172450823,0),
(430,1,3,'mod/hotpot:grade',1,1172450824,0),
(431,1,2,'mod/hotpot:grade',1,1172450824,0),
(432,1,1,'mod/hotpot:grade',1,1172450824,0),
(433,1,3,'mod/hotpot:deleteattempt',1,1172450824,0),
(434,1,2,'mod/hotpot:deleteattempt',1,1172450824,0),
(435,1,1,'mod/hotpot:deleteattempt',1,1172450824,0),
(436,1,5,'mod/lams:participate',1,1172450824,0),
(437,1,4,'mod/lams:manage',1,1172450824,0),
(438,1,3,'mod/lams:manage',1,1172450824,0),
(439,1,1,'mod/lams:manage',1,1172450824,0),
(440,1,3,'mod/lesson:edit',1,1172450827,0),
(441,1,2,'mod/lesson:edit',1,1172450827,0),
(442,1,1,'mod/lesson:edit',1,1172450827,0),
(443,1,4,'mod/lesson:manage',1,1172450827,0),
(444,1,3,'mod/lesson:manage',1,1172450827,0),
(445,1,2,'mod/lesson:manage',1,1172450827,0),
(446,1,1,'mod/lesson:manage',1,1172450827,0),
(447,1,6,'mod/quiz:view',1,1172450830,0),
(448,1,5,'mod/quiz:view',1,1172450830,0),
(449,1,4,'mod/quiz:view',1,1172450830,0),
(450,1,3,'mod/quiz:view',1,1172450830,0),
(451,1,2,'mod/quiz:view',1,1172450830,0),
(452,1,1,'mod/quiz:view',1,1172450830,0),
(453,1,5,'mod/quiz:attempt',1,1172450830,0),
(454,1,3,'mod/quiz:manage',1,1172450830,0),
(455,1,2,'mod/quiz:manage',1,1172450831,0),
(456,1,1,'mod/quiz:manage',1,1172450831,0),
(457,1,4,'mod/quiz:preview',1,1172450831,0),
(458,1,3,'mod/quiz:preview',1,1172450831,0),
(459,1,2,'mod/quiz:preview',1,1172450831,0),
(460,1,1,'mod/quiz:preview',1,1172450831,0),
(461,1,4,'mod/quiz:grade',1,1172450831,0),
(462,1,3,'mod/quiz:grade',1,1172450831,0),
(463,1,2,'mod/quiz:grade',1,1172450831,0),
(464,1,1,'mod/quiz:grade',1,1172450831,0),
(465,1,4,'mod/quiz:viewreports',1,1172450831,0),
(466,1,3,'mod/quiz:viewreports',1,1172450831,0),
(467,1,2,'mod/quiz:viewreports',1,1172450831,0),
(468,1,1,'mod/quiz:viewreports',1,1172450831,0),
(469,1,3,'mod/quiz:deleteattempts',1,1172450831,0),
(470,1,2,'mod/quiz:deleteattempts',1,1172450831,0),
(471,1,1,'mod/quiz:deleteattempts',1,1172450831,0),
(472,1,4,'mod/scorm:viewreport',1,1172450832,0),
(473,1,3,'mod/scorm:viewreport',1,1172450832,0),
(474,1,2,'mod/scorm:viewreport',1,1172450832,0),
(475,1,1,'mod/scorm:viewreport',1,1172450832,0),
(476,1,5,'mod/scorm:skipview',1,1172450832,0),
(477,1,5,'mod/scorm:savetrack',1,1172450832,0),
(478,1,4,'mod/scorm:savetrack',1,1172450832,0),
(479,1,3,'mod/scorm:savetrack',1,1172450832,0),
(480,1,2,'mod/scorm:savetrack',1,1172450832,0),
(481,1,1,'mod/scorm:savetrack',1,1172450832,0),
(482,1,5,'mod/scorm:viewscores',1,1172450832,0),
(483,1,4,'mod/scorm:viewscores',1,1172450832,0),
(484,1,3,'mod/scorm:viewscores',1,1172450832,0),
(485,1,2,'mod/scorm:viewscores',1,1172450832,0),
(486,1,1,'mod/scorm:viewscores',1,1172450832,0),
(487,1,5,'mod/survey:participate',1,1172450833,0),
(488,1,4,'mod/survey:participate',1,1172450833,0),
(489,1,3,'mod/survey:participate',1,1172450833,0),
(490,1,2,'mod/survey:participate',1,1172450833,0),
(491,1,1,'mod/survey:participate',1,1172450833,0),
(492,1,4,'mod/survey:readresponses',1,1172450833,0),
(493,1,3,'mod/survey:readresponses',1,1172450833,0),
(494,1,2,'mod/survey:readresponses',1,1172450833,0),
(495,1,1,'mod/survey:readresponses',1,1172450833,0),
(496,1,4,'mod/survey:download',1,1172450833,0),
(497,1,3,'mod/survey:download',1,1172450833,0),
(498,1,2,'mod/survey:download',1,1172450833,0),
(499,1,1,'mod/survey:download',1,1172450833,0),
(500,1,5,'mod/wiki:participate',1,1172450834,0),
(501,1,4,'mod/wiki:participate',1,1172450834,0),
(502,1,3,'mod/wiki:participate',1,1172450834,0),
(503,1,2,'mod/wiki:participate',1,1172450834,0),
(504,1,1,'mod/wiki:participate',1,1172450834,0),
(505,1,4,'mod/wiki:manage',1,1172450834,0),
(506,1,3,'mod/wiki:manage',1,1172450834,0),
(507,1,1,'mod/wiki:manage',1,1172450834,0),
(508,1,4,'mod/wiki:overridelock',1,1172450834,0),
(509,1,3,'mod/wiki:overridelock',1,1172450834,0),
(510,1,2,'mod/wiki:overridelock',1,1172450834,0),
(511,1,1,'mod/wiki:overridelock',1,1172450834,0),
(512,1,5,'mod/workshop:participate',1,1172450836,0),
(513,1,4,'mod/workshop:manage',1,1172450836,0),
(514,1,3,'mod/workshop:manage',1,1172450836,0),
(515,1,2,'mod/workshop:manage',1,1172450836,0),
(516,1,1,'mod/workshop:manage',1,1172450836,0),
(517,1,4,'block/rss_client:createprivatefeeds',1,1172451220,0),
(518,1,3,'block/rss_client:createprivatefeeds',1,1172451220,0),
(519,1,2,'block/rss_client:createprivatefeeds',1,1172451220,0),
(520,1,1,'block/rss_client:createprivatefeeds',1,1172451220,0),
(521,1,3,'block/rss_client:createsharedfeeds',1,1172451220,0),
(522,1,2,'block/rss_client:createsharedfeeds',1,1172451220,0),
(523,1,1,'block/rss_client:createsharedfeeds',1,1172451220,0),
(524,1,4,'block/rss_client:manageownfeeds',1,1172451220,0),
(525,1,3,'block/rss_client:manageownfeeds',1,1172451220,0),
(526,1,2,'block/rss_client:manageownfeeds',1,1172451220,0),
(527,1,1,'block/rss_client:manageownfeeds',1,1172451220,0),
(528,1,1,'block/rss_client:manageanyfeeds',1,1172451220,0),
(529,1,1,'enrol/authorize:managepayments',1,1172451228,0),
(530,1,1,'enrol/authorize:uploadcsv',1,1172451228,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_role_capabilities` ENABLE KEYS */;

--
-- Table structure for table `mdl_role_names`
--

DROP TABLE IF EXISTS `mdl_role_names`;
CREATE TABLE `mdl_role_names` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `contextid` bigint(10) unsigned NOT NULL default '0',
  `text` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_rolename_rolcon_uix` (`roleid`,`contextid`),
  KEY `mdl_rolename_rol_ix` (`roleid`),
  KEY `mdl_rolename_con_ix` (`contextid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='role names in native strings';

--
-- Dumping data for table `mdl_role_names`
--


/*!40000 ALTER TABLE `mdl_role_names` DISABLE KEYS */;
LOCK TABLES `mdl_role_names` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_role_names` ENABLE KEYS */;

--
-- Table structure for table `mdl_scale`
--

DROP TABLE IF EXISTS `mdl_scale`;
CREATE TABLE `mdl_scale` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `scale` text NOT NULL,
  `description` text NOT NULL,
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_scal_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines grading scales';

--
-- Dumping data for table `mdl_scale`
--


/*!40000 ALTER TABLE `mdl_scale` DISABLE KEYS */;
LOCK TABLES `mdl_scale` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_scale` ENABLE KEYS */;

--
-- Table structure for table `mdl_scorm`
--

DROP TABLE IF EXISTS `mdl_scorm`;
CREATE TABLE `mdl_scorm` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `reference` varchar(255) NOT NULL default '',
  `version` varchar(9) NOT NULL default '',
  `maxgrade` double NOT NULL default '0',
  `grademethod` tinyint(2) NOT NULL default '0',
  `maxattempt` bigint(10) NOT NULL default '1',
  `launch` bigint(10) unsigned NOT NULL default '0',
  `skipview` tinyint(1) unsigned NOT NULL default '1',
  `summary` text NOT NULL,
  `hidebrowse` tinyint(1) NOT NULL default '0',
  `hidetoc` tinyint(1) NOT NULL default '0',
  `hidenav` tinyint(1) NOT NULL default '0',
  `auto` tinyint(1) unsigned NOT NULL default '0',
  `popup` tinyint(1) unsigned NOT NULL default '0',
  `options` varchar(255) NOT NULL default '',
  `width` bigint(10) unsigned NOT NULL default '100',
  `height` bigint(10) unsigned NOT NULL default '600',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_scor_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='each table is one SCORM module and its configuration';

--
-- Dumping data for table `mdl_scorm`
--


/*!40000 ALTER TABLE `mdl_scorm` DISABLE KEYS */;
LOCK TABLES `mdl_scorm` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_scorm` ENABLE KEYS */;

--
-- Table structure for table `mdl_scorm_scoes`
--

DROP TABLE IF EXISTS `mdl_scorm_scoes`;
CREATE TABLE `mdl_scorm_scoes` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `scorm` bigint(10) unsigned NOT NULL default '0',
  `manifest` varchar(255) NOT NULL default '',
  `organization` varchar(255) NOT NULL default '',
  `parent` varchar(255) NOT NULL default '',
  `identifier` varchar(255) NOT NULL default '',
  `launch` varchar(255) NOT NULL default '',
  `parameters` varchar(255) NOT NULL default '',
  `scormtype` varchar(5) NOT NULL default '',
  `title` varchar(255) NOT NULL default '',
  `prerequisites` varchar(200) NOT NULL default '',
  `maxtimeallowed` varchar(19) NOT NULL default '',
  `timelimitaction` varchar(19) NOT NULL default '',
  `datafromlms` varchar(255) NOT NULL default '',
  `masteryscore` varchar(200) NOT NULL default '',
  `next` tinyint(1) unsigned NOT NULL default '0',
  `previous` tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_scorscoe_sco_ix` (`scorm`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='each SCO part of the SCORM module';

--
-- Dumping data for table `mdl_scorm_scoes`
--


/*!40000 ALTER TABLE `mdl_scorm_scoes` DISABLE KEYS */;
LOCK TABLES `mdl_scorm_scoes` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_scorm_scoes` ENABLE KEYS */;

--
-- Table structure for table `mdl_scorm_scoes_track`
--

DROP TABLE IF EXISTS `mdl_scorm_scoes_track`;
CREATE TABLE `mdl_scorm_scoes_track` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `scormid` bigint(10) NOT NULL default '0',
  `scoid` bigint(10) unsigned NOT NULL default '0',
  `attempt` bigint(10) unsigned NOT NULL default '1',
  `element` varchar(255) NOT NULL default '',
  `value` longtext NOT NULL,
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_scorscoetrac_usescosco_uix` (`userid`,`scormid`,`scoid`,`attempt`,`element`),
  KEY `mdl_scorscoetrac_use_ix` (`userid`),
  KEY `mdl_scorscoetrac_ele_ix` (`element`),
  KEY `mdl_scorscoetrac_sco_ix` (`scormid`),
  KEY `mdl_scorscoetrac_sco2_ix` (`scoid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to track SCOes';

--
-- Dumping data for table `mdl_scorm_scoes_track`
--


/*!40000 ALTER TABLE `mdl_scorm_scoes_track` DISABLE KEYS */;
LOCK TABLES `mdl_scorm_scoes_track` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_scorm_scoes_track` ENABLE KEYS */;

--
-- Table structure for table `mdl_sessions2`
--

DROP TABLE IF EXISTS `mdl_sessions2`;
CREATE TABLE `mdl_sessions2` (
  `sesskey` varchar(64) NOT NULL default '',
  `expiry` datetime NOT NULL,
  `expireref` varchar(250) default '',
  `created` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `sessdata` longtext,
  PRIMARY KEY  (`sesskey`),
  KEY `mdl_sess_exp_ix` (`expiry`),
  KEY `mdl_sess_exp2_ix` (`expireref`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Optional database session storage in new format, not used by';

--
-- Dumping data for table `mdl_sessions2`
--


/*!40000 ALTER TABLE `mdl_sessions2` DISABLE KEYS */;
LOCK TABLES `mdl_sessions2` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_sessions2` ENABLE KEYS */;

--
-- Table structure for table `mdl_stats_daily`
--

DROP TABLE IF EXISTS `mdl_stats_daily`;
CREATE TABLE `mdl_stats_daily` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `stattype` enum('enrolments','activity','logins') NOT NULL default 'activity',
  `stat1` bigint(10) unsigned NOT NULL default '0',
  `stat2` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_statdail_cou_ix` (`courseid`),
  KEY `mdl_statdail_tim_ix` (`timeend`),
  KEY `mdl_statdail_rol_ix` (`roleid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='to accumulate daily stats';

--
-- Dumping data for table `mdl_stats_daily`
--


/*!40000 ALTER TABLE `mdl_stats_daily` DISABLE KEYS */;
LOCK TABLES `mdl_stats_daily` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_stats_daily` ENABLE KEYS */;

--
-- Table structure for table `mdl_stats_monthly`
--

DROP TABLE IF EXISTS `mdl_stats_monthly`;
CREATE TABLE `mdl_stats_monthly` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `stattype` enum('enrolments','activity','logins') NOT NULL default 'activity',
  `stat1` bigint(10) unsigned NOT NULL default '0',
  `stat2` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_statmont_cou_ix` (`courseid`),
  KEY `mdl_statmont_tim_ix` (`timeend`),
  KEY `mdl_statmont_rol_ix` (`roleid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To accumulate monthly stats';

--
-- Dumping data for table `mdl_stats_monthly`
--


/*!40000 ALTER TABLE `mdl_stats_monthly` DISABLE KEYS */;
LOCK TABLES `mdl_stats_monthly` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_stats_monthly` ENABLE KEYS */;

--
-- Table structure for table `mdl_stats_user_daily`
--

DROP TABLE IF EXISTS `mdl_stats_user_daily`;
CREATE TABLE `mdl_stats_user_daily` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  `statsreads` bigint(10) unsigned NOT NULL default '0',
  `statswrites` bigint(10) unsigned NOT NULL default '0',
  `stattype` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_statuserdail_cou_ix` (`courseid`),
  KEY `mdl_statuserdail_use_ix` (`userid`),
  KEY `mdl_statuserdail_rol_ix` (`roleid`),
  KEY `mdl_statuserdail_tim_ix` (`timeend`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To accumulate daily stats per course/user';

--
-- Dumping data for table `mdl_stats_user_daily`
--


/*!40000 ALTER TABLE `mdl_stats_user_daily` DISABLE KEYS */;
LOCK TABLES `mdl_stats_user_daily` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_stats_user_daily` ENABLE KEYS */;

--
-- Table structure for table `mdl_stats_user_monthly`
--

DROP TABLE IF EXISTS `mdl_stats_user_monthly`;
CREATE TABLE `mdl_stats_user_monthly` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  `statsreads` bigint(10) unsigned NOT NULL default '0',
  `statswrites` bigint(10) unsigned NOT NULL default '0',
  `stattype` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_statusermont_cou_ix` (`courseid`),
  KEY `mdl_statusermont_use_ix` (`userid`),
  KEY `mdl_statusermont_rol_ix` (`roleid`),
  KEY `mdl_statusermont_tim_ix` (`timeend`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To accumulate monthly stats per course/user';

--
-- Dumping data for table `mdl_stats_user_monthly`
--


/*!40000 ALTER TABLE `mdl_stats_user_monthly` DISABLE KEYS */;
LOCK TABLES `mdl_stats_user_monthly` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_stats_user_monthly` ENABLE KEYS */;

--
-- Table structure for table `mdl_stats_user_weekly`
--

DROP TABLE IF EXISTS `mdl_stats_user_weekly`;
CREATE TABLE `mdl_stats_user_weekly` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  `statsreads` bigint(10) unsigned NOT NULL default '0',
  `statswrites` bigint(10) unsigned NOT NULL default '0',
  `stattype` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_statuserweek_cou_ix` (`courseid`),
  KEY `mdl_statuserweek_use_ix` (`userid`),
  KEY `mdl_statuserweek_rol_ix` (`roleid`),
  KEY `mdl_statuserweek_tim_ix` (`timeend`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To accumulate weekly stats per course/user';

--
-- Dumping data for table `mdl_stats_user_weekly`
--


/*!40000 ALTER TABLE `mdl_stats_user_weekly` DISABLE KEYS */;
LOCK TABLES `mdl_stats_user_weekly` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_stats_user_weekly` ENABLE KEYS */;

--
-- Table structure for table `mdl_stats_weekly`
--

DROP TABLE IF EXISTS `mdl_stats_weekly`;
CREATE TABLE `mdl_stats_weekly` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `timeend` bigint(10) unsigned NOT NULL default '0',
  `roleid` bigint(10) unsigned NOT NULL default '0',
  `stattype` enum('enrolments','activity','logins') NOT NULL default 'activity',
  `stat1` bigint(10) unsigned NOT NULL default '0',
  `stat2` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_statweek_cou_ix` (`courseid`),
  KEY `mdl_statweek_tim_ix` (`timeend`),
  KEY `mdl_statweek_rol_ix` (`roleid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To accumulate weekly stats';

--
-- Dumping data for table `mdl_stats_weekly`
--


/*!40000 ALTER TABLE `mdl_stats_weekly` DISABLE KEYS */;
LOCK TABLES `mdl_stats_weekly` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_stats_weekly` ENABLE KEYS */;

--
-- Table structure for table `mdl_survey`
--

DROP TABLE IF EXISTS `mdl_survey`;
CREATE TABLE `mdl_survey` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `template` bigint(10) unsigned NOT NULL default '0',
  `days` mediumint(6) NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `intro` text NOT NULL,
  `questions` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_surv_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Each record is one SURVEY module with its configuration';

--
-- Dumping data for table `mdl_survey`
--


/*!40000 ALTER TABLE `mdl_survey` DISABLE KEYS */;
LOCK TABLES `mdl_survey` WRITE;
INSERT INTO `mdl_survey` VALUES (1,0,0,0,985017600,985017600,'collesaname','collesaintro','25,26,27,28,29,30,43,44'),
(2,0,0,0,985017600,985017600,'collespname','collespintro','31,32,33,34,35,36,43,44'),
(3,0,0,0,985017600,985017600,'collesapname','collesapintro','37,38,39,40,41,42,43,44'),
(4,0,0,0,985017600,985017600,'attlsname','attlsintro','65,67,68'),
(5,0,0,0,985017600,985017600,'ciqname','ciqintro','69,70,71,72,73');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_survey` ENABLE KEYS */;

--
-- Table structure for table `mdl_survey_analysis`
--

DROP TABLE IF EXISTS `mdl_survey_analysis`;
CREATE TABLE `mdl_survey_analysis` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `survey` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `notes` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_survanal_use_ix` (`userid`),
  KEY `mdl_survanal_sur_ix` (`survey`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='text about each survey submission';

--
-- Dumping data for table `mdl_survey_analysis`
--


/*!40000 ALTER TABLE `mdl_survey_analysis` DISABLE KEYS */;
LOCK TABLES `mdl_survey_analysis` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_survey_analysis` ENABLE KEYS */;

--
-- Table structure for table `mdl_survey_answers`
--

DROP TABLE IF EXISTS `mdl_survey_answers`;
CREATE TABLE `mdl_survey_answers` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `survey` bigint(10) unsigned NOT NULL default '0',
  `question` bigint(10) unsigned NOT NULL default '0',
  `time` bigint(10) unsigned NOT NULL default '0',
  `answer1` text NOT NULL,
  `answer2` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_survansw_use_ix` (`userid`),
  KEY `mdl_survansw_sur_ix` (`survey`),
  KEY `mdl_survansw_que_ix` (`question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='the answers to each questions filled by the users';

--
-- Dumping data for table `mdl_survey_answers`
--


/*!40000 ALTER TABLE `mdl_survey_answers` DISABLE KEYS */;
LOCK TABLES `mdl_survey_answers` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_survey_answers` ENABLE KEYS */;

--
-- Table structure for table `mdl_survey_questions`
--

DROP TABLE IF EXISTS `mdl_survey_questions`;
CREATE TABLE `mdl_survey_questions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `text` varchar(255) NOT NULL default '',
  `shorttext` varchar(30) NOT NULL default '',
  `multi` varchar(100) NOT NULL default '',
  `intro` varchar(50) NOT NULL default '',
  `type` smallint(3) NOT NULL default '0',
  `options` text,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='the questions conforming one survey';

--
-- Dumping data for table `mdl_survey_questions`
--


/*!40000 ALTER TABLE `mdl_survey_questions` DISABLE KEYS */;
LOCK TABLES `mdl_survey_questions` WRITE;
INSERT INTO `mdl_survey_questions` VALUES (1,'colles1','colles1short','','',1,'scaletimes5'),
(2,'colles2','colles2short','','',1,'scaletimes5'),
(3,'colles3','colles3short','','',1,'scaletimes5'),
(4,'colles4','colles4short','','',1,'scaletimes5'),
(5,'colles5','colles5short','','',1,'scaletimes5'),
(6,'colles6','colles6short','','',1,'scaletimes5'),
(7,'colles7','colles7short','','',1,'scaletimes5'),
(8,'colles8','colles8short','','',1,'scaletimes5'),
(9,'colles9','colles9short','','',1,'scaletimes5'),
(10,'colles10','colles10short','','',1,'scaletimes5'),
(11,'colles11','colles11short','','',1,'scaletimes5'),
(12,'colles12','colles12short','','',1,'scaletimes5'),
(13,'colles13','colles13short','','',1,'scaletimes5'),
(14,'colles14','colles14short','','',1,'scaletimes5'),
(15,'colles15','colles15short','','',1,'scaletimes5'),
(16,'colles16','colles16short','','',1,'scaletimes5'),
(17,'colles17','colles17short','','',1,'scaletimes5'),
(18,'colles18','colles18short','','',1,'scaletimes5'),
(19,'colles19','colles19short','','',1,'scaletimes5'),
(20,'colles20','colles20short','','',1,'scaletimes5'),
(21,'colles21','colles21short','','',1,'scaletimes5'),
(22,'colles22','colles22short','','',1,'scaletimes5'),
(23,'colles23','colles23short','','',1,'scaletimes5'),
(24,'colles24','colles24short','','',1,'scaletimes5'),
(25,'collesm1','collesm1short','1,2,3,4','collesmintro',1,'scaletimes5'),
(26,'collesm2','collesm2short','5,6,7,8','collesmintro',1,'scaletimes5'),
(27,'collesm3','collesm3short','9,10,11,12','collesmintro',1,'scaletimes5'),
(28,'collesm4','collesm4short','13,14,15,16','collesmintro',1,'scaletimes5'),
(29,'collesm5','collesm5short','17,18,19,20','collesmintro',1,'scaletimes5'),
(30,'collesm6','collesm6short','21,22,23,24','collesmintro',1,'scaletimes5'),
(31,'collesm1','collesm1short','1,2,3,4','collesmintro',2,'scaletimes5'),
(32,'collesm2','collesm2short','5,6,7,8','collesmintro',2,'scaletimes5'),
(33,'collesm3','collesm3short','9,10,11,12','collesmintro',2,'scaletimes5'),
(34,'collesm4','collesm4short','13,14,15,16','collesmintro',2,'scaletimes5'),
(35,'collesm5','collesm5short','17,18,19,20','collesmintro',2,'scaletimes5'),
(36,'collesm6','collesm6short','21,22,23,24','collesmintro',2,'scaletimes5'),
(37,'collesm1','collesm1short','1,2,3,4','collesmintro',3,'scaletimes5'),
(38,'collesm2','collesm2short','5,6,7,8','collesmintro',3,'scaletimes5'),
(39,'collesm3','collesm3short','9,10,11,12','collesmintro',3,'scaletimes5'),
(40,'collesm4','collesm4short','13,14,15,16','collesmintro',3,'scaletimes5'),
(41,'collesm5','collesm5short','17,18,19,20','collesmintro',3,'scaletimes5'),
(42,'collesm6','collesm6short','21,22,23,24','collesmintro',3,'scaletimes5'),
(43,'howlong','','','',1,'howlongoptions'),
(44,'othercomments','','','',0,NULL),
(45,'attls1','attls1short','','',1,'scaleagree5'),
(46,'attls2','attls2short','','',1,'scaleagree5'),
(47,'attls3','attls3short','','',1,'scaleagree5'),
(48,'attls4','attls4short','','',1,'scaleagree5'),
(49,'attls5','attls5short','','',1,'scaleagree5'),
(50,'attls6','attls6short','','',1,'scaleagree5'),
(51,'attls7','attls7short','','',1,'scaleagree5'),
(52,'attls8','attls8short','','',1,'scaleagree5'),
(53,'attls9','attls9short','','',1,'scaleagree5'),
(54,'attls10','attls10short','','',1,'scaleagree5'),
(55,'attls11','attls11short','','',1,'scaleagree5'),
(56,'attls12','attls12short','','',1,'scaleagree5'),
(57,'attls13','attls13short','','',1,'scaleagree5'),
(58,'attls14','attls14short','','',1,'scaleagree5'),
(59,'attls15','attls15short','','',1,'scaleagree5'),
(60,'attls16','attls16short','','',1,'scaleagree5'),
(61,'attls17','attls17short','','',1,'scaleagree5'),
(62,'attls18','attls18short','','',1,'scaleagree5'),
(63,'attls19','attls19short','','',1,'scaleagree5'),
(64,'attls20','attls20short','','',1,'scaleagree5'),
(65,'attlsm1','attlsm1','45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64','attlsmintro',1,'scaleagree5'),
(66,'-','-','-','-',0,'-'),
(67,'attlsm2','attlsm2','63,62,59,57,55,49,52,50,48,47','attlsmintro',-1,'scaleagree5'),
(68,'attlsm3','attlsm3','46,54,45,51,60,53,56,58,61,64','attlsmintro',-1,'scaleagree5'),
(69,'ciq1','ciq1short','','',0,NULL),
(70,'ciq2','ciq2short','','',0,NULL),
(71,'ciq3','ciq3short','','',0,NULL),
(72,'ciq4','ciq4short','','',0,NULL),
(73,'ciq5','ciq5short','','',0,NULL);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_survey_questions` ENABLE KEYS */;

--
-- Table structure for table `mdl_tags`
--

DROP TABLE IF EXISTS `mdl_tags`;
CREATE TABLE `mdl_tags` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `type` varchar(255) NOT NULL default 'official',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `text` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_tags_typuse_ix` (`type`,`userid`),
  KEY `mdl_tags_tex_ix` (`text`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='tags structure for moodle';

--
-- Dumping data for table `mdl_tags`
--


/*!40000 ALTER TABLE `mdl_tags` DISABLE KEYS */;
LOCK TABLES `mdl_tags` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_tags` ENABLE KEYS */;

--
-- Table structure for table `mdl_timezone`
--

DROP TABLE IF EXISTS `mdl_timezone`;
CREATE TABLE `mdl_timezone` (
  `id` bigint(10) NOT NULL auto_increment,
  `name` varchar(100) NOT NULL default '',
  `year` bigint(11) NOT NULL default '0',
  `tzrule` varchar(20) NOT NULL default '',
  `gmtoff` bigint(11) NOT NULL default '0',
  `dstoff` bigint(11) NOT NULL default '0',
  `dst_month` tinyint(2) NOT NULL default '0',
  `dst_startday` smallint(3) NOT NULL default '0',
  `dst_weekday` smallint(3) NOT NULL default '0',
  `dst_skipweeks` smallint(3) NOT NULL default '0',
  `dst_time` varchar(5) NOT NULL default '00:00',
  `std_month` tinyint(2) NOT NULL default '0',
  `std_startday` smallint(3) NOT NULL default '0',
  `std_weekday` smallint(3) NOT NULL default '0',
  `std_skipweeks` smallint(3) NOT NULL default '0',
  `std_time` varchar(5) NOT NULL default '00:00',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Rules for calculating local wall clock time for users';

--
-- Dumping data for table `mdl_timezone`
--


/*!40000 ALTER TABLE `mdl_timezone` DISABLE KEYS */;
LOCK TABLES `mdl_timezone` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_timezone` ENABLE KEYS */;

--
-- Table structure for table `mdl_user`
--

DROP TABLE IF EXISTS `mdl_user`;
CREATE TABLE `mdl_user` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `auth` varchar(20) NOT NULL default 'manual',
  `confirmed` tinyint(1) NOT NULL default '0',
  `policyagreed` tinyint(1) NOT NULL default '0',
  `deleted` tinyint(1) NOT NULL default '0',
  `username` varchar(100) NOT NULL default '',
  `password` varchar(32) NOT NULL default '',
  `idnumber` varchar(64) NOT NULL default '',
  `firstname` varchar(100) NOT NULL default '',
  `lastname` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `emailstop` tinyint(1) unsigned NOT NULL default '0',
  `icq` varchar(15) NOT NULL default '',
  `skype` varchar(50) NOT NULL default '',
  `yahoo` varchar(50) NOT NULL default '',
  `aim` varchar(50) NOT NULL default '',
  `msn` varchar(50) NOT NULL default '',
  `phone1` varchar(20) NOT NULL default '',
  `phone2` varchar(20) NOT NULL default '',
  `institution` varchar(40) NOT NULL default '',
  `department` varchar(30) NOT NULL default '',
  `address` varchar(70) NOT NULL default '',
  `city` varchar(20) NOT NULL default '',
  `country` varchar(2) NOT NULL default '',
  `lang` varchar(10) NOT NULL default 'en',
  `theme` varchar(50) NOT NULL default '',
  `timezone` varchar(100) NOT NULL default '99',
  `firstaccess` bigint(10) unsigned NOT NULL default '0',
  `lastaccess` bigint(10) unsigned NOT NULL default '0',
  `lastlogin` bigint(10) unsigned NOT NULL default '0',
  `currentlogin` bigint(10) unsigned NOT NULL default '0',
  `lastip` varchar(15) NOT NULL default '',
  `secret` varchar(15) NOT NULL default '',
  `picture` tinyint(1) NOT NULL default '0',
  `url` varchar(255) NOT NULL default '',
  `description` text,
  `mailformat` tinyint(1) unsigned NOT NULL default '1',
  `maildigest` tinyint(1) unsigned NOT NULL default '0',
  `maildisplay` tinyint(2) unsigned NOT NULL default '2',
  `htmleditor` tinyint(1) unsigned NOT NULL default '1',
  `ajax` tinyint(1) unsigned NOT NULL default '1',
  `autosubscribe` tinyint(1) unsigned NOT NULL default '1',
  `trackforums` tinyint(1) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `trustbitmask` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_user_use_uix` (`username`),
  KEY `mdl_user_del_ix` (`deleted`),
  KEY `mdl_user_con_ix` (`confirmed`),
  KEY `mdl_user_fir_ix` (`firstname`),
  KEY `mdl_user_las_ix` (`lastname`),
  KEY `mdl_user_cit_ix` (`city`),
  KEY `mdl_user_cou_ix` (`country`),
  KEY `mdl_user_las2_ix` (`lastaccess`),
  KEY `mdl_user_ema_ix` (`email`),
  KEY `mdl_user_aut_ix` (`auth`),
  KEY `mdl_user_idn_ix` (`idnumber`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='One record for each person';

--
-- Dumping data for table `mdl_user`
--


/*!40000 ALTER TABLE `mdl_user` DISABLE KEYS */;
LOCK TABLES `mdl_user` WRITE;
INSERT INTO `mdl_user` VALUES (1,'manual',1,0,0,'guest','084e0343a0486ff05530df6c705c8bb4','','Guest User',' ','admin@DOMAIN',0,'','','','','','','','','','','','','admin_lang_lowercase','','99',0,0,0,0,'','',0,'','This user is a special user that allows read-only access to some courses.',1,0,2,1,1,1,0,1172451238,0),
(2,'manual',1,0,0,'admin','MD5PASSWORD','','ADMIN_FIRST_NAME','ADMIN_LAST_NAME','admin@DOMAIN',0,'','','','','','','','','','','ADMIN_CITY','ADMIN_LANG','admin_lang_lowercase','','99',0,1172454197,0,0,'192.168.0.3','',0,'','',0,0,1,1,1,1,0,1172451550,0);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_user` ENABLE KEYS */;

--
-- Table structure for table `mdl_user_info_category`
--

DROP TABLE IF EXISTS `mdl_user_info_category`;
CREATE TABLE `mdl_user_info_category` (
  `id` bigint(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `sortorder` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Customisable fields categories';

--
-- Dumping data for table `mdl_user_info_category`
--


/*!40000 ALTER TABLE `mdl_user_info_category` DISABLE KEYS */;
LOCK TABLES `mdl_user_info_category` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_user_info_category` ENABLE KEYS */;

--
-- Table structure for table `mdl_user_info_data`
--

DROP TABLE IF EXISTS `mdl_user_info_data`;
CREATE TABLE `mdl_user_info_data` (
  `id` bigint(10) NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `fieldid` bigint(10) unsigned NOT NULL default '0',
  `data` longtext NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Data for the customisable user fields';

--
-- Dumping data for table `mdl_user_info_data`
--


/*!40000 ALTER TABLE `mdl_user_info_data` DISABLE KEYS */;
LOCK TABLES `mdl_user_info_data` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_user_info_data` ENABLE KEYS */;

--
-- Table structure for table `mdl_user_info_field`
--

DROP TABLE IF EXISTS `mdl_user_info_field`;
CREATE TABLE `mdl_user_info_field` (
  `id` bigint(10) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `datatype` varchar(255) NOT NULL default '',
  `categoryid` bigint(10) unsigned NOT NULL default '0',
  `sortorder` bigint(10) unsigned NOT NULL default '0',
  `required` tinyint(2) unsigned NOT NULL default '0',
  `locked` tinyint(2) unsigned NOT NULL default '0',
  `visible` smallint(4) unsigned NOT NULL default '0',
  `defaultdata` longtext,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Customisable user profile fields';

--
-- Dumping data for table `mdl_user_info_field`
--


/*!40000 ALTER TABLE `mdl_user_info_field` DISABLE KEYS */;
LOCK TABLES `mdl_user_info_field` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_user_info_field` ENABLE KEYS */;

--
-- Table structure for table `mdl_user_lastaccess`
--

DROP TABLE IF EXISTS `mdl_user_lastaccess`;
CREATE TABLE `mdl_user_lastaccess` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `courseid` bigint(10) unsigned NOT NULL default '0',
  `timeaccess` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_userlast_usecou_uix` (`userid`,`courseid`),
  KEY `mdl_userlast_use_ix` (`userid`),
  KEY `mdl_userlast_cou_ix` (`courseid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='To keep track of course page access times, used in online pa';

--
-- Dumping data for table `mdl_user_lastaccess`
--


/*!40000 ALTER TABLE `mdl_user_lastaccess` DISABLE KEYS */;
LOCK TABLES `mdl_user_lastaccess` WRITE;
INSERT INTO `mdl_user_lastaccess` VALUES (1,2,2,1172451867);
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_user_lastaccess` ENABLE KEYS */;

--
-- Table structure for table `mdl_user_preferences`
--

DROP TABLE IF EXISTS `mdl_user_preferences`;
CREATE TABLE `mdl_user_preferences` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `userid` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(50) NOT NULL default '',
  `value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_userpref_usenam_uix` (`userid`,`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Allows modules to store arbitrary user preferences';

--
-- Dumping data for table `mdl_user_preferences`
--


/*!40000 ALTER TABLE `mdl_user_preferences` DISABLE KEYS */;
LOCK TABLES `mdl_user_preferences` WRITE;
INSERT INTO `mdl_user_preferences` VALUES (1,2,'email_bounce_count','1'),
(2,2,'email_send_count','1'),
(3,2,'admin_bookmarks','coursemgmt');
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_user_preferences` ENABLE KEYS */;

--
-- Table structure for table `mdl_wiki`
--

DROP TABLE IF EXISTS `mdl_wiki`;
CREATE TABLE `mdl_wiki` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `summary` text NOT NULL,
  `pagename` varchar(255) NOT NULL default '',
  `wtype` enum('teacher','group','student') NOT NULL default 'group',
  `ewikiprinttitle` smallint(4) unsigned NOT NULL default '1',
  `htmlmode` smallint(4) unsigned NOT NULL default '0',
  `ewikiacceptbinary` smallint(4) unsigned NOT NULL default '0',
  `disablecamelcase` smallint(4) unsigned NOT NULL default '0',
  `setpageflags` smallint(4) unsigned NOT NULL default '1',
  `strippages` smallint(4) unsigned NOT NULL default '1',
  `removepages` smallint(4) unsigned NOT NULL default '1',
  `revertchanges` smallint(4) unsigned NOT NULL default '1',
  `initialcontent` varchar(255) NOT NULL default '',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_wiki_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Main wik table';

--
-- Dumping data for table `mdl_wiki`
--


/*!40000 ALTER TABLE `mdl_wiki` DISABLE KEYS */;
LOCK TABLES `mdl_wiki` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_wiki` ENABLE KEYS */;

--
-- Table structure for table `mdl_wiki_entries`
--

DROP TABLE IF EXISTS `mdl_wiki_entries`;
CREATE TABLE `mdl_wiki_entries` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `wikiid` bigint(10) unsigned NOT NULL default '0',
  `course` bigint(10) unsigned NOT NULL default '0',
  `groupid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `pagename` varchar(255) NOT NULL default '',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_wikientr_cou_ix` (`course`),
  KEY `mdl_wikientr_gro_ix` (`groupid`),
  KEY `mdl_wikientr_use_ix` (`userid`),
  KEY `mdl_wikientr_pag_ix` (`pagename`),
  KEY `mdl_wikientr_wik_ix` (`wikiid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Holds entries for each wiki start instance';

--
-- Dumping data for table `mdl_wiki_entries`
--


/*!40000 ALTER TABLE `mdl_wiki_entries` DISABLE KEYS */;
LOCK TABLES `mdl_wiki_entries` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_wiki_entries` ENABLE KEYS */;

--
-- Table structure for table `mdl_wiki_locks`
--

DROP TABLE IF EXISTS `mdl_wiki_locks`;
CREATE TABLE `mdl_wiki_locks` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `wikiid` bigint(10) unsigned NOT NULL,
  `pagename` varchar(160) NOT NULL default '',
  `lockedby` bigint(10) unsigned NOT NULL default '0',
  `lockedsince` bigint(10) unsigned NOT NULL default '0',
  `lockedseen` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_wikilock_wikpag_uix` (`wikiid`,`pagename`),
  KEY `mdl_wikilock_loc_ix` (`lockedseen`),
  KEY `mdl_wikilock_wik_ix` (`wikiid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Stores editing locks on Wiki pages';

--
-- Dumping data for table `mdl_wiki_locks`
--


/*!40000 ALTER TABLE `mdl_wiki_locks` DISABLE KEYS */;
LOCK TABLES `mdl_wiki_locks` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_wiki_locks` ENABLE KEYS */;

--
-- Table structure for table `mdl_wiki_pages`
--

DROP TABLE IF EXISTS `mdl_wiki_pages`;
CREATE TABLE `mdl_wiki_pages` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `pagename` varchar(160) NOT NULL default '',
  `version` bigint(10) unsigned NOT NULL default '0',
  `flags` bigint(10) unsigned default '0',
  `content` mediumtext,
  `author` varchar(100) default 'ewiki',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `created` bigint(10) unsigned default '0',
  `lastmodified` bigint(10) unsigned default '0',
  `refs` mediumtext,
  `meta` mediumtext,
  `hits` bigint(10) unsigned default '0',
  `wiki` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `mdl_wikipage_pagverwik_uix` (`pagename`,`version`,`wiki`),
  KEY `mdl_wikipage_wik_ix` (`wiki`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Holds the Wiki-Pages';

--
-- Dumping data for table `mdl_wiki_pages`
--


/*!40000 ALTER TABLE `mdl_wiki_pages` DISABLE KEYS */;
LOCK TABLES `mdl_wiki_pages` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_wiki_pages` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop`
--

DROP TABLE IF EXISTS `mdl_workshop`;
CREATE TABLE `mdl_workshop` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `course` bigint(10) unsigned NOT NULL default '0',
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `wtype` smallint(3) unsigned NOT NULL default '0',
  `nelements` smallint(3) unsigned NOT NULL default '1',
  `nattachments` smallint(3) unsigned NOT NULL default '0',
  `phase` tinyint(2) unsigned NOT NULL default '0',
  `format` tinyint(2) unsigned NOT NULL default '0',
  `gradingstrategy` tinyint(2) unsigned NOT NULL default '1',
  `resubmit` tinyint(2) unsigned NOT NULL default '0',
  `agreeassessments` tinyint(2) unsigned NOT NULL default '0',
  `hidegrades` tinyint(2) unsigned NOT NULL default '0',
  `anonymous` tinyint(2) unsigned NOT NULL default '0',
  `includeself` tinyint(2) unsigned NOT NULL default '0',
  `maxbytes` bigint(10) unsigned NOT NULL default '100000',
  `submissionstart` bigint(10) unsigned NOT NULL default '0',
  `assessmentstart` bigint(10) unsigned NOT NULL default '0',
  `submissionend` bigint(10) unsigned NOT NULL default '0',
  `assessmentend` bigint(10) unsigned NOT NULL default '0',
  `releasegrades` bigint(10) unsigned NOT NULL default '0',
  `grade` smallint(3) NOT NULL default '0',
  `gradinggrade` smallint(3) NOT NULL default '0',
  `ntassessments` smallint(3) unsigned NOT NULL default '0',
  `assessmentcomps` smallint(3) unsigned NOT NULL default '2',
  `nsassessments` smallint(3) unsigned NOT NULL default '0',
  `overallocation` smallint(3) unsigned NOT NULL default '0',
  `timemodified` bigint(10) unsigned NOT NULL default '0',
  `teacherweight` smallint(3) unsigned NOT NULL default '1',
  `showleaguetable` smallint(3) unsigned NOT NULL default '0',
  `usepassword` smallint(3) unsigned NOT NULL default '0',
  `password` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `mdl_work_cou_ix` (`course`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines workshop';

--
-- Dumping data for table `mdl_workshop`
--


/*!40000 ALTER TABLE `mdl_workshop` DISABLE KEYS */;
LOCK TABLES `mdl_workshop` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop_assessments`
--

DROP TABLE IF EXISTS `mdl_workshop_assessments`;
CREATE TABLE `mdl_workshop_assessments` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `workshopid` bigint(10) unsigned NOT NULL default '0',
  `submissionid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `timegraded` bigint(10) unsigned NOT NULL default '0',
  `timeagreed` bigint(10) unsigned NOT NULL default '0',
  `grade` double NOT NULL default '0',
  `gradinggrade` smallint(3) NOT NULL default '0',
  `teachergraded` smallint(3) unsigned NOT NULL default '0',
  `mailed` smallint(3) unsigned NOT NULL default '0',
  `resubmission` smallint(3) unsigned NOT NULL default '0',
  `donotuse` smallint(3) unsigned NOT NULL default '0',
  `generalcomment` text NOT NULL,
  `teachercomment` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_workasse_use_ix` (`userid`),
  KEY `mdl_workasse_mai_ix` (`mailed`),
  KEY `mdl_workasse_wor_ix` (`workshopid`),
  KEY `mdl_workasse_sub_ix` (`submissionid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about assessments by teacher and students';

--
-- Dumping data for table `mdl_workshop_assessments`
--


/*!40000 ALTER TABLE `mdl_workshop_assessments` DISABLE KEYS */;
LOCK TABLES `mdl_workshop_assessments` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop_assessments` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop_comments`
--

DROP TABLE IF EXISTS `mdl_workshop_comments`;
CREATE TABLE `mdl_workshop_comments` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `workshopid` bigint(10) unsigned NOT NULL default '0',
  `assessmentid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `mailed` tinyint(2) unsigned NOT NULL default '0',
  `comments` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_workcomm_use_ix` (`userid`),
  KEY `mdl_workcomm_mai_ix` (`mailed`),
  KEY `mdl_workcomm_wor_ix` (`workshopid`),
  KEY `mdl_workcomm_ass_ix` (`assessmentid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Defines comments';

--
-- Dumping data for table `mdl_workshop_comments`
--


/*!40000 ALTER TABLE `mdl_workshop_comments` DISABLE KEYS */;
LOCK TABLES `mdl_workshop_comments` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop_comments` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop_elements`
--

DROP TABLE IF EXISTS `mdl_workshop_elements`;
CREATE TABLE `mdl_workshop_elements` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `workshopid` bigint(10) unsigned NOT NULL default '0',
  `elementno` smallint(3) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  `scale` smallint(3) unsigned NOT NULL default '0',
  `maxscore` smallint(3) unsigned NOT NULL default '1',
  `weight` smallint(3) unsigned NOT NULL default '11',
  `stddev` double NOT NULL default '0',
  `totalassessments` bigint(10) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_workelem_wor_ix` (`workshopid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about marking scheme of assignment';

--
-- Dumping data for table `mdl_workshop_elements`
--


/*!40000 ALTER TABLE `mdl_workshop_elements` DISABLE KEYS */;
LOCK TABLES `mdl_workshop_elements` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop_elements` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop_grades`
--

DROP TABLE IF EXISTS `mdl_workshop_grades`;
CREATE TABLE `mdl_workshop_grades` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `workshopid` bigint(10) unsigned NOT NULL default '0',
  `assessmentid` bigint(10) unsigned NOT NULL default '0',
  `elementno` bigint(10) unsigned NOT NULL default '0',
  `feedback` text NOT NULL,
  `grade` smallint(3) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_workgrad_wor_ix` (`workshopid`),
  KEY `mdl_workgrad_ass_ix` (`assessmentid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about individual grades given to each element';

--
-- Dumping data for table `mdl_workshop_grades`
--


/*!40000 ALTER TABLE `mdl_workshop_grades` DISABLE KEYS */;
LOCK TABLES `mdl_workshop_grades` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop_grades` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop_rubrics`
--

DROP TABLE IF EXISTS `mdl_workshop_rubrics`;
CREATE TABLE `mdl_workshop_rubrics` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `workshopid` bigint(10) unsigned NOT NULL default '0',
  `elementno` bigint(10) unsigned NOT NULL default '0',
  `rubricno` smallint(3) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_workrubr_wor_ix` (`workshopid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about the rubrics marking scheme';

--
-- Dumping data for table `mdl_workshop_rubrics`
--


/*!40000 ALTER TABLE `mdl_workshop_rubrics` DISABLE KEYS */;
LOCK TABLES `mdl_workshop_rubrics` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop_rubrics` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop_stockcomments`
--

DROP TABLE IF EXISTS `mdl_workshop_stockcomments`;
CREATE TABLE `mdl_workshop_stockcomments` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `workshopid` bigint(10) unsigned NOT NULL default '0',
  `elementno` bigint(10) unsigned NOT NULL default '0',
  `comments` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mdl_workstoc_wor_ix` (`workshopid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about the teacher comment bank';

--
-- Dumping data for table `mdl_workshop_stockcomments`
--


/*!40000 ALTER TABLE `mdl_workshop_stockcomments` DISABLE KEYS */;
LOCK TABLES `mdl_workshop_stockcomments` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop_stockcomments` ENABLE KEYS */;

--
-- Table structure for table `mdl_workshop_submissions`
--

DROP TABLE IF EXISTS `mdl_workshop_submissions`;
CREATE TABLE `mdl_workshop_submissions` (
  `id` bigint(10) unsigned NOT NULL auto_increment,
  `workshopid` bigint(10) unsigned NOT NULL default '0',
  `userid` bigint(10) unsigned NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `timecreated` bigint(10) unsigned NOT NULL default '0',
  `mailed` tinyint(2) unsigned NOT NULL default '0',
  `description` text NOT NULL,
  `gradinggrade` smallint(3) unsigned NOT NULL default '0',
  `finalgrade` smallint(3) unsigned NOT NULL default '0',
  `late` smallint(3) unsigned NOT NULL default '0',
  `nassessments` bigint(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `mdl_worksubm_use_ix` (`userid`),
  KEY `mdl_worksubm_mai_ix` (`mailed`),
  KEY `mdl_worksubm_wor_ix` (`workshopid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='Info about submitted work from teacher and students';

--
-- Dumping data for table `mdl_workshop_submissions`
--


/*!40000 ALTER TABLE `mdl_workshop_submissions` DISABLE KEYS */;
LOCK TABLES `mdl_workshop_submissions` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `mdl_workshop_submissions` ENABLE KEYS */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

